// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'ion-floating-menu', 'angular-md5'])
    .run(['$ionicPlatform', '$rootScope','$location', '$ionicHistory', '$ionicLoading', 'nativeHelper', 'localStorage', 'nav', 'control','$ionicViewSwitcher','$interval',
        function ($ionicPlatform, $rootScope,$location, $ionicHistory, $ionicLoading, nativeHelper, localStorage, nav, control,$ionicViewSwitcher,$interval) {

        window.currentUrl = 'http://zsfwpt.icinfo.cn'; // 生产
//        window.currentUrl = 'http://115.238.48.66:8085'; // 测试
        // window.currentUrl = 'http://192.168.5.209:8089';// 朱进兵本地
        
        var logoutAlertShow = false;

            $ionicPlatform.ready(function () {
                if (cordova.platformId === 'ios' && window.cordova && window.cordova.plugins.Keyboard) {
                    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                    // for form inputs)
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);

                    //禁止header向上移动
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    //StatusBar.styleDefault 状态栏默认样式，也就是电池信号黑色；
                    //StatusBar.styleLightContent 状态栏内容浅色，貌似就是白色，适合深色背景；
                    //StatusBar.styleBlackTranslucent 状态栏黑色半透明，电池时间都是白色的，适合深色背景；
                    //StatusBar.styleBlackOpaque 状态栏黑色不透明，还是白色的，适合深色背景；
                    //StatusBar.hide 状态栏隐藏；
                    //StatusBar.show(); //状态栏显示；
                    StatusBar.styleDefault();

                }
                //监听后台消息弹窗
                var showMsg = function (e) {
                    if ("error_017" == e.msgType) return;

                    $ionicLoading.hide();
                    control.showPopup(e.msg, 2000);
                }
                window.broadcaster.addEventListener("showMsg", showMsg);

                //登出操作
                var logoutFunc = function () {
                    $rootScope.localCertList = [];
                    localStorage.deleteItem('loginInfo');
                    PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
                    $ionicHistory.clearHistory();
                    nav.navigate('signIn');
                    logoutAlertShow = false;
                }
                //监听登出
                var logout = function () {
                    if (!logoutAlertShow) {
                        control.showAlert1("您的账号在其他设备登录，如果这不是您的操作，请即时修改您的登录密码",logoutFunc, null, null);
                    }
                }
                window.broadcaster.addEventListener("logout", logout);


                $rootScope.appid = "";
                $rootScope.secret = "";
                $rootScope.urlConfig = {};
                // 获取native基础数据配置
                var getBaseConfig = function() {
                    var returnFunc = function(baseData) {
                        $rootScope.appid = baseData.appid;
                        $rootScope.secret = baseData.secret;
                        $rootScope.zwwAppid = baseData.zwwAppid;
                        $rootScope.zwwSecret = baseData.zwwSecret;
                        $rootScope.urlConfig = {
                            "serverUrl": baseData.urlConfig.serverUrl,
                            "cloudCertUrl": baseData.urlConfig.cloudCertUrl,
                            "doDecDataUrl": baseData.urlConfig.cloudCertUrl,
                            "authCenterUrl" : baseData.urlConfig.authCenterUrl,
                            "scanUrl": baseData.urlConfig.scanUrl,
                            "OCRUrl": baseData.urlConfig.OCRUrl,
                            "CTIDAuthUrl": baseData.urlConfig.CTIDAuthUrl,
                            "msgCenterUrl": baseData.urlConfig.msgCenterUrl,
                            "TimeUrl": baseData.urlConfig.TimeUrl,
                            "frdecrUrl": baseData.urlConfig.frdecrUrl,
                            "stampUrl": baseData.urlConfig.stampUrl
                        }

                        // 判断测试/正式环境
                        if (-1 != baseData.urlConfig.serverUrl.search("test.icinfo.cn")
                        || -1 != baseData.urlConfig.serverUrl.search("115.238.48.66")
                        || -1 != baseData.urlConfig.serverUrl.search("192.168.5.101")
                        ) {
                            $rootScope.isDebug = true;
                            var vConsole = new VConsole();
                        } else {
                            $rootScope.isDebug = false;
                        }

                    }

                    nativeHelper.getBaseConfig({
                        data:[],
                        success: returnFunc
                    });
                }
                getBaseConfig();



                var loaded = function () {
                    try {
                        var loginInfo = localStorage.getObject('loginInfo');
                        if (JSON.stringify(loginInfo) == '{}') {
                            //nav.navigate('certManage');
                            nav.navigate('signIn');
                            //nav.navigate('entrustTemplate');
                        }
                        else {
                            if (parseInt(new Date().getTime() - loginInfo.firstLoginDate) <= 86400000 * 90) {

//                            if(device.version!='5.1.1')
                                PushAgent.setAlias(function(){},loginInfo.userId,'userUniqueId');

                                nav.navigate('home');
                            }
                            else {
                                nav.navigate('signIn');
                            }
                        }
                    } catch (e) {

                    }
                };

                // getConfigInfo();
                //loaded();

                var checkConnection = function () {
                    var networkState = navigator.connection.type;

                    if (networkState == Connection.NONE) {
                        nav.navigate('signIn');
                        return;
                    }
                    else {
                        loaded();
                    }
                };

                checkConnection();

            });

            if (cordova.platformId === 'android') {

                //控制选择控件物理返回不消失的问题
                $ionicPlatform.registerBackButtonAction(function (e) {
//                console.log("path :"+$location.path());
                    if (control.androidPicker($location.path())) {
                         $.closePicker()
                        }
                         if ($location.path() == '/applyAuthorizeComplete' || $location.path() == '/authorizationRecord') {
                                       if ($rootScope.backButtonGoBack) {
                                              $rootScope.backButtonGoBack = false;
                                                $ionicHistory.goBack();
                                                $ionicViewSwitcher.nextDirection("back");
                                            } else {

                                    setTimeout(function () {
                                        $rootScope.backButtonGoBack = true;
                                    }, 500);
                                            };
                                        }
                     //android物理返回退回home
                    if (control.androidPlatFormGoHome($location.path())) {
                        var timeout = setTimeout(function () {
                            control.showLoading();
                            if (angular.isDefined($rootScope.stop)) {
                                $interval.cancel($rootScope.stop);
                                $rootScope.stop = undefined;
                            }
                            nav.go('home');
                            $ionicHistory.clearHistory();
                            $ionicViewSwitcher.nextDirection("back");
//                            $ionicHistory.clearCache();
                            clearTimeout(timeout)
                            control.hideLoading();
                        }, 50);
                    }

                    //判断处于哪个页面时双击退出

                    else if (control.androidPlatFormExit($location.path())) {

                        if ($rootScope.backButtonPressedOnceToExit) {
                            $ionicHistory.clearHistory();
                            $ionicHistory.clearCache();
                            ionic.Platform.exitApp();

                        } else {
                            $rootScope.backButtonPressedOnceToExit = true;
                            control.showPopup('再按一次退出E照通', 1000);
                            setTimeout(function () {
                                $rootScope.backButtonPressedOnceToExit = false;
                            }, 2000);
                        };
                    }
                    else if ($ionicHistory.backView()) {
                        $ionicHistory.goBack();
                    }
//                    else if ($rootScope.backButtonPressedOnceToExit) {
//                        ionic.Platform.exitApp();
//                    } else {
//                        $rootScope.backButtonPressedOnceToExit = true;
//                        control.showPopup('再按一次退出E照通', 1000);
//                        setTimeout(function () {
//                            $rootScope.backButtonPressedOnceToExit = false;
//                        }, 2000);
//                    }
                    e.preventDefault();
                    return false;
                }, 101);
            }
        }])

    .config(['$stateProvider', '$urlRouterProvider', '$locationProvider', '$ionicConfigProvider',function ($stateProvider, $urlRouterProvider, $locationProvider, $ionicConfigProvider) {
        $stateProvider
        //登录
           .state('signIn', {
               url: '/signIn',
               cache: 'false',
               templateUrl: 'html/account/signIn.html',
               controller: 'signIn'
           })

           //注册
           .state('signUp', {
               url: '/signUp',
               cache: 'false',
               templateUrl: 'html/account/signUp.html',
               controller: 'signUp'
           })

           //忘记密码
           .state('retrievePassword', {
               url: '/retrievePassword',
               cache: 'false',
               templateUrl: 'html/account/retrievePassword.html',
               controller: 'retrievePassword'
           })

           //首页
           .state('home', {
               url: '/home',
               cache: 'false',
               templateUrl: 'html/home/home.html',
               controller: 'home',
               params:{
               pagePath:''
               }
           })

           //我的证书
           .state('certManage', {
               url: '/certManage',
               cache: 'false',
               templateUrl: 'html/home/certManage.html',
               controller: 'certManage'
           })

           //业务管理
           .state('businessManage', {
               url: '/businessManage',
               cache: 'false',
               templateUrl: 'html/home/businessManage.html',
               controller: 'businessManage',
               params:{
                businessManageSearchKey:null
               }
           })

           //用户
           .state('account', {
               url: '/account',
               cache: 'false',
               templateUrl: 'html/account/account.html',
               controller: 'account'
           })

           // 常见问题
           .state('commonProblem', {
               url: '/commonProblem',
               cache: 'false',
               templateUrl: 'html/account/commonProblem.html',
               controller: 'account'
           })

           // 使用帮助
           .state('usingHelp', {
               url: '/usingHelp',
               cache: 'false',
               templateUrl: 'html/account/usingHelp.html',
               controller: 'account'
           })

           //扫一扫证书列表
           .state('showLocalCertList', {
               url: '/showLocalCertList',
               cache: 'false',
               templateUrl: 'html/home/showLocalCertList.html',
               controller: 'showLocalCertList'
           })

           //下载证书
           .state('downloadCert', {
               url: '/downloadCert',
               cache: 'false',
               templateUrl: 'html/downloadCert/downloadCert.html',
               controller: 'downloadCert',
               params:{
               downloadCertInfo:null
               }
           })
             //下载证书成功
           .state('downloadCertSuccess', {
               url: '/downloadCertSuccess',
               cache: 'false',
               templateUrl: 'html/downloadCert/downloadCertSuccess.html',
               controller: 'downloadCertSuccess',
                 params: {
                                  downloadSuccessInfo: null
                              }
           })
           //--添加管理员
            .state('addAdmin', {
                url: '/addAdmin',
                cache: 'false',
                templateUrl: 'html/downloadCert/addAdmin.html',
                controller: 'addAdmin',
                params: {
                         certEntInfo: null
                               }
            })
           //变更、延期下载证书
           .state('delayOrChangeDwnCert', {
               url: '/delayOrChangeDwnCert',
               cache: 'false',
               templateUrl: 'html/downloadCert/delayOrChangeDwnCert.html',
               controller: 'delayOrChangeDwnCert',
               params: {
                lastPage: null,
                entName: null,
                uniscid: null,
                orderNo: null,
                corpid: null,
                type: null,
                certId: null,
                containerName: null
                }
           })
           //主体查询
           .state('subjectQuery', {
               url: '/subjectQuery',
               cache: 'false',
               templateUrl: 'html/home/subjectQuery.html',
               controller: 'subjectQuery'
           })

           //证书补办(证书新领)
           .state('reissueOrGetNewCert', {
               url: '/reissueOrGetNewCert',
               cache: 'false',
               templateUrl: 'html/home/reissueOrGetNewCert.html',
               controller: 'reissueOrGetNewCert'

           })

           //证书新领/补办（办理须知）
           .state('certApplyNotice', {
               url: '/certApplyNotice',
               templateUrl: 'html/home/certApplyNotice.html',
               controller: 'certApplyNotice'

           })

           //证书补办/新领（经办人信息）
           .state('certAgentInfo', {
               url: '/certAgentInfo',
               cache: 'false',
               templateUrl: 'html/home/certAgentInfo.html',
               controller: 'certAgentInfo'

           })

           //证书补办/新领（办理材料）
           .state('certExamineMaterial', {
               url: '/certExamineMaterial',
               cache: 'false',
               templateUrl: 'html/home/certExamineMaterial.html',
               controller: 'certExamineMaterial'

           })

           //委托模板
           .state('entrustTemplate', {
               url: '/entrustTemplate',
               templateUrl: 'html/home/entrustTemplate.html',
               controller: 'certApplyNotice'
           })

           //协议
           .state('eztAgreement', {
               url: '/eztAgreement',
               cache: 'false',
               templateUrl: 'html/home/eztAgreement.html',
               controller: 'eztAgreement'
           })

           //授权记录-提升用户等级
           .state('authenticationConfirm', {
                url: '/authenticationConfirm',
                templateUrl: 'html/other/authenticationConfirm.html',
                controller: 'authenticationConfirm',
                params:{
                }
            })

           //更新证件照片
           .state('updateCertificatePic', {
               url: '/updateCertificatePic',
               cache: 'false',
               templateUrl: 'html/home/updateCertificatePic.html',
               controller: 'updateCertificatePic'
           })

           //修改密码
           .state('modifyPassword', {
               url: '/modifyPassword',
               cache: 'false',
               templateUrl: 'html/account/modifyPassword.html',
               controller: 'modifyPassword'
           })

           //证书延期
           .state('certDelay', {
               url: '/certDelay',
               cache: 'false',
               templateUrl: 'html/home/certDelay.html',
               controller: 'certDelay'
           })

           //证书变更
           .state('certChange', {
               url: '/certChange',
               cache: 'false',
               templateUrl: 'html/home/certChange.html',
               controller: 'certChange'
           })

           //新领证书新流程
           .state('userNotice', {
               url: '/userNotice',
               cache: 'false',
               templateUrl: 'html/home/autoApply/userNotice.html',
               controller: 'userNotice'
           })

           //拍摄规则
           .state('photoRules', {
               url: '/photoRules',
               cache: 'false',
               templateUrl: 'html/home/autoApply/photoRules.html',
               controller: 'photoRules'
           })

           //上传营业执照
           .state('checkBusinessLicense', {
               url: '/checkBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/autoApply/checkBusinessLicense.html',
               controller: 'checkBusinessLicense'
           })


           //上传营业执照-补全资料
           .state('uploadBusinessLicense', {
                url: '/uploadBusinessLicense',
                cache: 'false',
                templateUrl: 'html/home/autoApply/uploadBusinessLicense.html',
                controller: 'uploadBusinessLicense',
                params : {
                    from: null
                }
            })

            //上传身份证正反面-补全资料
           .state('uploadIdentityCard', {
                url: '/uploadIdentityCard',
                cache: 'false',
                templateUrl: 'html/home/autoApply/uploadIdentityCard.html',
                controller: 'uploadIdentityCard'
            })

            //上传人脸图片
           .state('uploadAuthPic', {
                url: '/uploadAuthPic',
                cache: 'false',
                templateUrl: 'html/home/autoApply/uploadAuthPic.html',
                controller: 'uploadAuthPic'
            })

           // 电子营业执照
           .state('eleBusinessLicense', {
               url: '/eleBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/eleBusinessLicense.html',
               controller: 'eleBusinessLicense'
           })

           // 电子营业执照申领信息
           .state('businessLicApplyInfo', {
               url: '/businessLicApplyInfo',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/businessLicApplyInfo.html',
               controller: 'businessLicApplyInfo'
           })
           //下载电子营业执照
           .state('downloadEleBusinessLic', {
               url: '/downloadEleBusinessLic',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/downloadEleBusinessLic.html',
               controller: 'downloadEleBusinessLic',
               params: {
                   applyInfo: null
               }
           })
           // 营业执照
           .state('viewBusinessLicense', {
               url: '/viewBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/viewBusinessLicense.html',
               controller: 'viewBusinessLicense',
           })
           // 使用/出示营业执照
           .state('useBusinessLicense', {
               url: '/useBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/useBusinessLicense.html',
               controller: 'useBusinessLicense',
               params: {
                   imgBase64: null
               }
           })
           //证照识别
           .state('businessLicDiscern', {
               url: '/businessLicDiscern',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/businessLicDiscern.html',
               controller: 'businessLicDiscern'
           })
           //上传授权书
           .state('checkAuthorization', {
               url: '/checkAuthorization',
               cache: 'false',
               templateUrl: 'html/home/autoApply/checkAuthorization.html',
               controller: 'checkAuthorization'
           })

           //上传身份证
           .state('checkIdentityCard', {
               url: '/checkIdentityCard',
               cache: 'false',
               templateUrl: 'html/home/autoApply/checkIdentityCard.html',
               controller: 'checkIdentityCard'
           })

           //业务完成
           .state('businessCompleted', {
               url: '/businessCompleted',
               cache: 'false',
               templateUrl: 'html/home/autoApply/businessCompleted.html',
               controller: 'businessCompleted',
               params:{
                orderNo:null
               }
           })

           //OCR通道用户协议
           .state('agreement', {
               url: '/agreement',
               cache: 'false',
               templateUrl: 'html/home/autoApply/agreement.html',
               controller: 'agreement'
           })
           //付款信息查询接口
           .state('orderDetails', {
               url: '/orderDetails',
               cache: 'false',
               templateUrl: 'html/aliPay/orderDetails.html',
               controller: 'orderDetails',
               params: {
                   orderInfo: null
               }
           }).state('paymentSuccess', {
               url: '/paymentSuccess',
               cache: 'false',
               templateUrl: 'html/aliPay/paymentSuccess.html',
               controller: 'paymentSuccess',
               params: {
                   orderNo: null
               }
           })
           //年费付款信息查询接口
           .state('annualOrderDetails', {
               url: '/annualOrderDetails',
               cache: 'false',
               templateUrl: 'html/annualFeePay/annualOrderDetails.html',
               controller: 'annualOrderDetails',
               params: {
                   orderInfo: null
               }
           }).state('annualPaymentSuccess', {
               url: '/annualPaymentSuccess',
               cache: 'false',
               templateUrl: 'html/annualFeePay/annualPaymentSuccess.html',
               controller: 'annualPaymentSuccess'
           })

           //----新领证书付费人工审核发票路由 start----
           .state('payCertApplyInvoice', {
               url: '/payCertApplyInvoice',
               cache: 'false',
               templateUrl: 'html/home/payApply/payCertApplyInvoice.html',
               controller: 'payCertApplyInvoice'
           })

           //----新领证书付费人工审核路由 end----
           .state('autoApplyInvoice', {
               url: '/autoApplyInvoice',
               cache: 'false',
               templateUrl: 'html/home/autoApply/autoApplyInvoice.html',
               controller: 'autoApplyInvoice'
           })
           //----证书年费流程 start-----
           .state('confirmPayInfo', {
               url: '/confirmPayInfo',
               cache: 'false',
               templateUrl: 'html/annualFeePay/confirmPayInfo.html',
               controller: 'confirmPayInfo'
           }).state('annualFeeInvoice', {
               url: '/annualFeeInvoice',
               cache: 'false',
               templateUrl: 'html/annualFeePay/annualFeeInvoice.html',
               controller: 'annualFeeInvoice'
           })
           //-----------授权中心-------------
           //------身份信息核对-------
           .state('authorityCenter', {
               url: '/authorityCenter',
               cache: 'false',
               templateUrl: 'html/home/authority/authorityCenter.html',
               controller: 'authorityCenter'
           })
               //授权记录
               .state('authorizationRecord', {
               url: '/authorizationRecord',
               cache: 'false',
               templateUrl: 'html/authorizationRecord/authorizationRecord.html',
               controller: 'authorizationRecord'
           })
              //授权记录详情
               .state('authorizationDetails', {
               url: '/authorizationDetails',
               cache: 'false',
               templateUrl: 'html/authorizationRecord/authorizationDetails.html',
               controller: 'authorizationDetails',
               params:{
                    authorizationDetail:null
               }
               })
                 //授权审批
               .state('authenticationApproval', {
               url: '/authenticationApproval',
               templateUrl: 'html/authorizationRecord/authenticationApproval.html',
               controller: 'authenticationApproval',
               cache: 'false',
               params:{
                    authorizationDetail:null
               }

           })
                 //授权签名
               .state('signatureAuthorization', {
               url: '/signatureAuthorization',
               templateUrl: 'html/authorizationRecord/signatureAuthorization.html',
               controller: 'signatureAuthorization',
               cache:'false',
               params:{
                    authorizationDetail:null
               }

           })
                 //授权记录-提升用户等级认证信息
               .state('authenticationInfo', {
               url: '/authenticationInfo',
               templateUrl: 'html/authorizationRecord/authenticationInfo.html',
               controller: 'authenticationInfo',
               cache:'false',
               params:{
//                    authorizationDetail:null
               }
           })
           //授权记录-提升用户等级
           .state('authorizationFace', {
               url: '/authorizationFace',
               templateUrl: 'html/authorizationRecord/authorizationFace.html',
               controller: 'authorizationFace',
               params:{
//                    authorizationDetail:null
               }

           })


           //-------------------授权申领-------------
           //------------------申领人身份信息--------
           .state('authorizedPerson', {
               url: '/authorizedPerson',
               cache: 'false',
               templateUrl: 'html/home/authorityApply/authorizedPerson.html',
               controller: 'authorizedPerson',

           }).state('authorityConfirm', {
               url: '/authorityConfirm',
               cache: 'false',
               templateUrl: 'html/home/authorityApply/authorityConfirm.html',
               controller: 'authorityConfirm',
               params: {
                   cardId: null,
                   cardName: null
               }
           })
           //授权申领完成
           .state('authorizedApplyComplete', {
               url: '/authorizedApplyComplete',
               cache: 'false',
               templateUrl: 'html/home/authorityApply/authorizedApplyComplete.html',
               controller: 'businessCompleted',
           })

            //授权领证--搜索企业
            .state('applyCertSearch', {
                url: '/applyCertSearch',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/applyCertSearch.html',
                controller: 'applyCertSearch',
            })
            //授权领证--可领证书
            .state('ableApplyCertInfo', {
                url: '/ableApplyCertInfo',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/ableApplyCertInfo.html',
                controller: 'ableApplyCertInfo',
                //               params: {searchContent:null}
            })
            //授权领证--确认经办人信息
            .state('claimantInfo', {
                url: '/claimantInfo',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/claimantInfo.html',
                controller: 'claimantInfo',

            })
            //授权领证--经办人信息人脸认证结果
//            .state('authenticationResults', {
//                url: '/authenticationResults',
//                cache: 'false',
//                templateUrl: 'html/home/authorizedApplyCert/authenticationResults.html',
//                controller: 'authenticationResults',
//                //               params: {searchContent:null}
//            })
            //授权领证--确认授权证书
            .state('confirmAuthorizeInfo', {
                url: '/confirmAuthorizeInfo',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/confirmAuthorizeInfo.html',
                controller: 'confirmAuthorizeInfo',
                //               params: {searchContent:null}
            })
            //授权领证--确认授权证书发票
            .state('confirmCertInvoice', {
                url: '/confirmCertInvoice',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/confirmCertInvoice.html',
                controller: 'confirmCertInvoice',
                               params: {netOrderInfoWithInvoice:null}
            })
            //授权领证--确认授权证书付费订单信息
            .state('orderInfoConfirm', {
                url: '/orderInfoConfirm',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/orderInfoConfirm.html',
                controller: 'orderInfoConfirm',
                params: {
                    orderInfo: null
                }
            })
            //授权领证--申请授权
            .state('applyAuthorize', {
                url: '/applyAuthorize',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/applyAuthorize.html',
                controller: 'applyAuthorize',
                params: {params:null}
            })

            //授权领证--申领成功
            .state('applyAuthorizeComplete', {
                url: '/applyAuthorizeComplete',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/applyAuthorizeComplete.html',
                controller: 'applyAuthorizeComplete',
                params: {
                         linkContext: null
                               }
            })
            //授权领证--选择经办人
            .state('selectHandler', {
                url: '/selectHandler',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/selectHandler.html',
                controller: 'selectHandler',
//                params: {
//                         link: null
//                               }
            })   //授权领证--确认授权经办人
            .state('approvalInfo', {
                url: '/approvalInfo',
                cache: 'true',
                templateUrl: 'html/home/authorizedApplyCert/approvalInfo.html',
                controller: 'selectHandler',
//                params: {
//                         link: null
//                               }
            })
               //授权领证--法定代表人
            .state('legalRepresentative', {
                url: '/legalRepresentative',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/legalRepresentative.html',
                controller: 'legalRepresentative',
//                params: {
//                         link: null
//                               }
            })
            //授权领证--新增经办人
            .state('addNewHandler', {
                url: '/addNewHandler',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/addNewHandler.html',
                controller: 'addNewHandler',
//                params: {
//                         link: null
//                               }
            })

        //----消息中心---

            //消息中心--消息列表
            .state('messageCenter', {
                url: '/messageCenter',
                cache: 'false',
                templateUrl: 'html/notificationCenter/messageCenter.html',
                controller: 'messageCenter',

            })
            //消息中心--消息详情
            .state('messageDetails', {
                url: '/messageDetails',
                cache: 'false',
                templateUrl: 'html/notificationCenter/messageDetails.html',
                controller: 'messageDetails',
                 params: {
                                         msgDetail: null
                                               }
            })
             //完成业务单-邮寄说明
            .state('postIntroduction', {
                url: '/postIntroduction',
                cache: 'false',
                templateUrl: 'html/home/autoApply/postIntroduction.html',
                controller: 'businessCompleted',
                 params: {
                        orderNo: null
                     }
            })
               //扫一扫-提示页面
            .state('scanPrompt', {
                url: '/scanPrompt',
                cache: 'false',
                templateUrl: 'html/home/scanPrompt.html',
                controller: 'scanPrompt',
                 params: {
//                        orderNo: null
                 }
            })
        
        //完成签章
       .state('signCompleted', {
           url: '/signCompleted',
           cache: 'false',
           templateUrl: 'html/home/signCompleted.html',
           controller: 'signCompleted',
            params: {
                cert:null
            }
       })
          //签名会话
       .state('signConversation', {
           url: '/signConversation',
           cache: 'false',
           templateUrl: 'html/home/signConversation.html',
           controller: 'signConversation',
            params: {
                cert:null
            }
       })

        //----证书年费流程 end-------


        // if none of the above states are matched, use this as the fallback
        //$urlRouterProvider.otherwise('/home');

        $ionicConfigProvider.platform.ios.tabs.style('standard');

        $ionicConfigProvider.platform.ios.tabs.position('bottom');

        $ionicConfigProvider.platform.android.tabs.style('standard');

        $ionicConfigProvider.platform.android.tabs.position('standard');

        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');

        $ionicConfigProvider.platform.android.navBar.alignTitle('left');

        $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');

        $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

        $ionicConfigProvider.platform.ios.views.transition('ios');

        $ionicConfigProvider.platform.android.views.transition('android');

        $ionicConfigProvider.views.swipeBackEnabled(false);//禁止侧滑后退事件

        //$ionicConfigProvider.views.transition('no');
    }]);


