(function () {
    "use strict"
    angular.module('starter')
        .controller('signIn', ['$rootScope', '$scope', 'nav', 'validate', 'localStorage', 'control', 'nativeHelper', function ($rootScope, $scope, nav, validate, localStorage, control, nativeHelper) {
//        $rootScope.user = { name: '18616916715', password: '111111' };
            $rootScope.user = {name: '', password: ''};
            $scope.isPwd = true;

            var usageConfirm = function() {
                var confirm = function () {
                    // $scope.isAgreeApplyAgreement = true;
                    localStorage.set('isfirstInstall', true);
                };
                var cancel = function () {
                    $rootScope.rejectPolicy = true;
                    nav.navigate('home');
                };

                if ($rootScope.rejectPolicy) {
                    control.showConfirm7(confirm, cancel, '同意', '不同意', '', 'html/other/agreementConfirm.html');
                } else {
                    control.showConfirm7(confirm, cancel, '同意', '不同意', '', 'html/other/usageConfirm.html');
                }
            }
            
            var firstInstall=localStorage.get('isfirstInstall');
            if(!firstInstall){
                usageConfirm();
            }

            $scope.signIn = function () {
                $rootScope.buttonStatus = true;
                if (!validate.nullOrEmpty($rootScope.user.name) && validate.loginPassword($rootScope.user.password)) {

                var logOff = localStorage.getObject('logOff');
                if(!$scope.isAgreeApplyAgreement){
                    control.showPopup("请先阅读协议并同意", 2000);
                   return
                }
                    var params = [$rootScope.user.name, $rootScope.user.password];
                    control.showLoading();
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        
                        if ('1' == logOff && '18324450217' == $rootScope.user.name) {
                            control.showPopup('此账号已被注销', 2000);
                            return;
                        }

                        switch (result.success) {
                            case true:
                                $scope.$apply(function () {
                                    $rootScope.loginInfo = {
                                        accountId: result.value.accountId,
                                        mobile: result.value.mobile,
                                        userId: result.value.userUniqueId,

                                        idCard:result.value.idCard,
                                        userName:result.value.userName,
                                        realNameGrade:result.value.realNameGrade,
//
                                        //base64格式（实人认证使用）
                                        firstLoginDate: new Date().getTime()
                                    };

                                    localStorage.setObject('loginInfo', $rootScope.loginInfo);

//                                    PushAgent.addAlias(function(){},result.value.userUniqueId,'userUniqueId')
                                    PushAgent.setAlias(function(){},result.value.userUniqueId,'userUniqueId')

                                    nav.navigate('home');
                                });

                                break;
                            case false:
                                control.hideLoading();
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    nativeHelper.signIn({data: params, success: successFunc, fail: failFunc});
                }
                else {
                    control.showPopup('请输入正确的账号和密码', 2000);
                    return;
                }
            };

            $scope.doeyeclick = function () {
                $scope.isPwd = !$scope.isPwd;
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };

            $rootScope.agreementClick = function(type) {
                if (type === 'appagreement') {
                    var url = window.currentUrl + '/app/api/appagreement';
                } else {
                    var url = window.currentUrl + '/app/api/appprivacy';
                }

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }

            $scope.agreement = function(type) {
                if (type === 'appagreement') {
                    var url = window.currentUrl + '/app/api/appagreement';
                } else {
                    var url = window.currentUrl + '/app/api/appprivacy';
                }

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
            $scope.isBlur = true;

            $scope.getBlur = function() {
                $scope.isBlur = true;
            }
            $scope.getFocus = function() {
                $scope.isBlur = false;
            }
            var pwdHidden = true;
                $scope.pwdIconClick = function() {
                if (pwdHidden) {
                      let input = document.getElementById("login-pwdinput");
                      input.setAttribute("type", "text");
                      let icon = document.getElementById("login-pwdicon");
                      icon.setAttribute("class", "pwd-show-icon");
                } else {
                      let input = document.getElementById("login-pwdinput");
                      input.setAttribute("type", "password");
                      let icon = document.getElementById("login-pwdicon");
                      icon.setAttribute("class", "pwd-hide-icon");
                }
                pwdHidden = !pwdHidden;
            }

            $scope.isAgreeApplyAgreement=false;
            $scope.agree=function(){
                $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
            }
        }]);
})();
