﻿(function () {
    "use strict"

    angular.module('starter')
    .controller('signUp', ['$rootScope', '$scope', '$ionicLoading', 'nav', 'nativeHelper', 'control', 'validate', '$filter', function ($rootScope, $scope, $ionicLoading, nav, nativeHelper, control, validate, $filter) {
        $scope.signUpInfo = {
            tel: '',
            authCode: '',
            password: '',
            verifyPassword: ''
        };

        $scope.signUp = function () {
            if (validate.nullOrEmpty($scope.signUpInfo.tel) || validate.nullOrEmpty($scope.signUpInfo.authCode)) {
                control.showPopup('请输入手机号、验证码', 3000);
                return;
            }

            if (validate.loginPasswordReg($scope.signUpInfo.verifyPassword)) {
            // if (validate.loginPassword($scope.signUpInfo.verifyPassword)) {
                if ($scope.signUpInfo.password === $scope.signUpInfo.verifyPassword) {
                    control.showLoading();
                    var params = [$scope.signUpInfo.tel, $scope.signUpInfo.password, $scope.signUpInfo.authCode, '1'];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        switch (result.success) {
                            case true:
                                control.showPopup('注册成功', 2000);
                                nav.navigate('signIn');
                                break;
                            case false:
                                control.showPopup(result.msg, 3000);
                                break;
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                    };

                    nativeHelper.signUp({ data: params, success: successFunc, fail: failFunc });
                }
                else {
                    $rootScope.buttonStatus = false;
                    control.showPopup('您输入的两次密码不相同', 3000);
                }
            }
            else {
                $rootScope.buttonStatus = false;
                // control.showPopup('密码为6-16位字符。可使用字母、数字和符号任意组合', 2000);
                control.showPopup('8-32位字符，至少包含数字、大小写字母及特殊符号中的三种', 2000);
            }
        }

        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();