(function () {
    "use strict"
    angular.module('starter')
        .controller('orderDetails', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$stateParams','$state',
            function ($rootScope, $scope, nav, control, nativeHelper, $stateParams, $state) {
                control.hideLoading();
                //获取订单号
                $scope.orderInfo = $stateParams.orderInfo;
                //支付订单
                $scope.paymentOrder = function () {
                    control.showLoading();
                    /**
                     * userId	用户ID
                     * categoryBh	类目编号
                     * type	类型   1：新领费用；2：年费
                     * 
                     * */
                    var params = [$rootScope.loginInfo.accountId,
                        $scope.orderInfo.orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.resultStatus == 9000) {
//                            nav.go('businessManage');
                            if($scope.orderInfo.facePassState==='0'){
                                $state.go('businessCompleted',{orderNo:$scope.orderInfo.orderNo});
                            }else if($scope.orderInfo.facePassState==='1'){
                                $state.go('postIntroduction',{orderNo:$scope.orderInfo.orderNo});
                            }else{
                                nav.go('businessManage');
                            }
                        }
                        if (result.resultStatus != 9000) {
                            if (cordova.platformId === 'android') {
                                control.showPopup('支付失败：' + result.resultMsg, 2000);
                            }else
                            control.showPopup('支付失败：' + result.resultStatus, 2000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.memo, 2000);
                    };

                    nativeHelper.paymentOrder({ data: params, success: successFunc, fail: failFunc });
                }

                var payCallback = function (e) {
                    control.hideLoading();
                    if (e.resultStatus == 9000) {
//                        $state.go('paymentSuccess', { orderNo: $scope.orderInfo.orderNo });
                        if($scope.orderInfo.facePassState==='0'){
                                $state.go('businessCompleted',{orderNo:$scope.orderInfo.orderNo});
                            }else if($scope.orderInfo.facePassState==='1'){
                                $state.go('postIntroduction',{orderNo:$scope.orderInfo.orderNo});
                            }else{
                                nav.go('businessManage');
                            }
                    }
                    if (e.resultStatus != 9000) {
                        control.showPopup(e.memo + e.resultStatus, 2000);
                    }
                };

                window.broadcaster.addEventListener("payCallback", payCallback);


                var hideLoading = function (e) {
                    control.hideLoading();
                };

                window.broadcaster.addEventListener("hideLoading", hideLoading);

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

            }]);
})();
