﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('annualFeeInvoice', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state', function ($rootScope, $scope, nav, control,
                nativeHelper, $state) {

                $scope.invoice = { header: $rootScope.certAnnualFeeInfo.entName.replace(/\(副本.*?\)/g,''), taxNo: $rootScope.certAnnualFeeInfo.uniscid }
                //生成年费业务单
                $scope.confirmInvoice = function (header, taxNo) {

                    if (header == '') {
                        control.showPopup("发票抬头不能为空", 2000);
                        return;
                    }
                    if (taxNo == '') {
                        control.showPopup("统一信用代码不能为空", 2000);
                        return;
                    }
                    control.showLoading();
                    var params = [$rootScope.certAnnualFeeInfo.operator,
                    $rootScope.certAnnualFeeInfo.operatorid,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.accountId,
                    $rootScope.certAnnualFeeInfo.corpid,
                    $rootScope.certAnnualFeeInfo.count,
                        header,
                        taxNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.success) {
                            var item = {
                                orderNo: result.value.orderNo, payType: result.value.payType, allFee: result.value.allFee,
                                entName: $scope.header
                            };
                            $state.go('annualOrderDetails', { orderInfo: item });
                        }
                        if (!result.success) {
//                        $rootScope.OCRFailMsg =result.msg;
//                        $rootScope.OCRFail();
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.doSaveAnnualFeeNetOrderInfo({ data: params, success: successFunc, fail: failFunc });

                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();