﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('annualOrderDetails', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$stateParams','$state',
            function ($rootScope, $scope, nav, control, nativeHelper, $stateParams, $state) {
                control.hideLoading();
                //获取订单号
                $scope.annualOrderInfo = $stateParams.orderInfo;
                //支付订单
                $scope.paymentOrder = function () {
                    control.showLoading();
                    /**
                     * userId	用户ID
                     * categoryBh	类目编号
                     * type	类型   1：新领费用；2：年费
                     * 
                     * */
                    var params = [$rootScope.loginInfo.accountId,
                        $scope.annualOrderInfo.orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.resultStatus == 9000) {
                            $state.go('annualPaymentSuccess');
                        }
                        if (result.resultStatus != 9000) {
                            if (cordova.platformId === 'android') {
                                control.showPopup('支付失败：' + result.resultMsg, 2000);
                            }else
                            control.showPopup('支付失败：' + result.resultStatus, 2000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.memo, 2000);
                    };

                    nativeHelper.paymentOrder({ data: params, success: successFunc, fail: failFunc });
                }

                var payCallback = function (e) {
                    control.hideLoading();
                    if (e.resultStatus == 9000) {
                        $state.go('annualPaymentSuccess', { orderNo: $scope.annualOrderInfo.orderNo });
                    }
                    if (e.resultStatus != 9000) {
                        control.showPopup(e.memo + e.resultStatus, 2000);
                    }
                };

                window.broadcaster.addEventListener("payCallback", payCallback);


                var hideLoading = function (e) {
                    control.hideLoading();
                };

                window.broadcaster.addEventListener("hideLoading", hideLoading);

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

            }]);
})();
