(function() {
    "use strict"
    angular.module('starter')
    .controller('authenticationInfo', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'verifyIdentity', '$state', 'validate','localStorage',
    function($rootScope, $scope, nav, control, nativeHelper, verifyIdentity, $state, validate,localStorage) {

        $scope.authentication = {
            name:'',
            card:'',
            mobile:$rootScope.loginInfo.mobile,
        };

            //实人检测错误提示
            var detectionError = function(resultMsg) {
                if (liveDetectionNum < $rootScope.riseLevelFaceMax) {
                    control.showPopup(resultMsg, 2000);
                    return;
                } else if (liveDetectionNum === $rootScope.riseLevelFaceMax) {
                    liveDetectionNum=0;
//                    control.showPopup(resultMsg, 2000);
                    control.showPopup("人脸识别失败，请返回首页后重新操作", 2500);
//                    var timeout = setTimeout(function () {
                        nav.go('home');
//                        clearTimeout(timeout);
//                    },2500);
                }
            }

        //获取人脸认证结果后判断是否有授权操作
        var resultFunc = function(data) {
//            $scope.$apply(function() {
                if (data.result == 'fail') {
//                    if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//                        detectionError('请核对参数信息');
//                        return;
//                    } else {control.showPopup(data.authResultMsg, 2000);}

                    if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                        detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
                        return;
                    } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                         detectionError('人脸比对失败，错误代码'+data.authResult);
                         return;
                    } else {control.showPopup(data.authResultMsg, 2000);}
                }
                if (data.result == 'success') {
                    $rootScope.loginInfo.idCard=$scope.authentication.card;
                    $rootScope.loginInfo.realNameGrade='1';
                    $rootScope.loginInfo.userName=$scope.authentication.name;
                    localStorage.setObject('loginInfo', $rootScope.loginInfo);

                    control.showPopup("实名认证成功", 2000);
                    nav.navigate($rootScope.identityAuthRootPage);

                }
//            });
        }
        
        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }

        var liveDetectionNum=0;

        //开启活体静默检测
        var startLiveDetection = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体检测-实名认证";
            MobclickAgent.onEventWithParameters("authLivingRealNameEvent", eventCounter);
            liveDetectionNum++;
            verifyIdentity.startLiveDetection(liveDetectionResult);
        };
        
        //人脸识别结果
        var liveDetectionResult = function(res) {
            $scope.$apply(function() {
                if (res.base64PhotoData) {
                    verifyIdentity.startIdentityAuthenticationAction($scope.authentication.name, $scope.authentication.card, res.base64PhotoData, $rootScope.loginInfo.userId, $scope.loginInfo.realNameGrade, resultFunc);
                } else {
                    authLivingFailEvent();
                    detectionError(res.resultMsg);
                }
            });
        };
        //经办人身份信息和授权信息核验
        $scope.startAuthentication = function() {
            if (validate.nullOrEmpty($scope.authentication.name)) {
                control.showPopup('姓名不能为空', 2000);
                return;
            }
            if (validate.nullOrEmpty($scope.authentication.card)) {
                control.showPopup('身份证号码不能为空', 2000);
                return;
            }

            if ($scope.authentication.card.length === 17) {
                $scope.authentication.card += "X";
            }
            if (validate.nullOrEmpty($scope.authentication.mobile)) {
                control.showPopup('手机号码不能为空', 2000);
                return;
            }


            // startLiveDetection();

            $scope.acShowAuthConfirm = true;

        };

        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
            $scope.acShowAuthConfirm = false;
        }
        $scope.acIsAgreeApplyAgreement = true;
        $scope.acAgree = function() {
            $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
            var url = window.currentUrl + '/app/api/appfaceagreement';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }
        $scope.acNext = function() {
            if (!$scope.acIsAgreeApplyAgreement) {
                control.showPopup("请先阅读协议并同意", 2000);
                return;
            }
            $scope.acShowAuthConfirm = false;
            startLiveDetection();
        }



        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
