(function() {
    "use strict"

    angular.module('starter')
    .controller('authorizationRecord', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$state', 'verifyIdentity','$filter',
    function($rootScope, $scope, nav, control, nativeHelper, $state, verifyIdentity,$filter) {

        screen.orientation.unlock();
        screen.orientation.lock('portrait');

//        $scope.recordType = '1';

        var authRecordListRes = function(result) {
            $scope.recordLists = result.value.authRecordList;
        }

        //授权记录,type 0:未授权，1：已授权
        var getAuthRecordList = function(type) {

            verifyIdentity.checkAuthorization($rootScope.loginInfo.idCard, type, '', authRecordListRes);
        }
        //判断账号等级
        var checkIdentity = function() {
            if ($rootScope.loginInfo.realNameGrade == "1") {
                getAuthRecordList($rootScope.recordType);
            } else {
                $rootScope.identityAuthRootPage="authorizationRecord";
                nav.go('authorizationFace');
            }
        }
        checkIdentity();

        $scope.getAuthRecordByType = function(status) {
            $rootScope.recordType = status;
            getAuthRecordList(status);
        }

        //查看详情
        $scope.recordDetails = function(item) {
            $state.go('authorizationDetails', {
                'authorizationDetail': item
            });
        }

        //脱敏处理方法
        function maskName(str){
            if(null != str && str != undefined){
                if (2 == str.length){
                    return str.substring(0, 1)+'*'; //截取name 字符串截取第一个字符，
                } else if (3 == str.length){
                    return str.substring(0, 1)+"*"+str.substring(2, 3); //截取第一个和第三个字符
                } else if (str.length > 3){
                    return str.substring(0, 1)+"*"+'*'+str.substring(3, str.length); //截取第一个和大于第4个字符
                }
            } else {
                return str;
            }
        }

        // 生成授权领证业务单
        var doNetOrderInfo = function(item) {
            control.showLoading();

            var params = [item.agenter, item.cert, $rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId, item.extendDataJson.corpid, item.extendDataJson.categoryBh, item.extendDataJson.netType, {
                'letter': item.letter,
                'idCardFace': "data:image/png;base64,"+photoData
            },
            'EPASSAPP', item.authId, '1'];
            var successFunc = function(result) {
                control.hideLoading();
                
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                
//                alert('doNetOrderInfo:  ' + JSON.stringify(result));
                
                if (result.success) {

                    //0：法人 1:经办人
                    //                        $scope.$apply(function(){
                    $state.go('downloadCert', {
                        'downloadCertInfo': {
                            'srcPage': 'authorizationRecord',
                            'entName': item.unitName,
                            'uniscid': item.uniscid,
                            'orderNo': result.value.orderNo,
                            'corpid': item.extendDataJson.corpid,
                            'orderType': '1',
                            'businessCode': item.extendDataJson.netType == '8' ? 'B03': 'P012',
                            'operatorId': item.cert,
                        }
                    });
                    //                        });
                }
                if (!result.success) {
                    if (result.hasOwnProperty('value')) {
                        if (null != result.value && result.value.hasOwnProperty('busiHistoryDataJson')) {
                            let resValueBusi = result.value.busiHistoryDataJson;
                            if (resValueBusi) {
                                // 判断是否为同一个人
                                if (resValueBusi.proxIdNo == $rootScope.loginInfo.idCard) {
                                    if (false == resValueBusi.isDown) {
                                        // 未下载跳转业务管理
                                        $state.go('businessManage', {
                                            businessManageSearchKey: item.uniscid
                                        });
                                    } else {
                                        // 已下载提示信息
                                        control.showPopup('您已下载该证书，请至【首页-我的证书】中查看', 2000);
                                    }
    
                                } else {
                                    // 姓名脱敏
                                    var secName = resValueBusi.proxName;
                                    if (resValueBusi.proxName.length > 1) {
                                        secName = maskName(secName);
                                    }
    
                                    control.showPopup('证书已被其他用户（' + secName + '）申领下载，同一张证书同时只能一名用户使用  ', 2000);
                                }
                                return;
                            }
                        }
                    }

                    control.showPopup(result.msg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };

            nativeHelper.doSaveAuthNetOrderInfo({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

            //实人检测错误提示
            var detectionError = function(resultMsg) {
                if (liveDetectionNum < $rootScope.authFaceMax) {
                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                    control.showConfirm3($scope.startBiopsy,
                    function() {},
                    '取消', '重试', 'check-information', template);
                    return;
                } else if (liveDetectionNum === $rootScope.authFaceMax) {
                    liveDetectionNum = 0;
                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                    control.showConfirm3(function() {
                        $scope.navigate('subjectQuery')
                    },
                    function() {
                        nav.go('home');
                        return;
                    },
                    '返回首页', '上传材料', 'check-information', template);
                    return;
                }
            }
            //采集人脸提示
            $scope.alert_applicant_info = false;
            $scope.closeApplicantInfoAlert = function() {
                $scope.alert_applicant_info = false;
            }
            //记录刷脸次数
            var liveDetectionNum=0;

            //点击同意授权
            var isAuth = false;

            //开始活体检测
            $scope.startBiopsy=function(){

                $scope.acShowAuthConfirm = true;
                $scope.alert_applicant_info=false;


                //  var eventCounter = new Object();
                //  eventCounter.page = "活体检测-授权记录";
                //  MobclickAgent.onEventWithParameters("authLivingAuthorizationRecordEvent", eventCounter);

                // if (isAuth) {
                //     startBiopsyForAuthorization();
                // } else {
                //     $scope.alert_applicant_info=false;
                //     liveDetectionNum++;
                //     verifyIdentity.startLiveDetection(liveDetectionResult);
                // }
            }
        
            var authLivingFailEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体识别失败";
                MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
            }

            var photoData;
            //人脸识别结果监听
            var liveDetectionResult = function(res) {
//                alert('liveDetectionResult:  ' + JSON.stringify(res));
                $scope.$apply(function() {
                    if (res.base64PhotoData) {
                        photoData = res.base64PhotoData;
                        verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationRes);
                    } else {
                        authLivingFailEvent();
                        detectionError(res.resultMsg);
                    }
                });
            };

            //人脸信息和身份信息对比结果
            var IdentityAuthenticationRes = function(data) {
//                alert('IdentityAuthenticationRes:  ' + JSON.stringify(data));
                
                $scope.$apply(function() {
                    if (data.result == 'fail') {
//                        if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//                            detectionError('请核对参数信息');
//                            return;
//                        } else{
//                            control.showPopup(data.authResultMsg, 2000);
//                        }
                        if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                            detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
                            return;
                        } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                             detectionError('人脸比对失败，错误代码'+data.authResult);
                             return;
                        } else {control.showPopup(data.authResultMsg, 2000);}
                        }
                    if (data.result == 'success') {
                        //生成业务单
                        doNetOrderInfo(authorizationItemInfo);
                    }
                });
            }

        //生产网点资料业务单
        //var doSaveOfflineDataNetOrderInfo=function(item){
        //           control.showLoading();
        //                    var params = [$rootScope.loginInfo.accountId,
        //                      item.extendDataJson.netType,
        //                    'EPASSAPP',
        //                    item.authId,
        //                    ];
        //                    var successFunc = function(result) {
        //                        control.hideLoading();
        //                        if (result == null || angular.equals({},
        //                        result)) {
        //                            control.showPopup('服务出错啦', 2000);
        //                            return;
        //                        }
        //                         if (result.success) {
        //                        //0：法人 1:经办人
        ////                        $scope.$apply(function(){
        //                          if($rootScope.claimant.type == '0'){
        //                                            nav.navigate('applyCertComplete');
        //                                        }else if($rootScope.claimant.type == '1'){
        //                                            nav.navigate('confirmAuthorizeInfo');
        //                                        }
        ////                        });
        //                        }
        //                        if (!result.success) {
        //                            control.showPopup(result.msg, 2000);
        //                        }
        //                    }
        //                    var failFunc = function(error) {
        //                        control.hideLoading();
        //                        control.showPopup(error.msg, 2000);
        //                    };
        //
        //                    nativeHelper.doSaveOfflineDataNetOrderInfo({
        //                        data: params,
        //                        success: successFunc,
        //                        fail: failFunc
        //                    });
        //    }
        var certFeeTip = function(item, type, btnLeft,fee) {
            var tipContent = '';
            var btnRight = '';
            if (type == '年费') {
                tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期请先缴纳证书年费后再办理证书相关维护业务。<p>'
                btnRight = "取消";
            } else if (type == '子证书') {

                var category = $filter('categoryType')(item.extendDataJson.categoryBh);
                                        tipContent = '新领证书:<p>这是申领' + category + '，证书服务费用<span>' + fee + '元/年</span>，确定要申领请点“申领”。若是补办首张免费省法人证书请点“取消”后去补办省法人证书。</p > '
                btnRight = "申领";
            }

            control.showConfirm(tipContent,

            function() {
            //生成业务单：经办人类型 0法定代表人 1经办人 2管理员
            //授权记录："0法定代表人 1管理员 2经办人"
                if (type == '子证书') {
                var operatorType;
                switch(item.identityType){
                case '0':
                operatorType='0'
                break;
                case '1':
                operatorType='2';
                break;
                case '2':
                operatorType='1';
                break;
                }
//                console.log("item : "+JSON.stringify(item));
                    $state.go('confirmCertInvoice', {
                        'netOrderInfoWithInvoice': {
                            'entName': item.unitName,
                            'uniscid': item.uniscid,
                            'agenter': $rootScope.loginInfo.userName,
                            'cert': item.cert,
                            'mobile': item.mobile,
                            'corpid': item.extendDataJson.corpid,
                            'categoryBh': item.extendDataJson.categoryBh,
                            'netType': item.extendDataJson.netType,
                            'letter': item.letter,
                            'idCardFace': '',
                            'authId': item.authId,
                            'operatorType': operatorType,
                            'orderType': '1',
                            'businessCode': item.extendDataJson.netType == '8' ? 'B03': 'P012',
                        }
                    });
                    return;
                }
            },

            function() {

                if (type == '年费') {
                    //封装证书年费所需信息
                    $rootScope.certAnnualFeeInfo = {
                        entName: item.entName,
                        uniscid: item.uniscid,
                        categoryBh: item.extendDataJson.categoryBh,
                        isFree: item.isFree,
                        corpid: item.extendDataJson.corpid,
                        businessCode: type,
                        operator: item.agenter,
                        operatorid: item.cert,

                    }
                    nav.navigate('confirmPayInfo');
                    return;
                }
            },
            btnLeft, btnRight, 'cusClass');
        }
        $scope.canClick=false;
        //下载证书--生成业务单
        var authorizationItemInfo;
        $scope.createBusinessOrder = function(item) {
         $scope.canClick=true;
            control.showLoading();
            var params = [item.extendDataJson.categoryBh, item.extendDataJson.corpid, item.extendDataJson.netType, ];
            var successFunc = function(result) {
                control.hideLoading();
                $scope.canClick=false;
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                
//                alert('createBusinessOrder:  ' + JSON.stringify(result));
                
                if (result.success) {
                    if (!result.value.isFree) {
                        certFeeTip(item, '子证书', '取消',result.value.fee);
                        return;
                    }
                    if (!result.value.inService) {
                        item.endDate = result.endDate;
                        item.fee = result.fee;
                        certFeeTip(item, '年费', '缴费',result.value.fee);
                    } else{
                    authorizationItemInfo=item;
                    $scope.alert_applicant_info=true;
                    }
                }
                if (!result.success) {
                    control.showPopup(result.msg, 2000);
                }
            }
            var failFunc = function(error) {
                 $scope.canClick=false;
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };

            nativeHelper.getFeeInfo({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        //        //同意授权
        $scope.agreeAuthorization = function(item) {
            $state.go('authenticationApproval', {
                'authorizationDetail': {
                    'srcPage': 'authorizationRecord',
                    name: item.agenter,
                    cert: item.cert,
                    mobile: item.mobile,
                    'authId': item.authId,
                    identityId: item.identityId,
                    uniscid: item.uniscid,
                    startTime: item.startTime,
                    'certName': item.extendDataJson.certName,
                    'categoryBh': item.extendDataJson.categoryBh,
                    'netType': item.extendDataJson.netType,
                    'corpid': item.extendDataJson.corpid,
                }
            });
        }


        var selectedItem;
        $scope.doGetUserFace = function(item) {
            selectedItem = item;
            control.showLoading();
            var params = [$rootScope.loginInfo.idCard];
            var successFunc = function(result) {
                control.hideLoading();
                console.log('doGetUserFace result.data.hasFaceImg -- ' + JSON.stringify(result.data.hasFaceImg));
                
                if ('success' == result.rslt) {
                    let hasFaceImg = String(result.data.hasFaceImg);
                    if ('0' == hasFaceImg) {
                        isAuth = true;
                        $scope.alert_applicant_info=true;
                    } else if ('1' == hasFaceImg) {
                        $scope.agreeAuthorization(selectedItem);
                    }
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error, 3000);
            };
            nativeHelper.getUserFace({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        //开始活体检测
        var startBiopsyForAuthorization=function(){
            $scope.alert_applicant_info=false;
            verifyIdentity.startLiveDetection(liveDetectionResultForAuthorization);
        }
        var photoData;
        //人脸识别结果监听
        var liveDetectionResultForAuthorization = function(res) {
            $scope.$apply(function() {
                if (res.base64PhotoData) {
                    photoData = res.base64PhotoData;
                    verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationResForAuthorization);
                } else {
                    authLivingFailEvent();
                    detectionErrorForAuthorization(res.resultMsg);

                }
            });
        };
        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
        //实人检测错误提示
        var detectionErrorForAuthorization = function(resultMsg) {
            // if (liveDetectionNum < $rootScope.authFaceMax) {
                var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                control.showConfirm3(startBiopsyForAuthorization,
                    function() {},
                '取消', '重试', 'check-information', template);
                return;
            // } else if (liveDetectionNum === $rootScope.authFaceMax) {
            //     liveDetectionNum=0;
            //     control.showPopup("人脸识别失败，请返回首页后重新操作", 2500);
            //     nav.go('home');
            // }
        }
        //人脸信息和身份信息对比结果
        var IdentityAuthenticationResForAuthorization = function(data) {
            $scope.$apply(function() {
                if (data.result == 'fail') {
                    if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                         detectionErrorForAuthorization('姓名或身份证号码有误，错误代码'+data.authResult);
                         return;
                    } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult ==  '02XX'){
                         detectionErrorForAuthorization('人脸比对失败，错误代码'+data.authResult);
                         return;
                    } else {control.showPopup(data.authResultMsg, 2000);}
                }

                $scope.agreeAuthorization(selectedItem);
            });
        }





            var refuse=function(authId, identityId){
                control.showLoading();
                        var params = [authId, identityId];
                        var successFunc = function(result) {
                            control.hideLoading();
                            if (result == null || angular.equals({},
                            result)) {
                                control.showPopup('服务出错啦', 3000);
                                return;
                            }
                            if (result.rslt == 'success') {
                                //                            $scope.$apply(function() {
                                getAuthRecordList($rootScope.recordType)
                                //                            });
                            }
                            if (result.rslt == 'fail') {
                                control.showPopup(result.errorMsg, 2000);
                            }
                        }
                        var failFunc = function(error) {
                            control.hideLoading();
                            control.showPopup(error.msg, 2000);
                        };
                        nativeHelper.refuseAuthorization({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
            }

        //        拒绝授权
        $scope.refuseAuthorization = function(authId, identityId) {
            control.showConfirm("确认是否拒绝？",

                        function() {
                        refuse(authId, identityId);
                        },

                        function() {

                        },
                        "取消", "确认", 'cusClass');
        }
        //查看详情
        $scope.detail = function(item) {
            $state.go('authorizationDetails', {
                authorizationDetail: item
            });
        }

        $scope.isShow = false;
        $scope.linkContent = "";
        $scope.isShowShare = function(item) {
            if(!item.shareContent){
                control.showPopup('授权地址为空', 3000);
                return;
            }
            $scope.linkContent = item.shareContent;
//            if (cordova.platformId === 'android') {
                $scope.isShow = true;
//                console.log($scope.linkContent + "  " + $scope.isShow);
//            } else if (cordova.platformId === 'ios') {
//                nativeHelper.navToShareView({
//                    data: [$scope.linkContent],
//                    success: null,
//                    fail: null
//                });
//            }

        }
        $scope.cancel = function() {
            $scope.isShow = false;
        }
        $scope.cancelShare = function() {
            $scope.isShow = false;
        }
//         var eventWithParameters = function() {
//               var eventCounter = new Object();
//               eventCounter.page = "授权记录";
//               MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//                }
//                eventWithParameters();
        
        $scope.navigate = function(state) {
            nav.navigate(state);
        };


        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
            $scope.acShowAuthConfirm = false;
        }
        $scope.acIsAgreeApplyAgreement = true;
        $scope.acAgree = function() {
            $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
            var url = window.currentUrl + '/app/api/appfaceagreement';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }
        $scope.acNext = function() {
            if (!$scope.acIsAgreeApplyAgreement) {
                control.showPopup("请先阅读协议并同意", 2000);
                return;
            }
            $scope.acShowAuthConfirm = false;

            
            var eventCounter = new Object();
            eventCounter.page = "活体检测-授权记录";
            MobclickAgent.onEventWithParameters("authLivingAuthorizationRecordEvent", eventCounter);

           if (isAuth) {
               startBiopsyForAuthorization();
           } else {
               $scope.alert_applicant_info=false;
               liveDetectionNum++;
               verifyIdentity.startLiveDetection(liveDetectionResult);
           }
        }
    }]);
})();
