(function() {
    "use strict"

    angular.module('starter')
    .controller('signatureAuthorization', ['$rootScope', '$scope', '$timeout', '$stateParams', '$ionicLoading', '$filter', 'nav', 'control', 'nativeHelper', '$state',
    function($rootScope, $scope, $timeout, $stateParams, $ionicLoading, $filter, nav, control, nativeHelper, $state) {
        control.hideLoading();

        var approvalDetail = $stateParams.authorizationDetail;
        //console.log(approvalDetail);
        var wrapper = document.getElementById("signature-pad"),
        canvas = wrapper.querySelector("canvas"),
        signaturePad;

        var resizeCanvas = function() {
            var ratio = Math.max(window.devicePixelRatio || 1, 1);
            canvas.width = canvas.offsetWidth * ratio;
            canvas.height = canvas.offsetHeight * ratio;
            canvas.getContext("2d").scale(ratio, ratio);

            signaturePad = new SignaturePad(canvas);
        }

        var setLandscape = function() {
            //alert('setLandscape');
            screen.orientation.unlock();
            screen.orientation.lock('portrait');
            screen.orientation.lock('landscape');
        }

        //设置横屏
        setLandscape();

        $timeout(function() {
            resizeCanvas();
        },
        1000);

        $scope.clearSignature = function() {
            signaturePad.clear();
        }
        //授权记录同意
        var checkPass = function(signnatureBase) {
            control.showLoading();
            var signerId = approvalDetail.authId;
            var params = [approvalDetail.authId, approvalDetail.identityId, signnatureBase, approvalDetail.startTime + ' 00:00:00', approvalDetail.endTime + '23:59:59'];

            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                switch (result.rslt) {
                case "success":
                    control.showPopup('保存成功', 2000,
                    function() {
                        $scope.$apply(function() {
                            $scope.clearSignature();
                            screen.orientation.unlock();
                            screen.orientation.lock('portrait');
                            nav.navigate('authorizationRecord');
                        });
                    });

                    if (cordova.platformId === 'ios') {
                        nativeHelper.setOrientation({
                            data: ['Portrait'],
                            success: null,
                            fail: null
                        });
                    }
                    break;
                case "fail":
                    control.showPopup(result.errorMsg, 3000);
                    break;
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error, 3000);
            };

            nativeHelper.checkPass({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        var addAuthInfoByFr = function(signatureImage) {
            control.showLoading();
            var params = [approvalDetail.uniscid, approvalDetail.identityId, approvalDetail.authIdentityId, "20191016172831442090", approvalDetail.startTime + ' 00:00:00', approvalDetail.endTime + '23:59:59', signatureImage, 'EPASSAPP', {
                'certName': approvalDetail.certName,
                'categoryBh': approvalDetail.categoryBh,
                'netType': approvalDetail.netType,
                'corpid': approvalDetail.corpid,
                'businessType':approvalDetail.businessType,
            }];

            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                switch (result.rslt) {
                case "success":
                    control.showPopup('保存成功', 2000,
                    function() {
                        $scope.$apply(function() {
                            $scope.clearSignature();
                            screen.orientation.unlock();
                            screen.orientation.lock('portrait');
                            nav.navigate('authorizationRecord');
                        });
                    });
                    if (cordova.platformId === 'ios') {
                        nativeHelper.setOrientation({
                            data: ['Portrait'],
                            success: null,
                            fail: null
                        });
                    }
                    break;
                case "fail":
                    control.showPopup(result.errorMsg, 3000);
                    break;
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error, 3000);
            };

            nativeHelper.addAuthInfoByFr({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }


        $scope.submitSignature = function() {

            if (signaturePad.isEmpty()) {
                control.showPopup("请设置签名", 1000);
                return;
            }
            var imgBase64 = signaturePad.toDataURL().split(',')[1];
            if (approvalDetail.srcPage == 'selectHandler') {
                addAuthInfoByFr(imgBase64);
            } else checkPass(imgBase64);
        }

        $scope.navigate = function() {
            if (cordova.platformId === 'ios') {
                nativeHelper.setOrientation({
                    data: ['Portrait'],
                    success: null,
                    fail: null
                });
            }
            nav.goBack();
            //            $state.go(state,{'authorizationDetail':$scope.approvalDetail});
        };

//        var eventWithParameters = function() {
//            var eventCounter = new Object();
//            eventCounter.page = "授权审批";
//            MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//        }

    }]);
})();
