(function() {
    "use strict"

    angular.module('starter')
    .controller('addAdmin', ['$scope', 'nav', 'control', 'nativeHelper', 'validate', '$stateParams',
    function($scope, nav, control, nativeHelper, validate, $stateParams) {

        var certEntInfo = $stateParams.certEntInfo;

        $scope.addAdminInfo = {
            name: '',
            cert: '',
            mobile: '',
            startTime: '',
            label: ''
        };

        var getDate = function(time, day) {
            time.setDate(time.getDate() + day);
            var y = time.getFullYear();
            var m = time.getMonth() + 1;
            var d = time.getDate();
            return y + "-" + (m < 10 ? "0" + m: m) + "-" + (d < 10 ? "0" + d: d);
        }
        var nowTime = new Date();
        var getTime = getDate(nowTime, 0);

        $scope.startTime = getTime;
//        console.log("123 " + $scope.startTime);
        var years = function() {
            for (var t = [], e = nowTime.getFullYear(); e <= nowTime.getFullYear() + 1; e++) t.push(e);
            return t
        }
        //选择截止日期
        $("#datetime-picker-end").datetimePicker({
            onOpen: function(data) {
                // debugger
                $('#picker-title').html(data.value[0] + '-' + data.value[1] + '-' + data.value[2]);
            },
            onChange: function(data) {
                $('#picker-title').html(data.value[0] + '-' + data.value[1] + '-' + data.value[2]);
            },
            years: years(),
            toolbarTemplate: '<div class="tool-bar"><div class="close-picker fl close-text">关闭</div><div class="fl title-text" id="picker-title"></div><div class="close-picker fr finish-text">完成</div></div>',
            times: function() {
                return [];
            }
        });

        var getIdentityLabel = function() {
            control.showLoading();
            var params = [];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.rslt == 'success') {
                    $scope.$apply(function() {
                        $scope.labelList = result.labelList;
                    });
                }
                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.getIdentityLabel({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        getIdentityLabel();

        $scope.isSelect = -1;
        $scope.selectLabel = function(item) {
            $scope.isSelect = item.id;
            $scope.addAdminInfo.label = item.label;

        }

    var validTime=function (endTime){

         var date1 = new Date(getTime.replace(/-/g, '/'));
         var date2 = new Date(endTime.replace(/-/g, '/'));
         var arr1 = getTime.split("/");
         var date3=new Date(parseInt(arr1[0])+1,parseInt(arr1[1])-1,parseInt(arr1[2]),0,0,0);

           if(date1.getTime()>date2.getTime()) {
                   return '0';
             }else if(date2.getTime()>date3.getTime()){
                    return '1';
             }
    }
        //添加管理员
        $scope.addAdmin = function() {
            var endTime = $('#datetime-picker-end').val();
            if ($scope.addAdminInfo.name == '') {
                control.showPopup('姓名不能为空', 2000);
                return;
            }
            if ($scope.addAdminInfo.cert == '') {
                control.showPopup('身份证号码不能为空', 2000);
                return;
            }

            if ($scope.addAdminInfo.cert.length === 17) {
                $scope.addAdminInfo.cert += "X";
            }
            if ($scope.addAdminInfo.mobile == '') {
                control.showPopup('手机号码不能为空', 2000);
                return;
            }
            if (endTime == '') {
                control.showPopup('授权截止日期不能为空', 2000);
                return;
            }
            if (validTime(endTime) == '0') {
                control.showPopup('截止日期不能小于起始日期', 2000);
                return;
            }
            control.showLoading();
            var params = [certEntInfo.uniscid, $scope.addAdminInfo.name, $scope.addAdminInfo.cert, $scope.addAdminInfo.mobile, $scope.addAdminInfo.label, endTime, certEntInfo.authIdentityId];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                }
                if (result.rslt == 'success') {
                    control.showPopup('管理员设置成功！', 2000);
                    nav.navigate('home');
                }

                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
                return '';
            };
            nativeHelper.setAdmin({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        $scope.goHome = function() {
            nav.go('home');
        };
    }]);
})();
