(function () {
    "use strict"

    angular.module('starter')
        .controller('delayOrChangeDwnCert', ['$rootScope', '$scope', '$filter', 'nav', 'utility', 'control', 'nativeHelper', 'validate', 'localStorage', '$stateParams','requestWrapper',
            function ($rootScope, $scope, $filter, nav, utility, control, nativeHelper, validate, localStorage, $stateParams,requestWrapper) {
                $scope.downloadCertInfo = { password: '', confirmPwd: '' };
                $scope.canClick = false;
                $scope.delayOrChangeDwnCertLastPage = $stateParams.lastPage;
                var entName = $stateParams.entName;
                var uniscid = $stateParams.uniscid;
                var orderNo = $stateParams.orderNo;
                var corpid = $stateParams.corpid;
                var type = $stateParams.type;
                var certId = $stateParams.certId;
                var containerName = $stateParams.containerName;

            
            var downloadCertEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "下载证书";
                MobclickAgent.onEventWithParameters("downloadCertEvent", eventCounter);
            }
            
            var downloadCertCompletedEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "证书下载成功";
                MobclickAgent.onEventWithParameters("downloadCertCompletedEvent", eventCounter);
            }
            
                $scope.downloadCert = function () {
                    if (!validate.certPassword($scope.downloadCertInfo.password) || !validate.certPassword($scope.downloadCertInfo.confirmPwd)) {
                        control.showPopup('请输入6位数字密码', 2000);
                        return;
                    }

                    if ($scope.downloadCertInfo.password !== $scope.downloadCertInfo.confirmPwd) {
                        control.showPopup('您输入的两次密码不相同', 3000);
                        return;
                    }
                    $scope.canClick = true;
                    control.showLoading();
                    downloadCertEvent();//监听下载
                    
                    var timeout = setTimeout(function () {
                        var params = [
//                            entName,
//                            uniscid,
                            orderNo,
                            corpid,
                            type,
//                            certId,
                            $scope.downloadCertInfo.password,
                            cordova.platformId,
                            containerName,
                            $rootScope.SDKVersion,//V1：旧版密码模块，V2：新版密码模块
                            $rootScope.loginInfo.accountId,
                            "1",//自启用
                            "EPASSAPP"
                        ];
                        var successFunc = function (result) {
                            clearTimeout(timeout)
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                return;
                            }
                            switch (result.success) {
                                case true:
                                    downloadCertCompletedEvent();//监听下载成功
                                     control.showPopup('下载成功', 2000);
                                     $scope.canClick = false;
                                     nav.navigate('home');
                                    break;
                                case false:
                                    control.hideLoading();
                                    $scope.canClick = false;
                                    control.showPopup(result.msg, 3000);
                                    nav.navigate($scope.delayOrChangeDwnCertLastPage);
                                    break;
                            }
                        };

                        var failFunc = function (result) {
                            $scope.canClick = false;
                            control.hideLoading();
                            control.showPopup(result.msg, 3000);
                            clearTimeout(timeout)
                            requestWrapper.sendMesToDingTalk("密码模块错误","证书下载",result.alarmMsg)
                        };
                        nativeHelper.downloadCert({ data: params, success: successFunc, fail: failFunc });
                    }, 500);
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
