(function() {
    "use strict"

    angular.module('starter')
    .controller('downloadCert', ['$rootScope', '$scope', '$filter', 'nav', 'control', 'nativeHelper', 'validate', 'localStorage', 'utility', '$stateParams', '$state','verifyIdentity', 'requestWrapper',
    function($rootScope, $scope, $filter, nav, control, nativeHelper, validate, localStorage, utility, $stateParams, $state,verifyIdentity,requestWrapper) {

//        var secureCoreVersion=1;//密码模块版本
        $scope.downloadCertInfo = $stateParams.downloadCertInfo;
        $scope.certUse = {
            password: '',
            confirmPwd: ''
        };

        $scope.iptPass ='';
        $scope.iptPassnew ='';
        $scope.gbState = false;
        $scope.gbStateT = false;
        $scope.focusFunO = function () {
            $scope.gbState = true;
        };
        $scope.blurFunO = function () {
            $scope.gbState = false;
        };
        $scope.focusFunT = function () {
            $scope.gbStateT = true;
        };
        $scope.blurFunT = function () {
            $scope.gbStateT = false;
        };

        var downloadCertEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "下载证书";
            MobclickAgent.onEventWithParameters("downloadCertEvent", eventCounter);
        }
        
        var downloadCertCompletedEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "证书下载成功";
            MobclickAgent.onEventWithParameters("downloadCertCompletedEvent", eventCounter);
        }

        $scope.downloadSuccess=false;
        $scope.canClick = false;

        /**
         * 下载证书
         * */
        var downloadCert = function () {
            control.showLoading();
            downloadCertEvent();//监听下载
            
            var timeout = setTimeout(function () {
                if ($scope.downloadCertInfo.canReApply) {
                    var type = 'reApply';
                } else {
                    var type = $filter('businessCode')($scope.downloadCertInfo.businessCode);
                }

                $scope.containerName = $scope.downloadCertInfo.orderNo;
                if ($scope.downloadCertInfo.businessCode == 'B02') {
                    $scope.containerName = $scope.downloadCertInfo.containerId;
                }

                var params = [
//                        $scope.downloadCertInfo.entName,
//                        $scope.downloadCertInfo.uniscid,
                    $scope.downloadCertInfo.orderNo,
                    $scope.downloadCertInfo.corpid,
                    type,
//                        '',//certId
                    $scope.certUse.password,
                    cordova.platformId,
                    $scope.containerName,
                    $rootScope.SDKVersion,//V1：旧版密码模块，V2：新版密码模块
                    $rootScope.loginInfo.accountId,
                    "1",//自启用
//                        secureCoreVersion,
                    $scope.downloadCertInfo.sourceClient?$scope.downloadCertInfo.sourceClient:"EPASSAPP"
                ];
                var successFunc = function (result) {
                    clearTimeout(timeout)
//                        control.hideLoading();
                    if (result == null || angular.equals({}, result)) { return; }
                        console.log("添加证书 "+JSON.stringify(result));
                        switch (result.success) {
                        case true:
                            downloadCertCompletedEvent();//监听下载成功
                            $scope.canClick = false;
                            $scope.downloadSuccess = true;
                            //核验身份
                            verifyIdentity.checkIdentity($scope.downloadCertInfo.uniscid, $scope.downloadCertInfo.operatorId, '2', checkIdentityRes);
                            break;
                        case false:
                            control.hideLoading();
                            control.showPopup(result.msg, 3000);
                            break;
                        };
                 };

                var failFunc = function (result) {
                    $scope.canClick = false;
                    control.hideLoading();
                    control.showPopup(result.msg, 3000);
                    clearTimeout(timeout)
                    requestWrapper.sendMesToDingTalk("密码模块错误","下载证书",result.alarmMsg)
                };

                nativeHelper.downloadCert({ data: params, success: successFunc, fail: failFunc });
            }, 500);
        }

            /**
             * 证书密码校验
             * */
            $scope.startDownloadCert = function () {
                if (!validate.certPassword($scope.certUse.password) || !validate.certPassword($scope.certUse.confirmPwd)) {
                    control.showPopup('请输入6位数字密码', 2000);
                    return;
                }

                if ($scope.certUse.password !== $scope.certUse.confirmPwd) {
                    control.showPopup('您输入的两次密码不相同', 3000);
                    return;
                }

                downloadCert();
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };



           $scope.isExistValidAdmin = false;

            //查询是否存在有效管理员
            var checkIsExistValidAdmin = function() {

                control.showLoading();
                var params = [$scope.downloadCertInfo.uniscid];
                var successFunc = function(result) {
                    control.hideLoading();
                    if (result == null || angular.equals({},
                    result)) {
                        control.showPopup('服务出错啦', 3000);
                    }
                    if (result.rslt == 'success') {
    //                "existValidAdmin":"0不存在1存在"
                        if (result.existValidAdmin == '0') {
                            $scope.isExistValidAdmin = true;
                        }
                    }

                    if (result.rslt == 'fail') {
                        control.showPopup(result.errorMsg, 2000);
                    }
                }
                var failFunc = function(error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                    return '';
                };
                nativeHelper.existValidAdmin({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }

            var identityId;
            var checkIdentityRes = function(result) {
                if (result.rslt == 'success') {
                    $scope.identityType = result.identityType; //0法定代表人1管理员2经办人
                     identityId=result.identityId
                    if (result.identityType == '0') checkIsExistValidAdmin();
                }
                if (result.rslt == 'fail') {}
            }


            $scope.openWeChat = function() {
                var successFunc = function(result) {
                }

                var failFunc = function(error) {
                    console.log(error);
                    control.showPopup('分享失败,请选择复制', 2000);
                };

                nativeHelper.socialAgent({
                    data: ["e照通", 2],
                    success: successFunc,
                    fail: failFunc
                });
            }

            $scope.setAdmin = function() {
                $state.go('addAdmin', {
                    'certEntInfo':{'uniscid':$scope.downloadCertInfo.uniscid,'authIdentityId':identityId}
                });
            }
    }]);
})();
