(function() {
    "use strict"
    angular.module('starter')
    .controller('ableApplyCertInfo', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper','verifyIdentity','$state','$filter', 'requestWrapper', 'md5', 'utility',
    function($rootScope, $scope, nav, control, nativeHelper,verifyIdentity,$state,$filter,requestWrapper,md5, utility) {
        $rootScope.applyCertInfo = { uniscid: '' };

        var curItem;
        $scope.possess = false;
        $scope.canGet = false;
        $scope.showGoAlert = false;
        $scope.showTimeConfirm = false;

        $scope.legalPersonCert = [];
        $scope.otherCertTypeList = [];
        var initData = function() {
            $rootScope.searchResult.alreadyReceived.forEach(function(v) {
                if (v.hasOwnProperty('applyNew')) {
                    v.certApplyType = '新领'
                } else if (v.hasOwnProperty('makeUp')) {
                    v.certApplyType = '补办'
                }
                if (v.categoryBh == '010') {

                    $scope.legalPersonCert.push(v);
                } else {
                    $scope.otherCertTypeList.push(v);
                }
            });
            $rootScope.searchResult.canReceived.forEach(function(l) {
                if (l.hasOwnProperty('applyNew')) {
                    l.certApplyType = '新领'
                } else if (l.hasOwnProperty('makeUp')) {
                    l.certApplyType = '补办'
                }
                if (l.categoryBh == '010') {
                    $scope.legalPersonCert.push(l);
                } else {
                    $scope.otherCertTypeList.push(l);
                }
            })

            document.getElementById("heightList").style.height = 200 + $scope.otherCertTypeList.length * 200 +'px';
        }

        initData();
        if ($scope.otherCertTypeList.length > 0) {
            $scope.showMore = true;
        }

        //证书操作类型收缩控制
        $scope.showOtherCert = function() {
            $scope.showMore = !$scope.showMore;
        }


        /*
                 * 证书新领、补办数据全局声明
                 * businessCode: "P012"证书新领 "B03"证书补办
                 * netType业务单类型6:证书新领 8:证书补办 7:子证书新领
                 */
        var toApply = function(item, businessCode, netType) {
            //封装证书申领进行中所需信息
            $rootScope.certUnderwayInfo = {
                entName: $rootScope.searchResult.entName,
                uniscid: $rootScope.searchResult.uniscid,
                category: item.category,
                categoryBh: item.categoryBh,
                isFree: item.isFree?item.isFree:item.inService,
                inService: item.inService,
                corpid: item.corpid,
                certName:item.certName,
                certApplyType: item.certApplyType,
                businessCode: businessCode,
                netType: netType,
                operator: '',
                operatorid: '',
                identityType:'',
            }
            checkIdentity();

        }

                /**
                *收费提示
                *B03：已领
                *P012:新领
                */
        var certFeeScale = function(item, type, btnLeft) {
            console.log('item -- ' + JSON.stringify(item));

            var tipContent = '';
            var btnRight = '';
            if (type == 'B03') {
                tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期请先缴纳证书年费后再办理证书相关维护业务。<p>'
                btnRight = "取消";
            } else if (type == 'P012') {
                tipContent = '新领证书:<p>这是申领' + item.category + '，证书服务费用<span>' + item.fee + '元/年</span>，确定要申领请点“申领”。若是补办首张免费省法人证书请点“取消”后去补办省法人证书。</p > '
                btnRight = "申领";
            }

            control.showConfirm(tipContent,

            function() {
                        /*
                         *新领
                         *
                         * 类目categoryBh为“011”时为子证书（副证书）
                         * 业务单类型6:证书新领 8:证书补办 7:子证书新领
                         */
                if (type == 'P012') {
                    if (item.categoryBh == '011') {
                        toApply(item, type, "7");
                    } else {
                        toApply(item, type, "6");
                    }
                    return;
                }
            },

            function() {
                            /*
                            *补办
                            * 业务单类型8:证书补办
                            */
                if (type == 'B03') {
                    if (2 == item.existAnnueeFee) {
                        control.showPopup(item.refuseReason, 3000);
                        return;
                    }

                    //封装证书年费所需信息
                    $rootScope.certAnnualFeeInfo = {
                        entName: $rootScope.searchResult.entName,
                        uniscid: $rootScope.searchResult.uniscid,
                        category: item.category,
                        categoryBh: item.categoryBh,
                        isFree: item.isFree,
                        corpid: item.corpid,
                        businessCode: type,
                        operator: '',
                        operatorid: '',
                        count: '',

                    }
                    nav.navigate('confirmPayInfo');
                    return;
                }
            },
            btnLeft, btnRight, 'cusClass');
        }
        var paymentApply = function(item, type, btnLeft) {
            $rootScope.isFrCert = item.categoryBh == '011' ? true: false;
            $rootScope.certCharge = item.fee;
            //     control.showConfirm4('html/home/particularAttention.html', "特别提醒",
                // function() {

                //     /*
                //                      *新领
                //                      *
                //                      * 类目categoryBh为“011”时为子证书（副证书）
                //                      * 业务单类型6:证书新领 8:证书补办 7:子证书新领
                //                      */

                //     if (item.categoryBh == '011') {
                //         toApply(item, type, "7");
                //     } else {
                //         toApply(item, type, "6");
                //     }
                // },

        //     function() {

        // },
        //     "取消", "继续申领", 'cusClassTbtx');

            let el = document.getElementById("okBtn")
            el.setAttribute("value", "继续申领(5)");
            $scope.okFunc = function(){
                 /*
                  *新领
                  *
                  * 类目categoryBh为“011”时为子证书（副证书）
                  * 业务单类型6:证书新领 8:证书补办 7:子证书新领
                  */
                if (item.categoryBh == '011') {
                    toApply(item, type, "7");
                } else {
                    toApply(item, type, "6");
                }
                $scope.showTimeConfirm = false;

            }

            $scope.cancelClick2 = function() {
                clearInterval(setIntervalByOkBtn);
                $scope.showTimeConfirm = false;
            }

            $scope.isClick = false;

            el.setAttribute("disabled",true);
            var okBtnText = 4;
            function setOKBtn() {
                if (okBtnText == 0) {
                    clearInterval(setIntervalByOkBtn);
                    el.setAttribute("value", "继续申领");
                    el.removeAttribute("disabled")
                    $scope.$apply(function () {
                        $scope.isClick = true;
                    });
                } else {
                    el.setAttribute("value", "继续申领("+ okBtnText +")");
                }

                okBtnText--;

            }

            var setIntervalByOkBtn = setInterval(() => {
                setOKBtn();
            }, 1000);

            $scope.showTimeConfirm = true;

            return;
        }

        // 补办/新领 后续操作
        var certOp = function(item) {
            console.log("certOp");
            switch (item.certApplyType) {
                case '补办':
                    if (!item.makeUp) {
                        control.showCustom3Popup('知道了','check-information','温馨提示',item.reason);
    //                    control.showPopup(item.reason, 2000);
                    } else {
                    var isHaveTender= $rootScope.searchResult.isHaveTender ? $rootScope.searchResult.isHaveTender:"false";
                    if(isHaveTender=="true"&&item.isMedium=="true"){
                        control.showCustom3Popup('知道了','check-information','温馨提示','贵单位近期内有项目正在进行招投标，暂不支持补办业务，请在项目招标结束操作补办业务。');
                        return;
                    }
                        if ("true" == item.isMedium) {
                            control.showConfirm("当前介质证书补办为移动证书后，介质证书将无法继续使用，确定继续补办吗？",
                            function() {
                                if (!item.inService) {
                                    certFeeScale(item, 'B03', '续费');
                                } else {
                                    toApply(item, "B03", "8");
                                }
                            }, function() {}, "取消", "继续补办");
                        } else {
                            if (!item.inService) {
                                certFeeScale(item, 'B03', '续费');
                            } else {
                                console.log("toApply up");
                                toApply(item, "B03", "8");
                            }
                        }
                    }
                    break;
                case '新领':
                    if (!item.applyNew) {
                        control.showPopup(item.reason, 2000);
                    } else {
                        if (!item.isFree) {
                            paymentApply(item, 'P012', '取消');
                        } else {
                            if (item.categoryBh == '011') {
                                toApply(item, 'P012', "7");
                            } else toApply(item, 'P012', "6");
                        }
                    }
                    break;
                }
        }
        $scope.certOperation = function(item) {
            console.log("item - " + JSON.stringify(item));
            console.log('$rootScope.searchResult.uniscid - ' + $rootScope.searchResult.uniscid);
            curItem = item;

            if ("HCCA_NEW" == item.caName) {
                doCheckUploadPicture(item);
            } else {
                certOperationAlert(item);
            }
        }

        var doCheckUploadPicture = function (item) {
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var params = {
                "appid": $rootScope.appid,
                "time": time,
                "hashdata": hashdata,
                "corpid": item.corpid,
                "proxIdNo": $rootScope.loginInfo.idCard,
                "categoryBh": item.categoryBh
            }
            console.log("doCheckUploadPicture params :" + JSON.stringify(params));
            requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                .then(function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    };

                    if (true == result.success) {
                        if ("yes" == result.value.isUpload) {
                            console.log('showGoAlert');
                            $scope.showGoAlert = true;
                        } else {
                            certOperationAlert(item);
                        }
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                })
                .catch(function (e) {
                    control.hideLoading();
                    control.showPopup('网络请求失败：' + e.status, 2000);
                });
        }
        $scope.goNotice = function() {
            console.log('curItem1:' + JSON.stringify(curItem));
            var bCode = '';
            var nType = '';
            if (curItem.hasOwnProperty('applyNew')) {
                // 新领
                bCode = 'P012';
                if (curItem.categoryBh == '011') {
                    nType = '7';
                } else {
                    nType = '6';
                }
            } else if (curItem.hasOwnProperty('makeUp')) {
                // 补办
                bCode = 'B03';
                nType = '8';
            }

            console.log('curItem:' + JSON.stringify(curItem));
            $rootScope.certUnderwayInfo = {
                categoryBh: curItem.categoryBh,
                businessCode: bCode,
                netType: nType,
                entName: $rootScope.searchResult.entName,
                uniscid: $rootScope.searchResult.uniscid,
                corpid: curItem.corpid
            }

            // 去材料领证
            nav.go('userNotice');
        }
        $scope.cancelClick = function() {
            $scope.showGoAlert = false;
        }

        var certOperationAlert = function (item) {
            if (null == $rootScope.searchResult.uniscid) {
                certOp(item);
            } else {
                // 有信用代码则校验后4位
                control.showCustomPopup('html/home/popupCheckOrgCode.html', '', '取消', '验证', 'popup-btn-default',    'popup-btn-light',
                function () {},
                function () {
                    console.log($rootScope.searchResult.uniscid);
                    console.log('normal ' + $rootScope.applyCertInfo.uniscid);
                    console.log('up' + $rootScope.applyCertInfo.uniscid.toUpperCase());
                    if ($rootScope.applyCertInfo.uniscid.length!==4) {
                        control.showPopup('请输入统一社会信用代码后4位!' + $rootScope.applyCertInfo.uniscid , 2000);
                        return;
                    }

                    if ($rootScope.applyCertInfo.uniscid.toUpperCase() !== $rootScope.searchResult.uniscid.substr(-4)) {
                        control.showPopup("信息校验未通过，请确认后再次尝试", 2000);
                        return;
                    }
                    certOp(item);
                });
            }
        }

        //人脸图片与身份信息核验失败提示
        var detectionError = function() {
            if (liveDetectionNum == 1) {
                control.showConfirm2(startBiopsy, '关闭', '重新验证', 'check-information');
                return;
            }
            if (liveDetectionNum == 2) {
                var template = "<div><i class='icon-tips2'></i><h3>人脸验证失败</h3><p>重新验证或核对主体信息</p></div>"
                control.showConfirm3(startBiopsy,
                function() {},
                '关闭', '重新验证', 'check-information', template);
                return;
            }
            if (liveDetectionNum == 3) {
                liveDetectionNum = 0;
                var template = "<div><i class='icon-tips2'></i><h3>人脸验证失败</h3><p>重新验证或前往上传材料领证</p></div>"
                control.showConfirm3(function() {
                    nav.navigate('userNotice')
                },
                function() {},
                '关闭', '前往材料领证', 'check-information', template);
                return;
            }
        }
    //申请授权成功
    var applyAuthorizeRes = function(res) {
        $state.go('applyAuthorizeComplete', {
            linkContext: res
        });
    }
    //更新扩展字段
    var updateExtendData = function(authId) {
        control.showLoading();
        var extendData = {
            'certName': $rootScope.certUnderwayInfo.netType == "8" ? $rootScope.certUnderwayInfo.certName: $rootScope.certUnderwayInfo.entName,
            'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
            'netType': $rootScope.certUnderwayInfo.netType,
            'corpid': $rootScope.certUnderwayInfo.corpid,
            'businessType': $filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType),
        };

        var params = [authId, "EPASSAPP", extendData];
        //             var params = ["1","20190325092052817016",cardId,"玉环金源进出口有限公司","913310217719107159" ];
        var successFunc = function(result) {
            control.hideLoading();
            if (result.rslt == 'success') {
                $rootScope.recordType='1';
                nav.navigate('authorizationRecord');
            } else {
                control.showPopup(result.errorMsg, 2000);
            }
        }
        var failFunc = function(result) {
            control.hideLoading();
            control.showPopup(result.msg, 2000);
        };
        nativeHelper.updateExtendData({
            data: params,
            success: successFunc,
            fail: failFunc
        });
    }
    //授权鉴权结果
    var checkAuthInfoFunc = function(result) {
        console.log("checkAuthInfoFunc - " + JSON.stringify(result));
        $scope.$apply(function() {
            if (result.checkData.checkRslt == "true") {
                if(result.authInfoData.extendData==null){
                    updateExtendData(result.checkData.authId);
                }else{
                    var categoryBh=JSON.parse(result.authInfoData.extendData).categoryBh;
                    let netType = JSON.parse(result.authInfoData.extendData).netType;
                    if(categoryBh==$rootScope.certUnderwayInfo.categoryBh){

                        // 判断当前用户操作和授权记录（补办/新领） 是否一致  一致：去授权记录  不一致：去申领
                        if ($rootScope.certUnderwayInfo == netType) {
                            $rootScope.recordType='1';
                            nav.navigate('authorizationRecord');
                        } else {
                            var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>"
                            control.showConfirm3(function() {
                                verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                            },
                            function() {},
                            '取消', '申请', 'check-information', template);
                        }

                    }else{
                        var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>"
                        control.showConfirm3(function() {
                            verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                        },
                        function() {},
                        '取消', '申请', 'check-information', template);
                    }
                }
            } else {
                var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>"
                control.showConfirm3(function() {
                    verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                },
                function() {},
                '取消', '申请', 'check-information', template);
            }
        });

    }
        //人脸信息和身份信息对比结果
        var IdentityAuthenticationRes=function(data){
                        $scope.$apply(function() {
                        if (data.result == 'fail') {
                         if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                             detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
                             return;
                         } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                             detectionError('人脸比对失败，错误代码'+data.authResult);
                             return;
                         } else {control.showPopup(data.authResultMsg, 2000);}
//                            if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//                                detectionError();
//                                return;
//                            } else
//                            control.showPopup(data.authResultMsg, 2000);
                        }
                        if (data.result == 'success') {
                            //判断经办人身份
                            if($rootScope.certUnderwayInfo.identityType!='2'){

                                nav.navigate('legalRepresentative');
                            }else{
                            //鉴权
                            verifyIdentity.getAuthorizationComfirmInfo($rootScope.loginInfo.idCard,$rootScope.certUnderwayInfo.entName,$rootScope.certUnderwayInfo.uniscid,checkAuthInfoFunc);

                            }
                        }
                    });
        }

        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
        //记录刷脸次数
//        var liveDetectionNum=0;
           //开始活体检测 //暂时没有看到调用
                var startBiopsy=function(){
                    liveDetectionNum++;
                    verifyIdentity.startLiveDetection(liveDetectionResult);
                }
        //人脸识别结果监听
          var liveDetectionResult = function(res) {
                    $scope.$apply(function() {
                        if (res.base64PhotoData) {
                            var photoData = res.base64PhotoData;
                            $rootScope.certUnderwayInfo.base64PhotoData=photoData;
                            verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName,
                             $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId,
                             $rootScope.loginInfo.realNameGrade, IdentityAuthenticationRes);

                        } else {
                            authLivingFailEvent();
//                            control.showPopup(res.resultMsg, 2000);
                                if (liveDetectionNum == 1) {
                                                var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>"+res.resultMsg+"</p></div>"
                                                control.showConfirm3(startBiopsy,
                                                function() {},
                                                '取消', '重试', 'check-information', template);
                                                }
                                            if (liveDetectionNum == 2) {
                                                liveDetectionNum=0;
                                                var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>"+res.resultMsg+"</p></div>"
                                                control.showConfirm3(function() {

                                                $scope.navigate('userNotice')
                                                },
                                                function() {},
                                                '取消', '上传材料', 'check-information', template);
                                                }
                        }
                    });
                };

                //判断账号等级
                var checkIdentity=function(){
                    console.log('checkIdentity');
                    if($rootScope.loginInfo.realNameGrade=="1"){
                        //开始判断身份类型
                        checkIdentityType();
                    }else{
                        nav.navigate('claimantInfo');
                    }
                }
                var checkIdentityTypeRes=function(result){
                    console.log('checkIdentityTypeRes - ' + JSON.stringify(result));
                    if (result.rslt == 'success') {
                                $rootScope.certUnderwayInfo.systemTime = result.systemTime;
                                $rootScope.certUnderwayInfo.identityType = result.identityType; //0法定代表人1管理员2经办人
                                $rootScope.certUnderwayInfo.identityId = result.identityId;
//                                console.log($rootScope.certUnderwayInfo.identityId);

                            //判断经办人身份
                            if($rootScope.certUnderwayInfo.identityType!='2'){

                                nav.navigate('legalRepresentative');
                            }else{
                                //鉴权
                                verifyIdentity.getAuthorizationComfirmInfo($rootScope.loginInfo.idCard,$rootScope.certUnderwayInfo.entName,$rootScope.certUnderwayInfo.uniscid,checkAuthInfoFunc);
                                }
//                                startBiopsy();
//                                verifyIdentity.checkAuthorization($rootScope.loginInfo.idCard,'1',$rootScope.searchResult.uniscid ,checkAuthInfoFunc);
//                                nav.navigate('legalRepresentative');
                            }
                            if (result.rslt == 'fail') {
                                $scope.$apply(function() {
                                    if ("ERROR_027" == result.errorCode) {
                                        //表示法定代表人身份证无法通过校验
                                        control.showCustomAlert3('知道了', 'check-information');
                                        return;
                                    }
                                    if ("ERROR_028" == result.errorCode ) {
                                        //法人身份与主体法人不符
                                        control.showCustomAlert4('知道了', 'check-information');
                                        return;
                                    }
                                    if ("ERROR_029" == result.errorCode ) {
                                        //法定代表人身份证不属于中国大陆
                                        var errorMsg=result.errorMsg ? result.errorMsg: '贵单位法定代表人非大陆人士无法通过授权领证！';
                                        var template = "<div><i class='icon-tips2'></i><h3>无法授权领证</h3><p>" + errorMsg + "</p></div>";
                                                        control.showConfirm3(function() {
                                                                       nav.navigate('userNotice');
                                                        },
                                                        function(){},
                                                        '取消', '材料领证', 'check-information', template);
                                        return;
                                    }
                                    if("ERROR_038"==result.errorCode){
                                         control.showConfirm5("<div class='tbtx-cont'><p>" + result.errorMsg + "</p></div>", "特别提醒",
                                                    function() {
                                                        nav.go('userNotice');
                                                    },
                                                    function() {},
                                                    "取消", "材料领证", 'cusClassTbtx');
                                                    return;
                                    }
                                    if("ERROR_023"==result.errorCode){
                                         control.showConfirm5("<div class='tbtx-cont'><p>" + result.errorMsg + "</p></div>", "特别提醒",
                                                    function() {
                                                        nav.go('userNotice');
                                                    },
                                                    function() {},
                                                    "取消", "材料领证", 'cusClassTbtx');
                                                    return;
                                    }

                                    control.showPopup(result.errorMsg, 2000);
                                });
                            }
                }
           //检查经办人身份类型
           var checkIdentityType=function(){
            verifyIdentity.checkIdentity($rootScope.searchResult.uniscid,$rootScope.loginInfo.idCard,'2',checkIdentityTypeRes);
           }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
