(function() {
    "use strict"

    angular.module('starter')
    .controller('addNewHandler', ['$rootScope', '$scope', '$stateParams', 'nav', 'control', 'nativeHelper', 'validate', 'localStorage', 'utility',
    function($rootScope, $scope, $stateParams, nav, control, nativeHelper, validate, localStorage, utility) {

        $scope.addAgenterInfo = {
            name: '',
            cert: '',
            mobile: '',
            label: ''
        }

        var getIdentityLabel = function() {
            control.showLoading();
            var params = [];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.rslt == 'success') {
                    $scope.$apply(function() {
                        $scope.labelList = result.labelList;
                    });
                }
                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.getIdentityLabel({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        getIdentityLabel();
        $scope.isSelect = -1;
        $scope.selectLabel = function(item) {
            $scope.isSelect = item.id;
            $scope.addAgenterInfo.label = item.label;

        }

        $scope.addAgenter = function() {
            if ($scope.addAgenterInfo.name == "") {
                control.showPopup("姓名不能为空", 2000);
                return;
            }
            if ($scope.addAgenterInfo.cert == "") {
                control.showPopup("身份证号码不能为空", 2000);
                return;
            }

            if ($scope.addAgenterInfo.cert.length === 17) {
                $scope.addAgenterInfo.cert += "X";
            }
            if ($scope.addAgenterInfo.mobile == "") {
                control.showPopup("手机号码不能为空", 2000);
                return;
            }
            if ($scope.addAgenterInfo.label == "") {
                control.showPopup("身份标签不能为空", 2000);
                return;
            }
            control.showLoading();
            var params = [$rootScope.certUnderwayInfo.uniscid, $scope.addAgenterInfo.name, $scope.addAgenterInfo.cert, $scope.addAgenterInfo.mobile, $scope.addAgenterInfo.label, $rootScope.certUnderwayInfo.identityId];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.rslt == 'success') {
                    nav.goBack();
                }
                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.addAgenter({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        $scope.goBack=function(){
            nav.goBack();
        }
        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
