(function() {
    "use strict"
    angular.module('starter')
    .controller('claimantInfo', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'verifyIdentity', '$state', 'validate','localStorage','$filter',
    function($rootScope, $scope, nav, control, nativeHelper, verifyIdentity, $state, validate,localStorage,$filter) {

        $scope.claimant = {
            userName:$rootScope.loginInfo.userName,
            idCard: $rootScope.loginInfo.idCard,
            type: '',
            identityId: '',
            systemTime: '',
            base64PhotoData: '',
            identityType: '',
            letter:'',
            authId:'',
        };

        //经办人类型
        var changeType = function(type) {
            $scope.$apply(function() {
                if (type == '经办人') {
                    $scope.claimant.type = '1';
                }
                if (type == '法定代表人/管理员') {
                    $scope.claimant.type = '0';
                }
            });
        }

        //检测选择经办人类型
        $("#picker").picker({
            onOpen: function(data) {
                changeType(data.value);
                $('#picker-title').html(data.value[0]);
            },
            onChange: function(data) {
                changeType(data.value);
                $('#picker-title').html(data.value[0]);
            },
            toolbarTemplate: '<div class="tool-bar"><div class="close-picker fl close-text">关闭</div><div class="fl title-text" id="picker-title"></div><div class="close-picker fr finish-text">完成</div></div>',
            cols: [{
                textAlign: 'center',
                values: ['经办人', '法定代表人/管理员']
            }],
        });

        //控制是否可输入
        $rootScope.isRealName = false;
        //判断连联用户是否实名
        var checkLinkAccount = function() {
            control.showLoading();
            var params = [$rootScope.loginInfo.mobile, $rootScope.loginInfo.userId];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                if (result.rslt == 'success') {
                    $scope.$apply(function() {
                        if (result.data.idCard && result.data.userName) {
                            $rootScope.isRealName = true;
                            //var isRealName  = true;
                            $scope.claimant.userName = result.data.userName;
                            $scope.claimant.idCard = result.data.idCard;
                        }
                    });
                }
                if (result.rslt == 'fail') {
                    //                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };

            nativeHelper.checkLinkAccount({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
//        checkLinkAccount();

            //实人检测错误提示
            var detectionError = function(resultMsg) {

                 if (liveDetectionNum < $rootScope.riseLevelFaceMax) {
                                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                                    control.showConfirm3(startLiveDetection,
                                    function() {},
                                    '取消', '重试', 'check-information', template);
                                    return;
                                } else if (liveDetectionNum === $rootScope.riseLevelFaceMax) {
                                    liveDetectionNum = 0;
                                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                                    control.showConfirm3(function() {
                                        $rootScope.isNeedAuthFace = false;
                                        $scope.navigate('userNotice')
                                    },
                                    function() {
                                        $rootScope.isNeedAuthFace = true;
                                        nav.go('home');
                                        return;
                                    },
                                    '取消', '上传材料', 'check-information', template);
                                    return;
                                }
            }

        //记录人脸识别次数
        var liveDetectionNum = 0;

        var applyAuthorizeRes=function(res){
            $state.go('applyAuthorizeComplete',{linkContext:res});
        }

    //更新拓展字段
    var updateExtendData = function(authId) {
        control.showLoading();
        var extendData = {
            'certName': $rootScope.certUnderwayInfo.netType == "8" ? $rootScope.certUnderwayInfo.certName: $rootScope.certUnderwayInfo.entName,
            'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
            'netType': $rootScope.certUnderwayInfo.netType,
            'corpid': $rootScope.certUnderwayInfo.corpid,
            'businessType': $filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType),
        };

        var params = [authId, "EPASSAPP", extendData];
        //             var params = ["1","20190325092052817016",cardId,"玉环金源进出口有限公司","913310217719107159" ];
        var successFunc = function(result) {
            control.hideLoading();
            if (result.rslt == 'success') {
                $rootScope.recordType='1';
                nav.navigate('authorizationRecord');
            } else {
                control.showPopup(result.errorMsg, 2000);
            }
        }
        var failFunc = function(result) {
            control.hideLoading();
            control.showPopup(result.msg, 2000);
        };
        nativeHelper.updateExtendData({
            data: params,
            success: successFunc,
            fail: failFunc
        });
    }
        //鉴权结果
        var checkAuthInfoFunc = function(result) {

            $scope.$apply(function() {
                if (result.checkData.checkRslt == "true") {
                    updateExtendData(result.checkData.authId);

                } else {
                    var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>";
                    control.showConfirm3(function() {

                        verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);

                    },
                    function() {},
                    '取消', '申请', 'check-information', template);
                }
            });

        }
        //获取人脸认证结果后判断是否有授权操作
        var resultFunc = function(data) {
            $scope.$apply(function() {
                if (data.result == 'fail') {
//                    if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//                        detectionError('请核对参数信息');
//                        return;
//                    } else
//                    control.showPopup(data.authResultMsg, 2000);
                    if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                        detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
                        return;
                    } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                         detectionError('人脸比对失败，错误代码'+data.authResult);
                         return;
                    } else
                    control.showPopup(data.authResultMsg, 2000);

                }
                if (data.result == 'success') {
                    $rootScope.loginInfo.idCard=$scope.claimant.idCard;
                    $rootScope.loginInfo.realNameGrade='1';
                    $rootScope.loginInfo.userName=$scope.claimant.userName;
                    localStorage.setObject('loginInfo', $rootScope.loginInfo);
                    //如果是经办人检查有没有授权，法人或管理员进入自己领证和授权他人领证页面
                    if ($scope.claimant.identityType == '2') {
                         verifyIdentity.getAuthorizationComfirmInfo($rootScope.loginInfo.idCard,$rootScope.certUnderwayInfo.entName,$rootScope.certUnderwayInfo.uniscid ,checkAuthInfoFunc);
//                         verifyIdentity.checkAuthorization($scope.claimant.idCard,'1',$rootScope.searchResult.uniscid ,checkAuthInfoFunc);
                    } else {
                        nav.navigate('legalRepresentative');
                    }

                }
            });
        }
        
        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
        
        //开启活体静默检测
        var startLiveDetectionFunc = function() {
            $scope.acShowAuthConfirm = true;
        };

        var startLiveDetection = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体检测-新领补办";
            MobclickAgent.onEventWithParameters("authLivingAbleApplyEvent", eventCounter);
            liveDetectionNum++;
            verifyIdentity.startLiveDetection(liveDetectionResult);
        }

        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
            $scope.acShowAuthConfirm = false;
        }
        $scope.acIsAgreeApplyAgreement = true;
        $scope.acAgree = function() {
            $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
            var url = window.currentUrl + '/app/api/appfaceagreement';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }
        $scope.acNext = function() {
            if (!$scope.acIsAgreeApplyAgreement) {
                control.showPopup("请先阅读协议并同意", 2000);
                return;
            }
            $scope.acShowAuthConfirm = false;
            startLiveDetection();
        }
        
        //人脸识别结果
        var liveDetectionResult = function(res) {
            $scope.$apply(function() {
                if (res.base64PhotoData) {
                    $scope.claimant.base64PhotoData = res.base64PhotoData;
                    $rootScope.certUnderwayInfo.base64PhotoData = res.base64PhotoData;
                    console.log("startIdentityAuthenticationAction");
                    verifyIdentity.startIdentityAuthenticationAction($scope.claimant.userName, $scope.claimant.idCard, res.base64PhotoData, $rootScope.loginInfo.userId, $scope.claimant.realNameGrade, resultFunc);
                } else {
                    authLivingFailEvent();
                    detectionError(res.resultMsg);
                }
            });
        };

        //经办人身份类型校验结果
        var identityResult = function(result) {
            if (result.rslt == 'success') {
               $rootScope.certUnderwayInfo.systemTime = result.systemTime;
                 $scope.claimant.identityType = result.identityType; //0法定代表人1管理员2经办人
                 $rootScope.certUnderwayInfo.identityType = result.identityType; //0法定代表人1管理员2经办人
                  $rootScope.certUnderwayInfo.identityId = result.identityId;

                // startLiveDetection();
                startLiveDetectionFunc();
            }
            if (result.rslt == 'fail') {
                $scope.$apply(function() {
                    if ("ERROR_027" == result.errorCode) {
                        //表示法定代表人身份证无法通过校验
                        control.showCustomAlert3('知道了', 'check-information');
                        return;
                    }
                    if ("ERROR_028" == result.errorCode && $scope.claimant.type == '0') {
                        //法人身份与主体法人不符
                        control.showCustomAlert4('知道了', 'check-information');
                        return;
                    }
                    if ("ERROR_029" == result.errorCode && $scope.claimant.type == '1') {
                         //法定代表人身份证不属于中国大陆
                     var errorMsg=result.errorMsg ? result.errorMsg: '贵单位法定代表人非大陆人士无法通过授权领证！';
                     var template = "<div><i class='icon-tips2'></i><h3>无法授权领证</h3><p>" + errorMsg + "</p></div>";
                     control.showConfirm3(function() {
                         nav.navigate('userNotice');
                     },
                     function() {},
                     '取消', '材料领证', 'check-information', template);
                     return;
                    }
                    if ("ERROR_038" == result.errorCode ) {
                         //合伙企业
                     var errorMsg=result.errorMsg ;
                     var template = "<div><i class='icon-tips2'></i><h3>无法授权领证</h3><p>" + errorMsg + "</p></div>";
                     control.showConfirm3(function() {
                         nav.navigate('userNotice');
                     },
                     function() {},
                     '取消', '材料领证', 'check-information', template);
                     return;
                    }
                    if ("ERROR_023" == result.errorCode ) {
                         //合伙企业
                     var errorMsg=result.errorMsg ;
                     var template = "<div><i class='icon-tips2'></i><h3>无法授权领证</h3><p>" + errorMsg + "</p></div>";
                     control.showConfirm3(function() {
                         nav.navigate('userNotice');
                     },
                     function() {},
                     '取消', '材料领证', 'check-information', template);
                     return;
                    }
                    control.showPopup(result.errorMsg, 2000);
                });
            }
        }
        //经办人身份信息和授权信息核验
        $scope.checkInfo = function() {
            if (validate.nullOrEmpty($scope.claimant.userName)) {
                control.showPopup('姓名不能为空', 2000);
                return;
            }
            if (validate.nullOrEmpty($scope.claimant.idCard)) {
                control.showPopup('身份证号码不能为空', 2000);
                return;
            }

            if ($scope.claimant.idCard.length === 17) {
                $scope.claimant.idCard += "X";
            }
            if ($scope.claimant.type !== '1' && $scope.claimant.type !== '0') {
                control.showPopup('请选择您的身份', 2000);
                return;
            }
            
            if (!$scope.isAgreeApplyAgreement) {
                control.showPopup("请阅读并同意协议", 2000);
                return;
            }
            
            verifyIdentity.checkIdentity($rootScope.certUnderwayInfo.uniscid, $scope.claimant.idCard, $scope.claimant.type, identityResult);

        };
//        var eventWithParameters = function() {
//            var eventCounter = new Object();
//            eventCounter.page = "经办人信息-低实用户提示等级材料页";
//            MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//        }
//        eventWithParameters();
        $scope.navigate = function(state) {
            nav.navigate(state);
        };
        
        $scope.isAgreeApplyAgreement=false;
        $scope.agree=function(){
            $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
        }
    }]);
})();
