(function() {
    "use strict"
    angular.module('starter')
    .controller('confirmCertInvoice', ['$rootScope','$stateParams', '$scope', 'nav', 'control', 'nativeHelper', '$state','verifyIdentity',
    function($rootScope,$stateParams, $scope, nav, control, nativeHelper, $state,verifyIdentity) {

    /**
    *授权申领法人或经办人生成付费业务单、授权记录生成付费业务单
    **/

    var netOrderInfoWithInvoice=$stateParams.netOrderInfoWithInvoice;
//    console.log("netOrderInfoWithInvoice : "+JSON.stringify(netOrderInfoWithInvoice));
        $scope.invoice = {
            header: netOrderInfoWithInvoice.entName.replace(/\(副本.*?\)/g,''),
            taxNo: netOrderInfoWithInvoice.uniscid
        }
        $scope.canClick=false;
        //生成授权付费业务单
        $scope.confirmInvoice = function(header, taxNo) {
            $scope.canClick=true;
            if (header == '') {
                control.showPopup("发票抬头不能为空", 2000);
                return;
            }
            if (taxNo == '') {
                control.showPopup("统一信用代码不能为空", 2000);
                return;
            }
            $scope.invoice.header=header;
            $scope.invoice.taxNo=taxNo;
            $scope.userName=netOrderInfoWithInvoice.agenter;
            $scope.userCert=netOrderInfoWithInvoice.cert;
            $scope.alert_applicant_info=true;
        }


        //脱敏处理方法
        function maskName(str){
            if(null != str && str != undefined){
                if (2 == str.length){
                    return str.substring(0, 1)+'*'; //截取name 字符串截取第一个字符，
                } else if (3 == str.length){
                    return str.substring(0, 1)+"*"+str.substring(2, 3); //截取第一个和第三个字符
                } else if (str.length > 3){
                    return str.substring(0, 1)+"*"+'*'+str.substring(3, str.length); //截取第一个和大于第4个字符
                }
            } else {
                return str;
            }
        }

        var doSaveAuthNetOrderInfoWithInvoice=function(){
                    control.showLoading();
                    var params = [netOrderInfoWithInvoice.agenter,
                    netOrderInfoWithInvoice.cert,
                    netOrderInfoWithInvoice.mobile,
                    $rootScope.loginInfo.accountId,
                    netOrderInfoWithInvoice.corpid,
                    netOrderInfoWithInvoice.categoryBh,
                    netOrderInfoWithInvoice.netType,
                    {'letter':netOrderInfoWithInvoice.letter?netOrderInfoWithInvoice.letter:'',
                    'idCardFace':"data:image/png;base64,"+photoData},
                     $scope.invoice.header, $scope.invoice.taxNo,'EPASSAPP',netOrderInfoWithInvoice.authId,
                     netOrderInfoWithInvoice.operatorType
                     ];
                    var successFunc = function(result) {
                        $scope.canClick=false;
                        control.hideLoading();
                        if (result == null || angular.equals({},
                        result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        console.log("doSaveAuthNetOrderInfoWithInvoice :" + JSON.stringify(result));


                        if (result.success) {

        //                    var item = {
                                netOrderInfoWithInvoice.orderNo= result.value.orderNo,
                                netOrderInfoWithInvoice.payType= result.value.payType,
                                netOrderInfoWithInvoice.allFee= result.value.allFee,
        //                        netOrderInfoWithInvoice.entName= $scope.header
        //                    };
                            $state.go('orderInfoConfirm', {
                                orderInfo: netOrderInfoWithInvoice
                            });
                            
                            
                        }
                        if (!result.success) {
                            if (result.hasOwnProperty('value')) {
                                if (null != result.value && result.value.hasOwnProperty('busiHistoryDataJson')) {
                                    let resValueBusi = result.value.busiHistoryDataJson;
                                    if (resValueBusi) {
                                        // 判断是否为同一个人
                                        if (resValueBusi.proxIdNo == $rootScope.loginInfo.idCard) {
                                            if (false == resValueBusi.isDown) {
                                                // 未下载跳转业务管理
                                                $state.go('businessManage', {
                                                    businessManageSearchKey: netOrderInfoWithInvoice.uniscid
                                                });
                                            } else {
                                                // 已下载提示信息
                                                control.showPopup('您已下载该证书，请至【首页-我的证书】中查看', 2000);
                                            }
                                        } else {
                                            // 姓名脱敏
                                            var secName = resValueBusi.proxName;
                                            if (resValueBusi.proxName.length > 1) {
                                                secName = maskName(secName);
                                            }
                                            control.showPopup('证书已被其他用户（' + secName + '）申领下载，同一张证书同时只能一名用户使用', 2000);
                                        }
                                        return;
                                    }
                                }
                            }

                            //$rootScope.OCRFailMsg =result.msg;
                            //$rootScope.OCRFail();
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function(result) {
                        $scope.canClick=false;
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.doSaveAuthNetOrderInfoWithInvoice({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
        }

           //实人检测错误提示
            var detectionError = function(resultMsg) {
                if (liveDetectionNum < $rootScope.authFaceMax) {
                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                    control.showConfirm3($scope.startBiopsy,
                    function() {},
                    '取消', '重试', 'check-information', template);
                    return;
                } else if (liveDetectionNum === $rootScope.authFaceMax) {
                    liveDetectionNum = 0;
                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                    control.showConfirm3(function() {
                        $rootScope.isNeedAuthFace = false;
                        nav.go('subjectQuery');
                    },
                    function() {
                        $rootScope.isNeedAuthFace = true;
                        nav.go('home');
                        return;
                    },
                    '返回首页', '上传材料', 'check-information', template);
                    return;
                }
            }

        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
        
          //采集人脸提示
          $scope.alert_applicant_info = false;
          $scope.closeApplicantInfoAlert = function() {
              $scope.alert_applicant_info = false;
          }
            var liveDetectionNum=0;
            //开始活体检测
            $scope.startBiopsyClick=function(){
                $scope.acShowAuthConfirm = true;
                $scope.alert_applicant_info=false;
            }
            var photoData;
            //人脸识别结果监听
            var liveDetectionResult = function(res) {
                $scope.$apply(function() {
                    if (res.base64PhotoData) {
                        photoData = res.base64PhotoData;
                        verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationRes);
                    } else {
                        authLivingFailEvent();
                        detectionError(res.resultMsg);
                    }
                });
            };

            var startBiopsy = function() {
                $scope.alert_applicant_info=false;
                liveDetectionNum++;
                verifyIdentity.startLiveDetection(liveDetectionResult);
            }

            $scope.acShowAuthConfirm = false;
            $scope.acCloseClick = function() {
                $scope.acShowAuthConfirm = false;
            }
            $scope.acIsAgreeApplyAgreement = true;
            $scope.acAgree = function() {
                $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
            }
            $scope.acAgreement = function() {
                var url = window.currentUrl + '/app/api/appfaceagreement';
                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
            $scope.acNext = function() {
                if (!$scope.acIsAgreeApplyAgreement) {
                    control.showPopup("请先阅读协议并同意", 2000);
                    return;
                }
                $scope.acShowAuthConfirm = false;
                startBiopsy();
            }


            //人脸信息和身份信息对比结果
            var IdentityAuthenticationRes = function(data) {
                $scope.$apply(function() {
                    if (data.result == 'fail') {

                    if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                         detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
                         return;
                    } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                         detectionError('人脸比对失败，错误代码'+data.authResult);
                         return;
                    } else {control.showPopup(data.authResultMsg, 2000);}
//                        if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//                            detectionError(data.authResultMsg);
//                            return;
//                        } else
//                         control.showPopup(data.authResultMsg, 2000);
                    }
                    if (data.result == 'success') {
                        //生成付费业务单
                        doSaveAuthNetOrderInfoWithInvoice();
                    }
                });
            }

        $scope.navigate = function(state) {
            nav.goBack();
        };
    }]);
})();
