(function() {
    "use strict"

    angular.module('starter')
    .controller('selectHandler', ['$rootScope', '$scope', '$filter', 'nav', 'control', 'nativeHelper', 'validate', '$state', 'utility',
    function($rootScope, $scope, $filter, nav, control, nativeHelper, validate, $state, utility) {

        var getAgenterList = function() {
            control.showLoading();
            var params = [$rootScope.certUnderwayInfo.uniscid];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.rslt == 'success') {
                    $scope.$apply(function() {
                        $scope.agenterList = result.agenterList;
                    });
                }
                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.getAgenterList({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        getAgenterList();

        $scope.toAuthorization = function(item) {
            $state.go('authenticationApproval', {
                authorizationDetail: {
                    'srcPage': 'selectHandler',
                    name: item.name,
                    cert: item.cert,
                    mobile: item.mobile,
                    identityId: item.identityId,
                    authIdentityId: $rootScope.certUnderwayInfo.identityId,
                    uniscid: $rootScope.certUnderwayInfo.uniscid,
                    startTime: $rootScope.certUnderwayInfo.systemTime,
                    'certName': $rootScope.certUnderwayInfo.netType=="8"?$rootScope.certUnderwayInfo.certName:$rootScope.certUnderwayInfo.entName,
                    'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
                    'netType': $rootScope.certUnderwayInfo.netType,
                    'corpid': $rootScope.certUnderwayInfo.corpid,
                    'businessType':$filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType)
                }
            });
        }

//        var eventWithParameters = function() {
//            var eventCounter = new Object();
//            eventCounter.page = "选择经办人";
//            MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//        }
//        eventWithParameters();
        $scope.navigate = function(state) {
            nav.navigate(state);
        };

    }]);
})();
