(function () {
    "use strict"
    angular.module('starter')
        .controller('autoApplyInvoice', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state', 'verifyIdentity','localStorage',function ($rootScope, $scope, nav, control,
                nativeHelper, $state,verifyIdentity,localStorage) {
        var facePassState;
        var photoData='';
            
        $scope.invoice = {
            header: $rootScope.certUnderwayInfo.entName,
            taxNo: $rootScope.certUnderwayInfo.uniscid
        }
        //生成申领业务单
        $scope.confirmInvoice = function(header, taxNo) {

            if (header == '') {
                control.showPopup("发票抬头不能为空", 2000);
                return;
            }
            if (taxNo == '') {
                control.showPopup("统一信用代码不能为空", 2000);
                return;
            }
            $scope.invoice.header = header;
            $scope.invoice.taxNo = taxNo;
            
            //授权刷脸失败后，材料领证不需要刷脸
            if($rootScope.isNeedAuthFace){
                $scope.alert_applicant_info = true;
            }else{
                facePassState = '1';
                doSaveAutoAuditNetOrderInfoWithInvoice();
            }
        }

        var doSaveAutoAuditNetOrderInfoWithInvoice = function() {
            control.showLoading();
            var params = [$rootScope.autoApplyInfo.IDCardName, $rootScope.autoApplyInfo.IDCardNumber, $rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId, $rootScope.certUnderwayInfo.categoryBh, '5', $rootScope.certUnderwayInfo.netType, $rootScope.certUnderwayInfo.corpid, {
                'businessLicense': $rootScope.autoApplyInfo.businessLicensePic,
                'letter': $rootScope.autoApplyInfo.authorizationPic,
                'idCardFace': $rootScope.autoApplyInfo.IDCardFrontPic,
                'idCardBack': $rootScope.autoApplyInfo.IDCardBackPic,
                faceBase64: photoData==''?photoData:"data:image/png;base64,"+photoData
            },
            '0', $scope.invoice.header, $scope.invoice.taxNo, facePassState //人脸识别是否通过状态：0通过，1不通过
            ];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                if (result.success) {
                    var item = {
                        orderNo: result.value.orderNo,
                        payType: result.value.payType,
                        allFee: result.value.allFee,
                        entName: $scope.invoice.header,
                        lastPage: 'autoApplyInvoice',
                        facePassState: facePassState
                    };
                    $state.go('orderDetails', {
                        orderInfo: item
                    });
                }
                if (!result.success) {
                    $rootScope.OCRFailMsg = result.msg;
                    $rootScope.OCRFail();
                    //                         control.showPopup(result.msg, 2000);
                }
            }

            var failFunc = function(result) {
                control.hideLoading();
                control.showPopup(result.msg, 2000);
            };

            nativeHelper.doSaveAutoAuditNetOrderInfoWithInvoice({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        var liveDetectionError = function() {
            if (liveDetectionNum < $rootScope.materialFaceMax) {
                var template = "<div><i class='icon-tips2'></i><h3>核验失败</h3><p> 请确保本人操作或邮寄资料办理业务。 </p></div>";
                control.showConfirm3(function() {
                    facePassState = '1';
                    doSaveAutoAuditNetOrderInfoWithInvoice();
                },
                $scope.startLiveDetection, '重试', '邮寄材料', 'check-information', template);
            } else if (liveDetectionNum === $rootScope.materialFaceMax) {
                liveDetectionNum = 0;
                var template = "<div><i class='icon-tips2'></i><h3>核验失败</h3><p> 请确保本人操作或邮寄资料办理业务。 </p></div>";
                control.showConfirm3(function() {
                    facePassState = '1';
                    doSaveAutoAuditNetOrderInfoWithInvoice();
                },
                function() {
                    nav.go('home');
                },
                '返回首页', '邮寄材料', 'check-information', template);
            }
        }
            
        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
            
        //采集人脸提示
        $scope.alert_applicant_info = false;
        $scope.closeApplicantInfoAlert = function() {
            $scope.alert_applicant_info = false;
        }
        var liveDetectionNum=0;
        //开启活体静默检测
        $scope.startLiveDetectionClick = function() {
            $scope.alert_applicant_info = false;
            $scope.acShowAuthConfirm = true;
        };

        var startLiveDetection = function() {
            liveDetectionNum++;
            $scope.alert_applicant_info = false;
            verifyIdentity.startLiveDetection(liveDetectionResult);
        }

        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
            $scope.acShowAuthConfirm = false;
        }
        $scope.acIsAgreeApplyAgreement = true;
        $scope.acAgree = function() {
            $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
            var url = window.currentUrl + '/app/api/appfaceagreement';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }
        $scope.acNext = function() {
            if (!$scope.acIsAgreeApplyAgreement) {
                control.showPopup("请先阅读协议并同意", 2000);
                return;
            }
            $scope.acShowAuthConfirm = false;
            startLiveDetection();
        }

        // 验证身份和活体信息是否匹配
        var liveDetectionResult = function(res) {
            $scope.$apply(function() {
                if (res.base64PhotoData) {
                    photoData=res.base64PhotoData;
                    verifyIdentity.startIdentityAuthenticationAction($rootScope.autoApplyInfo.IDCardName, $rootScope.autoApplyInfo.IDCardNumber, res.base64PhotoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, resultFunc, $rootScope.loginInfo.realNameGrade == "1"?'0':'1');
                    facePassState = '0';
                } else {
                    authLivingFailEvent();
                    liveDetectionError();
                }
            });
        };

        var resultFunc = function(data) {
            $scope.$apply(function() {
                if (data.result == 'fail') {
                    liveDetectionError();
                }
                if (data.result == 'success') {
                 if($rootScope.loginInfo.realNameGrade=='0'){
                                       $rootScope.loginInfo.idCard=$rootScope.autoApplyInfo.IDCardNumber;
                                       $rootScope.loginInfo.realNameGrade='1';
                                       $rootScope.loginInfo.userName=$rootScope.autoApplyInfo.IDCardName;
                                       localStorage.setObject('loginInfo', $rootScope.loginInfo);
                                     }
                    facePassState = '0';
                    doSaveAutoAuditNetOrderInfoWithInvoice();
                }
            });
        }
        $scope.navigate = function(state) {
            nav.navigate(state);
        };
   }]);
})();
