﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('checkAuthorization', ['$rootScope', '$scope', 'nav', 'control', 'utility', 'validate', 'nativeHelper', function ($rootScope, $scope, nav, control, utility, validate, nativeHelper) {
            $scope.isShowPhotoRules = false;

            $scope.checkPicture = function () {
                var successFunc = function (pic) {
                    control.hideLoading();
                    $scope.$apply(function () {
                    $rootScope.autoApplyInfo.authorizationPic = 'data:image/png;base64,'+pic;
                    });
                };

                var failFunc = function (e) {
                    control.hideLoading();
                };

                control.camera(successFunc, failFunc, false);
            }

            $scope.next = function () {

                if ($rootScope.autoApplyInfo.authorizationPic == '') {
                      control.showPopup('请上传图片', 2000);
                    return;
                }


                nav.navigate('checkIdentityCard');
            }


            $scope.showPhotoRules = function () {
                $scope.isShowPhotoRules = true;
            }

            $scope.hidePhotoRules = function () {
                $scope.isShowPhotoRules = false;
            }

            $scope.navToTrust = function () {
                $rootScope.entrustTemplateParent = 'checkAuthorization';
                nav.navigate('entrustTemplate');
            }

            $scope.showPic = false;
            $scope.showPicClick = function() {
                $scope.showPic = true;
            }
            $scope.picClick = function() {
                $scope.showPic = false;
            }

            $scope.copyText =function(text) {
                var successFunc = function() {
                    control.showPopup('复制成功', 2000);
                }

                var failFunc = function() {
                    control.showPopup('复制失败', 2000);
                }

                nativeHelper.socialAgent({
                    data: [text, 1],
                    success: successFunc,
                    fail: failFunc
                });
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();