(function () {
    "use strict"

    angular.module('starter')
        .controller('businessManage', ['$rootScope', '$scope', '$ionicLoading',
            '$ionicActionSheet', '$filter', 'nav', 'control', 'localStorage',
            'nativeHelper', '$state','$stateParams','verifyIdentity', 'requestWrapper', 'md5', 'utility',
            function ($rootScope, $scope, $ionicLoading, $ionicActionSheet, $filter, nav,
                control, localStorage, nativeHelper, $state, $stateParams, verifyIdentity, requestWrapper, md5, utility ) {
                var pageNum = 1;//页码
                var showNum = 5;
                $scope.can_loadmore = true;
                $scope.isloadmore = false;
                $scope.isloading = true;
                $scope.searchInfo = { key: '' }
                $scope.selectIsValid = "";
                var curItem = null;

                // 资料更新是否需要隐藏授权书上传
                $rootScope.hideAuthUpload = false;

                $rootScope.updatePictures = {
                    businessLicensePic: '',
                    IDCardFrontPic: '',
                    IDCardBackPic: '',
                    authorizationPic: '',
                    uploadFrom: '',
                    orderNo:'',
                }

                $scope.businessInfoList = [
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '8', handleState: '7', reason: '长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差' },
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '6', handleState: '0', reason:''},
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '6', handleState: '1', reason: '' },
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '8', handleState: '2', reason: '' },
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '8', handleState: '5', reason: '' },
                ];
                var refreshBtnStatus = false;
            
            var authLivingFailEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体识别失败";
                MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
            }

                var getBusinessInfoList = function () {
                    control.showLoading();
                    refreshBtnStatus = true;
                    var timeout = setTimeout(function () {
                        refreshBtnStatus = false;
                    }, 2000);
                    var params = [$rootScope.loginInfo.accountId, $rootScope.loginInfo.mobile,
                        pageNum, showNum, $scope.searchInfo.key, $rootScope.loginInfo.idCard,$scope.selectIsValid];
                    var successFunc = function (result) {
                        control.hideLoading();
                        $scope.isloading = false;
                        $scope.can_loadmore = true;
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };
                        switch (result.success) {
                            case true:
                                $scope.$apply(function () {
                                    $scope.businessInfoList = result.value.netOrderDetailsList;
                                    $scope.recordsTotal = result.value.pagination.total;
                                });
                                break;
                            case false:
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.getBusinessInfoList({ data: params, success: successFunc, fail: failFunc });
                };

                //业务管理tab
                $('.ywgl-tab span').bind('click',function(){
                    $(this).addClass("active").siblings().removeClass("active")
                    if($(this).index() == 1){
                        //有效
                        $scope.selectIsValid = "1";
                    }else if($(this).index() == 2){
                        //无效
                         $scope.selectIsValid = "0";
                    }else {
                        //全部
                        $scope.selectIsValid = "";
                    }
                     getBusinessInfoList();
                })

                
                // 授权记录跳转 获取信用码执行搜索
                if ($stateParams.businessManageSearchKey) {
                    // 搜索条件 - 信用代码 有效
                    $scope.searchInfo.key = $stateParams.businessManageSearchKey;
                    $scope.selectIsValid = "1";
                    $('.ywgl-tab span').removeClass("active");
                    var eleArr = $('.ywgl-tab span').get();
                    if (eleArr.length > 2) {
                        eleArr[1].setAttribute("class", "active");
                    }
                }

                getBusinessInfoList();

                $scope.searchBusiness = function () {
                    pageNum = 1;
                    showNum = 5;
                    getBusinessInfoList();
                    //关闭软键盘
                    cordova.plugins.Keyboard.close();
                }

                // 检查是否需要上传资料
                var doCheckUploadPicture = function(item, state) {
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "corpid": item.corpid,
                        "proxIdNo": $rootScope.loginInfo.idCard,
                        "categoryBh": item.categoryBh,
                        "orderNo": item.orderNo
                    }
                    console.log("doCheckUploadPicture params :" + JSON.stringify(params));
                    requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            console.log('doCheckUploadPicture - result:' + JSON.stringify(result));
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if (true == result.success) {
                                if ('yes' == result.value.isUpload) {
                                    $scope.showUpdatePicAlert = true;
                                } else {
                                    doDownloadCertOp(item, state);
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        })
                        .catch(function (e) {
                            control.hideLoading();
                            console.log('网络请求失败：' + e.status);
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                }

                $scope.doUploadPic = function () {
                    $rootScope.updatePictures.uploadFrom = 'businessManage';
                    $rootScope.updatePictures.orderNo = curItem.orderNo;
                    //非个人 上传营业执照/身份证正反面
                    nav.navigate("uploadBusinessLicense");
                }

                $scope.continueBusiness = function (item, state) {
                    curItem = item;
                    if (state == 'checking') {
                        control.showPopup('正在审核中', 2000);
                        return;
                    }
                    if (state == 'orderDetails') {
                        nav.navigate(state);
                        return;
                    }
                    
                    // B01延期 B02变更 
                    if ('B01' == item.businessCode || 'B02' == item.businessCode) {
                        $rootScope.hideAuthUpload = true;
                    }

                    if (item.flag == '0') {
                        control.showPopup('该业务已失效，请重新办理', 2000);
                    } else {

                        var params = [$rootScope.loginInfo.accountId, item.certSn];
                        var successFunc = function (result) {
                            
                            console.log(JSON.stringify("judge - " + result));
                            if (result && 'B01' != item.businessCode && 'B02' != item.businessCode) {
                                // 本地有证书且不是B01延期和B02变更的业务单无需下载
                                control.showPopup('证书已下载至本设备，无需重新下载。如果证书出现了无法使用的故障，可删除证书后再重新下载。', 2000);
                            } else {
                                $rootScope.curBusinessInfo = item;

                                //封装证书新领或补办进行中所需信息
                                $rootScope.certUnderwayInfo = {
                                    entName: item.entName,
                                    category: $filter('categoryType')(item.categoryBh),
                                    businessCode: item.businessCode,
                                };
                                //if (item.businessCode == 'B01' && item.handleState == '7') {
                                //    $rootScope.certApplyNoticeParent = 'businessManage';
                                //    nav.navigate('certChange');
                                //}
                                //else {
                                //                        if ($rootScope.curBusinessInfo.keySerial != 'eztApp' && $rootScope.curBusinessInfo.isweb == '1' && state == 'downloadCert' && $rootScope.curBusinessInfo.keySerial !== $rootScope.phoneUUID) {
                                //                            control.showPopup('请使用业务申请的手机进行操作，或走证书补办流程', 2000);
                                //                            return;
                                //                        }
        
                                $rootScope.certApplyNoticeParent = 'businessManage';
                                if(state=='downloadCert'){
                                    $scope.$apply(function(){
                                        if ('HCCA_NEW' == item.caName) {
                                            doCheckUploadPicture(item, state);
                                        } else {
                                            doDownloadCertOp(item);
                                        }
                                    });
                                    return;
                                }
                                $scope.$apply(function(){
                                    nav.navigate(state);
                                });
                            }
                        }
                        var failFunc = function (e) {
                            control.showPopup(e, 2000);
                        };
                        nativeHelper.getSpecifiedCert({ data: params, success: successFunc, fail: failFunc });
                    }

                }

                var doDownloadCertOp = function (item) {
                    orderNoData=item;
                    // $scope.$apply(function(){
                        downloadBeforeJudgment(item);
                    // });
                }

                //判断当前业务单下载证书是否需要刷脸
                var downloadBeforeJudgment=function(curBusinessInfo){
                    //初始化默认值
                    $scope.isInFaceValidTime = true;
                    var curDeviceInfo=device.uuid;

//
                    //orderType = 业务单类型：0材料领证 1授权领证
                    if(curBusinessInfo.orderType == '0'){//0材料
                        //facePassState = 人脸识别是否通过状态：0通过1不通过
                        if(curBusinessInfo.facePassState=='0'){//0通过人脸，1不通过
                              //keySerial = 手机标识
                              if(curBusinessInfo.keySerial!=curDeviceInfo){
                                   //更换设备弹框提示
                                   $scope.alert_operator_info = true;
                                   $scope.operator = orderNoData.operator;
                                   $scope.operatorId = orderNoData.operatorId;
                              }else{
                                   isNeedIdentification(curBusinessInfo);
                              }
                        }else{
                            isNeedIdentification(curBusinessInfo);
                        }
                    }else{
                        //realNameGrade = 0未实名 1已实名
                        if($rootScope.loginInfo.realNameGrade == "1"){
                            //keySerial = 手机标识
                            if(curBusinessInfo.keySerial == curDeviceInfo){
                                isNeedIdentification(curBusinessInfo);
                            }else{
                                  //更换设备弹框提示
                                  $scope.alert_operator_info = true;
                                  $scope.operator = orderNoData.operator;
                                  $scope.operatorId = orderNoData.operatorId;
                            }

                            console.log("$scope.alert_operator_info - " + $scope.alert_operator_info);
                        }else{
                             $rootScope.identityAuthRootPage="businessManage";
                             nav.go('authorizationFace');
                        }
                    }

                }
                var currentTime ;//当前时间

                var isNeedIdentification = function(orderNoData) {
                    currentTime = new Date();//当前时间
                    //canReApply 是否重发
                    if (!orderNoData.canReApply || $rootScope.faceReApplyDate == null || $rootScope.faceReApplyDate == '') {
                        $state.go('downloadCert', {
                            'downloadCertInfo': orderNoData
                        });
                        return;
                    }

                    if(orderNoData.orderType == '0' && orderNoData.facePassState=='1'){
                        $state.go('downloadCert', {
                             'downloadCertInfo': orderNoData
                        });
                        return;
                    }


                    var downLoadTime = orderNoData.certDownloadTime.replace(/-/g,"/");
                    var certDownloadTime = new Date(downLoadTime);

                    if ((currentTime - certDownloadTime) >= (86400000 * $rootScope.faceReApplyDate)) {
                        var lastIdentificationTime=localStorage.get($rootScope.loginInfo.userId);
                           lastIdentificationTime = lastIdentificationTime ? lastIdentificationTime : 0;
                        if ((currentTime-new Date(lastIdentificationTime)) >= (3600000 * $rootScope.faceValidTime)) {
                            $scope.isInFaceValidTime = false;
                            $scope.alert_operator_info = true;
                            $scope.operator = orderNoData.operator;
                            $scope.operatorId = orderNoData.operatorId;

                            return;
                        }
                    }
                    $state.go('downloadCert', {
                        'downloadCertInfo': orderNoData
                    });
                }
                /**
                *初始化人脸验证弹框内信息
                **/
                 $scope.operator='';
                 $scope.operatorId='';
                 $scope.alert_operator_info=false;
                 var orderNoData='';
                 
                 var startLiveDetection = function(){
                   //人脸信息和身份信息对比结果
                   var IdentityAuthenticationRes = function(data) {
                       $scope.$apply(function() {
                           $scope.alert_operator_info = false;

//                            {"errorCode":"","rslt":"success",
                           //                "data":{"businessSerialNumber":"443C2A89112F380E41",
                           //                "authResult":"5XXX","authResultMsg":"身份信息无效","authMsg":"身份信息无效","result":"fail"},
                           //                "errorMsg":""}
                           if (data.result == 'fail') {
//                               if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//                                   control.showPopup("请核对参数信息", 2000);
//                                   return;
//                               } else control.showPopup(data.authResultMsg, 2000);

                                if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                                     control.showCustomAlert5('姓名或身份证号码有误，错误代码'+data.authResult,'check-information');
                                     return;
                                } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                                     control.showCustomAlert5('人脸比对失败，错误代码'+data.authResult,'check-information');
                                     return;
                                } else control.showPopup(data.authResultMsg, 2000);
                           }
                           if (data.result == 'success') {

                               localStorage.set($rootScope.loginInfo.userId, currentTime);
                               $state.go('downloadCert', {
                                   'downloadCertInfo': orderNoData
                               });
                               return;
                           }
                       });
                   }

                    //人脸识别结果监听
                    var liveDetectionResult = function(res) {
                        $scope.$apply(function() {
                            $scope.alert_operator_info=false;
                            if (res.base64PhotoData) {
                                verifyIdentity.startIdentityAuthenticationAction(orderNoData.operator, orderNoData.operatorId, res.base64PhotoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationRes,'0');
                                // isNeedIdentification(orderNoData); 2.5.5版本去掉了
                                return;
                            } else {
                                authLivingFailEvent();
                                control.showPopup(res.resultMsg, 2000);
                                return;
                            }
                        });
                    };
                    var eventCounter = new Object();
                    eventCounter.page = "活体检测-业务管理";
                    MobclickAgent.onEventWithParameters("authLivingBusinessManageEvent", eventCounter);
                    verifyIdentity.startLiveDetection(liveDetectionResult);
              }

              
              $scope.acShowAuthConfirm = false;
              $scope.acCloseClick = function() {
                  $scope.acShowAuthConfirm = false;
              }
              $scope.acIsAgreeApplyAgreement = true;
              $scope.acAgree = function() {
                  $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
              }
              $scope.acAgreement = function() {
                  var url = window.currentUrl + '/app/api/appfaceagreement';
                  var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                  cordova.InAppBrowser.open(url, '_blank', operation);
              }
              $scope.acNext = function() {
                  if (!$scope.acIsAgreeApplyAgreement) {
                      control.showPopup("请先阅读协议并同意", 2000);
                      return;
                  }
                  $scope.acShowAuthConfirm = false;
                  startLiveDetection();
              }


              
              $scope.startLiveDetectionClick = function() {
                $scope.acShowAuthConfirm = true;
                $scope.alert_operator_info = false;
             }

              $scope.closeApplicantInfoAlert=function(){
                $scope.alert_operator_info=false;
              }
                //获取下拉刷新数据
                $scope.doRefresh = function () {
                    pageNum = 1;
                    showNum = 5;
                    getBusinessInfoList();
                    $scope.$broadcast('scroll.refreshComplete');
                };

                //点击加载更多
                $scope.loadMore = function () {
                    if ($scope.recordsTotal > showNum) {
                        showNum = 5 + showNum;
                        getBusinessInfoList();
//                        $scope.can_loadmore = false;

                    } else {
                        $scope.isloadmore = true;
                    }
                    $scope.can_loadmore = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    return;
                };
                var refreshBtnStatus = false;
                $scope.refreshBtn = function () {
                    refreshBtnStatus = true;
                    var timeout = setTimeout(function () {
                        refreshBtnStatus = false;
                    }, 10000);
                    getBusinessInfoList();
                }
                /**
                 *
                 *缴费
                 *
                 */
                $scope.goPay = function (item) {
                if(item.orderType=='1'){
                    $state.go('orderInfoConfirm',{'orderInfo':item});
                      return;
                }
                    var item = { orderNo: item.orderNo, payType: item.payType, allFee: item.allFee, entName: item.entName, lastPage: 'businessManage',facePassState:item.facePassState };


                    $state.go('orderDetails', { orderInfo: item });
                }
                /**
                *下载电子发票
                *
                **/
                $scope.downloadInvoice = function (pdfUrl) {
                    var operation = 'location=no,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                    var url = pdfUrl;
                    //解决Safari浏览器下载文件后缀exe的问题
                    if (cordova.platformId === 'ios') {
                        url = window.currentUrl + '/app/api/fpDownload?path=' + pdfUrl;
                    }
                    cordova.InAppBrowser.open(url, '_system', operation);
                }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };


            var orderNo='';
            $scope.postTipDialog=true;

            $scope.postTip=function(item){
                $scope.postTipDialog=false;
                if(item.allFee===0){
                    $scope.mainCert=true;
                    $scope.otherCert=false;
                    orderNo=item.orderNo;
                }else{
                    $scope.mainCert=false;
                    $scope.otherCert=true;
                }
            }
            //撤销业务单
            $scope.doCancelNetOrder = function () {
                    control.showLoading();
                    var params = [orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                         $scope.postTipDialog=true;
                         $scope.mainCert=false;
                         $scope.otherCert=false;
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };
                        switch (result.success) {
                            case true:
                                $scope.$apply(function () {
                                    nav.go('applyCertSearch');
                                });
                                break;
                            case false:
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.doCancelNetOrder({ data: params, success: successFunc, fail: failFunc });
                };

                $scope.cancelClick = function () {
                    $scope.showUpdatePicAlert = false;
                }
                
                $scope.cancelPost=function(){
                    $scope.postTipDialog=true;
                    $scope.mainCert=false;
                    $scope.otherCert=false;
                }
            }]);
})();
