(function () {
    "use strict"
    angular.module('starter')
        .controller('certAgentInfo', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', '$filter', 'nativeHelper', '$ionicLoading', 'validate', function ($rootScope, $scope, nav, localStorage, control, $filter, nativeHelper, $ionicLoading, validate) {
            $scope.agentInfo = { name: '', idNum: '' };

            //材料照片存储
            $rootScope.certExamineMaterial = { idFace: '', idOpposite: '', businessLicense: '', authorization: '' };

            //        $rootScope.updateCertificatePicInfo = { idFace: '', idOpposite: '', businessLicense: '', authorization: '' };
            //        if (typeof $rootScope.curBusinessInfo !== 'undefined'){
            //            $rootScope.updateCertificatePicInfo.idFace = $rootScope.curBusinessInfo.idCardFace || '';
            //            $rootScope.updateCertificatePicInfo.idOpposite = $rootScope.curBusinessInfo.idCardBack || '';
            //            $rootScope.updateCertificatePicInfo.businessLicense = $rootScope.curBusinessInfo.businessLicense || '';
            //            $rootScope.updateCertificatePicInfo.authorization = $rootScope.curBusinessInfo.letter || '';
            //        }

            //获取图片信息
            var getUpdateMaterialPic = function () {

                control.showLoading();
                var params = [$rootScope.curBusinessInfo.orderNo];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 3000);
                        return;
                    }
                    if (result.success) {
                        $scope.$apply(function () {
                            $rootScope.updateCertificatePicInfo = {
                                idFace: result.value.idCardFace,
                                idOpposite: result.value.idCardBack,
                                businessLicense: result.value.businessLicense,
                                authorization: result.value.letter,
                                faceBase64:result.value.faceBase64
                            };
                        });
                    }
                    if (!result.success) {
                        //control.showPopup(result.msg, 3000);
                        $rootScope.updateCertificatePicInfo = {
                            idFace: "",
                            idOpposite: "",
                            businessLicense: "",
                            authorization: "",
                            faceBase64:""
                        };
                    }
                }

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 3000);
                };

                nativeHelper.getUpdateMaterialPic({ data: params, success: successFunc, fail: failFunc });
            };
            if ($rootScope.certApplyNoticeParent == 'businessManage') {
                getUpdateMaterialPic();
            }


            //从业务管理页面进入，继续办理、更新资料
            if ($rootScope.certApplyNoticeParent == 'businessManage') {
                $scope.agentInfo = { 'name': $rootScope.curBusinessInfo.operator, 'idNum': $rootScope.curBusinessInfo.operatorId };
            }

            var initiateRequest = function () {
                control.showLoading();
                var params = [$scope.agentInfo.name,
                $scope.agentInfo.idNum,
                $rootScope.loginInfo.mobile,
                $rootScope.loginInfo.accountId,
                $rootScope.certUnderwayInfo.corpid,
                $rootScope.certUnderwayInfo.categoryBh,
                $rootScope.certUnderwayInfo.businessCode];//类目编号  010：省法人数字证书
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 3000);
                        return;
                    }
                    if (result.success) {
                        //订单号
                        $scope.$apply(function () {
                            $rootScope.orderNo = result.value;
                            $rootScope.certHandMaterialParent = 'certAgentInfo';
                            nav.navigate('certExamineMaterial');
                        });
                    }
                    else {
                        control.showPopup(result.msg, 3000);
                    }
                }
                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 3000);
                };
                nativeHelper.getSaveNetOrderInfo({ data: params, success: successFunc, fail: failFunc });
            };

            var updateNetOrderInfo = function (orderNo) {

                control.showLoading();
                var params = [orderNo, $scope.agentInfo.name, $scope.agentInfo.idNum];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 3000);
                        return;
                    }

                    if (result.success) {
                        if ($rootScope.certApplyNoticeParent == 'businessManage') {
                            $rootScope.curBusinessInfo.operator = $scope.agentInfo.name;
                            $rootScope.curBusinessInfo.operatorId = $scope.agentInfo.idNum;
                            nav.navigate('updateCertificatePic');
                        } else {
                            nav.navigate('certExamineMaterial');
                        }
                    }
                    else {
                        control.showPopup(result.msg, 3000);
                    }
                };

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 3000);
                };

                nativeHelper.doUpdateNetOrderInfo({ data: params, success: successFunc, fail: failFunc });
            };

            $scope.isIdNum = function (id) {
                $scope.agentInfo.idNum = id;
            }
            $scope.certUnderwayNext = function() {
                //if ($rootScope.orderNo !== '') {
                //    updateNetOrderInfo($rootScope.orderNo);
                //    return;
                //}
                control.showLoading();
                var timeout = setTimeout(function() {
                    control.hideLoading();
                    clearTimeout(timeout) ;
                    if ($rootScope.certApplyNoticeParent == 'businessManage') {
                        if ($scope.agentInfo.name !== $rootScope.curBusinessInfo.operator || $scope.agentInfo.idNum !== $rootScope.curBusinessInfo.operatorId) {
                            updateNetOrderInfo($rootScope.curBusinessInfo.orderNo);
                        } else {
                            nav.navigate('updateCertificatePic');
                        }
                    } else {
                        if ($scope.agentInfo.name == '') {
                            control.showPopup('姓名不能为空', 2000);
                            return;
                        }
                        if ($scope.agentInfo.idNum == '') {
                            control.showPopup('身份证号码不能为空', 2000);
                            return;
                        }

                        if ($scope.agentInfo.idNum.length === 17) {
                            $scope.agentInfo.idNum += "X";
                        }
                        /**
                                     * 判断是否收费
                                     **/

                        if ($rootScope.certApplyNoticeParent == 'reissueOrGetNewCert' && $rootScope.certUnderwayInfo.businessCode == 'P012' && !$rootScope.certUnderwayInfo.isFree) {
                            $rootScope.certUnderwayInfo.operator = $scope.agentInfo.name;
                            $rootScope.certUnderwayInfo.operatorid = $scope.agentInfo.idNum;
                            nav.navigate('certExamineMaterial');
                            return;
                        } else {
                            initiateRequest();
                        }

                    }
                },
                50);
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
