﻿﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('certChange', ['$rootScope', '$scope', 'nav', 'control',
            'nativeHelper', 'validate', 'localStorage', '$state', 'requestWrapper', 'md5', 'utility', function
                ($rootScope, $scope, nav, control, nativeHelper, validate, localStorage, $state,requestWrapper, md5, utility) {

                    $rootScope.updatePictures.uploadFrom = 'certChange';
                    var needUploadPic = false;
                    $scope.showUpdatePicAlert = false;

                    var certSn = $rootScope.curManagedCert.serialNum;
                    var containerName = $rootScope.curManagedCert.containerName;
                    var canModify = false;
                    //企业信息获取
                    var doGetEntInfo = function () {
                        control.showLoading();
                        var params = [certSn, 'modify'];
                        var successFunc = function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 3000);
                                return;
                            }
                            if (result.success) {
                                console.log("doGetEntInfo:" + JSON.stringify(result));
                                $scope.$apply(function () {

                                    $scope.certName = result.value.certName;
                                    $scope.certUniscid = result.value.certUniscid;
                                    $scope.entName = result.value.entName;
                                    $scope.uniscid = result.value.uniscid;
                                    $scope.caName = result.value.caName;
                                    if($rootScope.loginInfo.idCard != null && $rootScope.loginInfo.idCard != '' && typeof $rootScope.loginInfo.idCard != 'undefined'){
                                        $scope.operator = $rootScope.loginInfo.userName;
                                        $scope.operatorId = $rootScope.loginInfo.idCard;
                                        $scope.operatorPhone = $rootScope.loginInfo.mobile;
                                    }else{
                                        $scope.operator = result.value.operator;
                                        $scope.operatorId = result.value.operatorId;
                                        $scope.operatorPhone = result.value.operatorPhone;
                                    }
                                    $scope.categoryBh = result.value.categoryBh;
                                    canModify = result.value.canModify;



                                    if ('' != $rootScope.updatePictures.businessLicensePic 
                                    && '' != $rootScope.updatePictures.IDCardFrontPic 
                                    && '' != $rootScope.updatePictures.IDCardBackPic) {
                                        needUploadPic = true;
                                        updateCert();
                                    }
                                });
                            }
                            else {
                                control.showPopup(result.msg, 3000);
                            }
                        }
                        var failFunc = function (result) {
                            control.hideLoading();
                            control.showPopup(result.msg, 3000);
                        };
                        nativeHelper.doGetEntInfo({ data: params, success: successFunc, fail: failFunc });
                    }

                    doGetEntInfo();

                //证书变更信息
                $scope.subCertChange = function () {

                    if (!canModify) {
                        control.showPopup("企业信息已为最新，无需更新！", 2000);
                        return;
                    }


                    // 是否需要判断资料齐全
                    if ("HCCA_NEW" == $scope.caName) {
                        doCheckUploadPicture();
                    } else {
                        updateCert();
                    }

                }

                var doCheckUploadPictureRes;
                // 检查是否需要上传资料
                var doCheckUploadPicture = function() {
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "corpid": $rootScope.curManagedCert.corpid,
                        "proxIdNo": $rootScope.loginInfo.idCard,
                        "categoryBh": $scope.categoryBh
                    }
                    console.log("doCheckUploadPicture params :" + JSON.stringify(params));
                    requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if (true == result.success) {
                                if ('yes' == result.value.isUpload) {
                                    doCheckUploadPictureRes = result;
                                    $scope.showUpdatePicAlert = true;
                                } else {
                                    updateCert();
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        })
                        .catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                }

                // 变更证书
                var updateCert = function() {
                    control.showLoading();
                    var handlestate = '1';
                    var netMarkingsDto = {
                        businessLicense: '',
                        idCardFace : '',
                        idCardBack : '',
                        faceBase64 : '',
                        creditNo: '',
                        businessName: ''
                    }
                    if (needUploadPic) {
                        handlestate = '5';
                        //非个人 上传营业执照/身份证正反面
                        netMarkingsDto = {
                            businessLicense: $rootScope.updatePictures.businessLicensePic,
                            idCardFace : $rootScope.updatePictures.IDCardBackPic,
                            idCardBack : $rootScope.updatePictures.IDCardFrontPic,
                            faceBase64 : '',
                            creditNo: '',
                            businessName: ''
                        }
                    }
                    var params = [
                        $scope.operator,
                        $scope.operatorId,
                        $scope.operatorPhone,
                        $rootScope.loginInfo.accountId,
                        $scope.categoryBh,
                        'B01',
                        containerName,
                        handlestate,
                        '2',
                        {
                            purItem: "证书更新"
                        },
                        netMarkingsDto,
                        certSn
                    ];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.hideLoading();
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        if (result.success) {
                            $scope.$apply(function () {
                                if (needUploadPic) {
                                    needUploadPic = false;
                                    control.showAlert1("资料提交成功，请耐心等待审核，待审核通过后，请前往“业务管理”下载证书。",function() {$state.go('certManage')}, null, null);
                                    return;
                                }
                                control.showPopup(result.msg, 3000);
                                $state.go('delayOrChangeDwnCert', {
                                    lastPage: "certChange",
                                    entName: $scope.entName,
                                    uniscid: $scope.uniscid,
                                    orderNo: result.value.orderNo,
                                    corpid: result.value.corpid,
                                    type: "modify",
                                    certId: result.value.certId,
                                    containerName: containerName
                                });
                            });
                        }
                        else {
                            control.showPopup(result.msg, 3000);
                        }
                    }
                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 3000);
                        var timeout = setTimeout(function () {
                            clearTimeout(timeout)
                            nav.navigate('certManage');
                        }, 50);
                    };
                    nativeHelper.certChangeInfo({ data: params, success: successFunc, fail: failFunc });

                }

                $scope.doUploadPic = function () {
                    needUploadPic = true;
                    
                    //非个人 上传营业执照/身份证正反面
                    nav.navigate("uploadBusinessLicense");
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

                $scope.cancelClick=function(){
                    $scope.showUpdatePicAlert = false;
                }
            }]);
})();