﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('certDelay', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'validate', '$state', 'requestWrapper', 'md5', 'utility',
            function ($rootScope, $scope, nav, control, nativeHelper, validate, $state,requestWrapper,md5, utility) {

                $rootScope.updatePictures.uploadFrom = 'certDelay';
                var needUploadPic = false;
                $scope.showUpdatePicAlert = false;

                $scope.delayAgent = { 'name': '', 'id': '' };
                var certSn = $rootScope.curManagedCert.serialNum;
                var containerName = $rootScope.curManagedCert.containerName;
                //企业信息获取
                var doGetEntInfo = function () {
                    control.showLoading();
                    var params = [certSn, 'postpone'];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        if (result.success) {
                            $scope.$apply(function () {
                                $scope.certName = result.value.certName;
                                $scope.certUniscid = result.value.certUniscid;
                                $scope.operator = result.value.operator;
                                $scope.operatorId = result.value.operatorId;
                                $scope.operatorPhone = result.value.operatorPhone;
                                $scope.isFree = result.value.isFree;
                                $scope.inService = result.value.inService;
                                $scope.fee = result.value.fee;
                                $scope.endDate = result.value.endDate;
                                $scope.corpid = result.value.corpid;
                                $scope.canModify = result.value.canModify;
                                $scope.categoryBh = result.value.categoryBh;
                                $scope.caName = result.value.caName;


                                if ('' != $rootScope.updatePictures.businessLicensePic 
                                    && '' != $rootScope.updatePictures.IDCardFrontPic 
                                    && '' != $rootScope.updatePictures.IDCardBackPic) {
                                        needUploadPic = true;
                                        doCertDely();
                                    }
                            });
                        }
                        else {
                            control.showPopup(result.msg, 3000);
                        }
                    }
                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 3000);
                        var timeout = setTimeout(function () {
                            clearTimeout(timeout)
                            nav.navigate('certManage');
                        }, 50);
                    };
                    nativeHelper.doGetEntInfo({ data: params, success: successFunc, fail: failFunc });
                }

                doGetEntInfo();


                /**
              *提示
              *
              */
                var certFeeScale = function () {

                    control.showConfirm('证书年费<p>证书年费服务期已于' + $scope.endDate + '过期请先缴纳证书年费后再办理证书相关维护业务。<p>',
                        /*
                        *【取消】按钮的后续操作
                        */
                        function () {


                        },
                        // 【知道了】按钮的后续操作
                        function () {

                            //封装证书年费所需信息
                            $rootScope.certAnnualFeeInfo = {
                                entName: $rootScope.searchResult.entName,
                                uniscid: $rootScope.searchResult.uniscid,
                                category: '',
                                categoryBh: '',
                                isFree: $scope.isFree,
                                corpid: $scope.corpid,
                                businessCode: '',
                                operator: $scope.operator,
                                operatorid: $scope.operatorId,
                                count: '',
                                parentPage: 'certDelay',
                            }
                            nav.navigate('confirmPayInfo');

                        }, '缴费', '取消', 'cusClass');
                }

                //确认
                $scope.confirmDelay = function () {

                    if (!$scope.isFree ) {
                        if (!$scope.inService) {
                            certFeeScale();
                            return;
                        }
                    }
                    console.log("scope - " + $scope.caName);
                    // 是否需要判断资料齐全
                    if ("HCCA_NEW" == $scope.caName) {
                        // 检查是否需要上传资料
                        doCheckUploadPicture();
                    } else {
                        // 不检查直接延期
                        doCertDely();
                    }
                }

                // 检查是否需要上传资料
                var doCheckUploadPicture = function() {
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "corpid": $rootScope.curManagedCert.corpid,
                        "proxIdNo": $rootScope.loginInfo.idCard,
                        "categoryBh": $scope.categoryBh
                    }
                    console.log("doCheckUploadPicture params :" + JSON.stringify(params));
                    requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };

                            if (true == result.success) {
                                if ("yes" == result.value.isUpload) {
                                    $scope.showUpdatePicAlert = true;
                                } else {
                                    doCertDely();
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        })
                        .catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                }

                // 延期
                var doCertDely = function () {
                    control.showLoading();
                    var handlestate = '1';
                    var netMarkingsDto = {
                        businessLicense: '',
                        idCardFace : '',
                        idCardBack : '',
                        faceBase64 : '',
                        creditNo: '',
                        businessName: ''
                    }
                    if (needUploadPic) {
                        handlestate = '5';
                        //非个人 上传营业执照/身份证正反面
                        netMarkingsDto = {
                            businessLicense: $rootScope.updatePictures.businessLicensePic,
                            idCardFace : $rootScope.updatePictures.IDCardBackPic,
                            idCardBack : $rootScope.updatePictures.IDCardFrontPic,
                            faceBase64 : '',
                            creditNo: '',
                            businessName: ''
                        }
                    }
                    console.log('loginInfo - ' + JSON.stringify($rootScope.loginInfo));
                    var params = [
                        $scope.operator,
                        $scope.operatorId,
                        $scope.operatorPhone,
                        $rootScope.loginInfo.accountId,
                        $scope.categoryBh,
                        'B02',
                        containerName,
                        handlestate,
                        '2',
                        {
                            purItem: "证书更新"
                        },
                        netMarkingsDto,
                        $rootScope.curManagedCert.serialNum
                    ];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        if (result.success) {
                            $scope.$apply(function () {
                                //  &scope.orderNo = result.value;
                                if (needUploadPic) {
                                    needUploadPic = false;
                                    control.showAlert1("资料提交成功，请耐心等待审核，待审核通过后，请前往“业务管理”下载证书。",function() {$state.go('certManage')}, null, null);
                                    return;
                                }
                                control.showPopup(result.msg, 3000);
                                $state.go('delayOrChangeDwnCert', {
                                    lastPage: "certDelay",
                                    entName: $scope.certName,
                                    uniscid: $scope.certUniscid,
                                    orderNo: result.value.orderNo,
                                    corpid: result.value.corpid,
                                    type: "postpone",
                                    certId: result.value.certId,
                                    containerName: containerName,
                                });
                            });
                        }
                        else {
                            control.showPopup(result.msg, 3000);
                        }
                    }
                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 3000);
                    };
                    nativeHelper.certChangeInfo({ data: params, success: successFunc, fail: failFunc });
                }

                $scope.doUploadPic = function () {
                    needUploadPic = true;
                    
                    //非个人 上传营业执照/身份证正反面
                    nav.navigate("uploadBusinessLicense");
                }
                $scope.cancelClick=function(){
                    $scope.showUpdatePicAlert = false;
                }

                //取消
                $scope.cancelDelay = function () {
                    nav.navigate('certManage');
                }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();