(function () {
    "use strict"

    angular.module('starter')
        .controller('certManage', ['$rootScope', '$scope', '$ionicLoading', '$ionicActionSheet', 'nav', 'control', 'nativeHelper', 'validate', 'utility', '$filter', '$timeout', 'url',
            function ($rootScope, $scope, $ionicLoading, $ionicActionSheet, nav, control,
                nativeHelper, validate, utility, $filter, $timeout, urlFct) {
                $rootScope.changeCertPasswordInfo = { oldPwd: '', newPwd: '', verifyPwd: '' };
                $rootScope.resetCertPasswordInfo = { tel: '', authCode: '', newPwd: '' };
                $rootScope.deleteCertInfo = { password: '' };
                $scope.searchInfo = { key: '' };
                $rootScope.certApplyNoticeParent = 'certManage';
                $scope.showLocalCertList = [];

                $scope.validCertList = [];
                $scope.invalidCertList = [];
                $scope.willInvalidCertList = [];

                $rootScope.updatePictures = {
                    businessLicensePic: '',
                    IDCardFrontPic: '',
                    IDCardBackPic: '',
                    authorizationPic: '',
                    uploadFrom: ''
                }

                var isScroll = function () {
                    var ele = angular.element(document.querySelector('ion-content'));
                    var changeEle = angular.element(document.querySelector('ion-floating-button'));
                    var timer;
                    ele.on('touchmove', function () {
                        if (timer && timer.$$state.status != 2) {
                            $timeout.cancel(timer)
                        }
                        changeEle.css('visibility', 'hidden');
                    })
                    ele.on('touchend', function () {
                        timer = $timeout(function () {
                            changeEle.css('visibility', 'visible');
                            $timeout.cancel(timer)
                        }, 300)
                    })
                }
                isScroll()

                var getCertValidity = function () {
                    var certSnList = [];
                    $rootScope.localCertList.forEach(function (v) {
                        certSnList.push(v.serialNum);
                    });
                    control.showLoading();
                    var params = [certSnList];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        };
                        if (result.success) {
                            result.value.forEach(function (c) {
                                    $rootScope.localCertList.forEach(function (l) {
                                            if (l.serialNum == c.certSn) {
                                                l.isValid = c.valid;
                                                l.operation = c.operation;
                                                l.canPostpone = c.canPostpone;
                                                l.canModify=c.canModify;
                                                l.reason = c.reason;
                                                if (typeof c.category != 'undefined') {
                                                    l.category = c.category;
                                                };
                                                if (typeof c.yearSerEnd != 'undefined') {
                                                    l.yearSerEnd = c.yearSerEnd;
                                                };
                                                l.corpid = c.corpid;

                                                l.existAnnueeFee = c.existAnnueeFee;
                                                l.refuseReason = c.refuseReason;
                                                console.log('c.existAnnueeFee -- ' + JSON.stringify(c));
                                                
                                                // 区分有效证书和失效证书
                                                if (l.isValid) {
                                                    $scope.validCertList.unshift(l);

                                                    // 筛选即将过期证书（有效期小于30天）
                                                    if (utility.judgeWillInvalidDate(l.expiryDate, 30)) {
                                                        $scope.willInvalidCertList.unshift(l);
                                                    }
                                                } else {
                                                    $scope.invalidCertList.unshift(l);
                                                }
                                            }
                                    });
                            })

                            $scope.hasCert = $rootScope.localCertList.length > 0;

//                            if (cordova.platformId === 'ios') {
//                                //  $scope.$apply(function () {
//                                $scope.showLocalCertList = $rootScope.localCertList;
//                                //                                 });
//                            }
//                            else {
                                $scope.showLocalCertList = $rootScope.localCertList.sort((a, b) => b.isValid - a.isValid);

                                if (JSON.stringify($scope.showLocalCertList) == '{}') {
                                    $scope.showLocalCertList = [];
                                }
//                            }

                            // 首页跳转 显示即将过期证书
                            if ($rootScope.showWillInvalidCert) {
                                $rootScope.showWillInvalidCert = false;
                                console.log('$rootScope.showWillInvalidCert - ' + $rootScope.showWillInvalidCert);
                                var willInvalidEle = document.getElementById('willInvalidCert');
                                willInvalidEle.setAttribute("class", "active");
                                var totalCertsEle = document.getElementById('totalCerts');
                                totalCertsEle.removeAttribute("class", "active");
                                $scope.showLocalCertList = $scope.willInvalidCertList;
                            }
                            
                        }
                        else {
                            control.showPopup(result.msg, 3000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.getCertValidity({ data: params, success: successFunc, fail: failFunc });
                };
                var getCertList = function () {
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {
                        $rootScope.localCertList = result;
                        $scope.hasCert = $rootScope.localCertList.length > 0;

//                        console.log('cert :'+JSON.stringify($rootScope.localCertList));
                        if ($rootScope.localCertList.length > 0){
                            getCertValidity();
                        }else
                            $scope.showLocalCertList=[];

                    }

                    var failFunc = function (e) {
                    };
                    nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
                }
                    getCertList();

                var deleteCert = function (curCert) {
                    // if (!validate.certPassword($rootScope.deleteCertInfo.password)) {
                    //     control.showPopup('请输入6位数字密码', 2000);
                    //     return;
                    // }

                    // if ($rootScope.deleteCertInfo.password !== curCert.password) {
                    //     control.showPopup('证书密码错误', 2000);
                    //     return;
                    // }
//                    if (!curCert.valid) {
//                        deleteCertItem(curCert);
//                        control.showPopup("证书删除成功", 2000);
//                    } else {

                        control.showLoading();
                        var params = [curCert.containerName,curCert.serialNum,curCert.SDKVersion];
                        var successFunc = function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 3000);
                                return;
                            };
                            if (result.indexOf('成功') > 0) {
//                                deleteCertItem(curCert);
                                control.showPopup(result, 2000);
                                getCertList();
                            }else{
                                control.showPopup(result, 2000);
                            }
                        }

                        var failFunc = function (error) {
                            control.hideLoading();
                        };
                        nativeHelper.deleteCert({ data: params, success: successFunc, fail: failFunc });

//                    }
                };

                var changeCertPwd = function (curCert) {
                    if (curCert.password == $rootScope.changeCertPasswordInfo.oldPwd) {
                        if (!validate.certPassword($rootScope.changeCertPasswordInfo.newPwd) || !validate.certPassword($rootScope.changeCertPasswordInfo.verifyPwd)) {
                            control.showPopup('请输入6位数字密码', 2000);
                            return;
                        }
                        if ($rootScope.changeCertPasswordInfo.newPwd == $rootScope.changeCertPasswordInfo.verifyPwd) {
                            control.showLoading();
                           var params = [curCert.containerName, $rootScope.changeCertPasswordInfo.oldPwd, $rootScope.changeCertPasswordInfo.newPwd,curCert.serialNum,curCert.SDKVersion];
                            var successFunc = function (result) {
                                control.hideLoading();
                                if (result == null || angular.equals({}, result)) {
                                    return;
                                }
                                if (result.indexOf('成功') > 0) {
                                    control.showPopup('密码修改成功', 2000);
                                    getCertList();
                                } else {
                                    control.showPopup(result, 2000);
                                }
                            }

                            var failFunc = function (error) {
                                control.hideLoading();
                            };
                            nativeHelper.changeCertPwd({ data: params, success: successFunc, fail: failFunc });
                        }
                        else {
                            control.showPopup('您输入的两次密码不相同', 2000);
                        }
                    }
                    else {
                        control.showPopup('旧密码输入错误', 2000);
                    }
                };

                var resetCertPwd = function (curCert) {
                    control.showLoading();
                    var params = [curCert.containerName, $rootScope.deleteCertInfo.password];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };

                        if (result.indexOf('成功') > 0) {
                            $rootScope.localCertList.forEach(function (v) {
                                v.data.forEach(function (item) {
                                    if (item.serialNum == curCert.serialNum) {
                                        var index = v.data.indexOf(item);
                                        v.data.splice(index, 1);
                                    }
                                })
                            });
                        }

                        control.showPopup(result, 2000);
                    }

                    var failFunc = function (error) {

                    };

                    nativeHelper.resetCertPwd({ data: params, success: successFunc, fail: failFunc });
                }

                //tab
                $('.mycert-tab span').bind('click',function(){
                    console.log('click');
                    $(this).addClass("active").siblings().removeClass("active")
                    if($(this).index() == 1) {
                        //有效
                        $scope.showLocalCertList = $scope.validCertList;
                    } else if($(this).index() == 2) {
                        //失效
                        $scope.showLocalCertList = $scope.invalidCertList;
                    } else if($(this).index() == 3) {
                        //即将过期
                        $scope.showLocalCertList = $scope.willInvalidCertList;
                    } else {
                        //全部
                        $scope.showLocalCertList = $rootScope.localCertList;
                    }
                    $scope.$apply();
                })


                $scope.copyText =function(text) {
                    var successFunc = function() {
                        control.showPopup('复制成功', 2000);
                    }

                    var failFunc = function() {
                        control.showPopup('复制失败', 2000);
                    }

                    nativeHelper.socialAgent({
                        data: [text, 1],
                        success: successFunc,
                        fail: failFunc
                    });
                }
    		/**
                *证书变更
                **/
                $scope.certModify=function(currentCert){
                      if(!currentCert.isValid){
                         return;
                      }
                      if (currentCert.canModify) {
                           $rootScope.curManagedCert = currentCert;
                           nav.navigate('certChange');
                      } else {
                           control.showPopup(currentCert.reason, 2000);
                      }
                }

                /**
                *证书延期
                **/
                $scope.certDelay= function(currentCert){
                    if (currentCert.canPostpone) {
                        $rootScope.curManagedCert = currentCert;
                        nav.navigate('certDelay');
                    } else {
                        control.showPopup(currentCert.reason, 2000);
                    }
                }
                //证书管理操作
                $scope.certManage = function (entName, curCert, orgCode) {
                    if (curCert.isValid) {
                        var manageList = [
                            { text: '修改密码' },
                            //{ text: '重置密码' },
                            { text: '删除证书' },
                            { text: '证书变更' },
                            { text: '证书延期' },
                        ]
                        if ('省法人数字证书' == curCert.category) {
                            manageList.push({ text: '印章管理' });
                        }
                    } else if (!curCert.isValid) {
                        var manageList = [
                            { text: '删除证书' },
                            { text: '证书延期' },
                        ]
                    };

                    var hideSheet =$ionicActionSheet.show({
                        buttons: manageList,
                        titleText: '',
                        //cancelText: '取消',
                        // 新增自定义样式
                        cssClass: 'myionic-sheet',
                        buttonClicked: function (index) {
                            if (!curCert.isValid) {
                                switch (index) {
                                    case 0:
                                        if (curCert.SDKVersion !== "V2") {
                                            hideSheet();
                                            control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                                            function() {
                                                $scope.navigate("businessManage");
                                                return;
                                            },
                                            function() {},
                                            "取消", "去业务管理", 'cusClassTbtx');
                                            return;
                                        }
                                        $rootScope.deleteCertInfo = {
                                            password: '',
                                        };
                                        control.showCustomPopup('html/certManage/popupDeleteCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () {
                                            return;
                                        }, function () {
                                            deleteCert(curCert);
                                        });
                                        return true;
                                        break;
                                    case 1:
                                          $scope.certDelay(curCert);
                                        break;
                                }

                            } else {
                                switch (index) {
                                    case 0:
                                        if (curCert.SDKVersion !== "V2") {
                                            hideSheet();
                                            control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                                            function() {
                                                $scope.navigate("businessManage");
                                                return;
                                            },
                                            function() {},
                                            "取消", "去业务管理", 'cusClassTbtx');
                                            return;
                                        }
                                        $rootScope.changeCertPasswordInfo = {
                                            oldPwd: '',
                                            newPwd: '',
                                            verifyPwd: ''
                                        };
                                        control.showCustomPopup('html/certManage/popupChangePassword.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () {
                                            return;
                                        }, function () {
                                            changeCertPwd(curCert);
                                            return;
                                        });
                                        return true;
                                        break;
                                    case 1:
                                        if (curCert.SDKVersion !== "V2") {
                                            hideSheet();
                                            control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                                            function() {
                                                $scope.navigate("businessManage");
                                                return;
                                            },
                                            function() {},
                                            "取消", "去业务管理", 'cusClassTbtx');
                                            return;
                                        }
                                        $rootScope.deleteCertInfo = {
                                            password: '',
                                        };
                                        control.showCustomPopup('html/certManage/popupDeleteCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () {
                                            return;
                                        }, function () {
                                            deleteCert(curCert);
                                        });

                                        return true;
                                        break;
                                    case 2:
                                       $scope.certModify(curCert);
                                        break;
                                    case 3:
                                       $scope.certDelay(curCert);
                                        break;
                                    case 4:
                                        $scope.stampManage(curCert);
                                        break;
                                }
                            }
                        }
                    });
                };
                $scope.addCert = function () {
                    $rootScope.subjectQueryRoute = 'certManage';
                    nav.navigate('applyCertSearch');
                }
                //续费
                $scope.navCertDelay = function (curCert) {
                    
                    if (2 == curCert.existAnnueeFee) {
                        control.showPopup(curCert.refuseReason, 3000);
                        return;
                    }

                    $rootScope.certAnnualFeeInfo = {
                        entName: curCert.entName,
                        uniscid: curCert.orgCode,
                        operator: '',
                        cardId: '',
                        parentPage: 'certManage',
                        corpid: curCert.corpid,
                    };
                    nav.navigate('confirmPayInfo');
                }

                /**
                 * 搜索证书
                 */

                $scope.searchCert = function () {
                    if ($scope.searchInfo.key == '') {
                        $scope.showLocalCertList = $rootScope.localCertList;
                        return;
                    }
                    $scope.showLocalCertList = $filter('filter')($rootScope.localCertList, $scope.searchInfo.key);
                    //关闭软键盘
                    cordova.plugins.Keyboard.close();

                }


                // 印章管理
                $scope.stampManage = function(curCert) {
                    var certBase64 = utility.URLEncode(curCert.certContent);
                    var url = urlFct.generate('', 'stampUrl') + 'tyyz/zlb/company/sealmanage/sealImgList?certBase64=' + certBase64;
                    console.log('stampManage' + url);
                    var operation = 'hidenavigationbuttons=no,leftbackclose=yes,location=no,toolbar=yes,toolbarposition=top,customertitle=印章管理';
                    cordova.InAppBrowser.open(url, '_blank', operation);
                }

                //查询年报状态
                $scope.checkYearReportStatus= function (curCert) {
                                    control.showLoading();
                                    var params = [curCert.serialNum];
                                    var successFunc = function (result) {
                                        control.hideLoading();
                                        if (result == null || angular.equals({}, result)) {
                                            control.showPopup('服务出错啦', 2000);
                                            return;
                                        };

                                        if (result.success) {
//                                            $scope.reportStatus=result.value;
                                            control.showPopup(result.value.text, 2000);
                                        }else
                                            control.showPopup(result.msg, 2000);
                                    }

                                    var failFunc = function (error) {
                                        control.showPopup(error.msg, 2000);
                                    };

                                    nativeHelper.getYearReportStatus({ data: params, success: successFunc, fail: failFunc });
                                }
//                console.log('cert :'+JSON.stringify($rootScope.localCertList));

                    $scope.showAddCert=true;
                    $scope.getBlur=function(){
                               $scope.showAddCert=true;
                               if($scope.searchInfo.key == '')
                                $scope.showLocalCertList = $rootScope.localCertList;
                           }
                           $scope.getFocus=function(){
                               $scope.showAddCert=false;
                           }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

            }]);
})();
