﻿(function () {
    "use strict"

    angular.module('starter')
        .controller('useBusinessLicense', ['$rootScope', '$scope', '$stateParams', 'nav',
         'nativeHelper', 'control','$interval',
         function ($rootScope, $scope, $stateParams, nav, nativeHelper, control,$interval) {

            $scope.businessLicense = { password: '', qRCode: '' };
            
            $scope.imgBase64 = $stateParams.imgBase64;
            $scope.showBusinessLicense = false;

            var timeout=null;
            /**
            * 获取二维码
            * $interval
            * */
            var getBusinessLicQRCode = function () {
                control.showLoading();
                var params = [
                    $rootScope.id,
                    $scope.businessLicense.password,
                ];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) { return; }
                    switch (result.rslt) {
                        case 'success':
                            $scope.businessLicense.qRCode = 'data:image/png;base64,' + result.picdata;
                            timeout=result.timeout;
                            $scope.showBusinessLicense = true;
                            break;
                        case 'fail':
                            control.hideLoading();
                            control.showPopup(result.errorMsg, 2000);
                            break;
                    }
                };

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };

                nativeHelper.getBusinessLicQRCode({ data: params, success: successFunc, fail: failFunc });
            }

            /**
            *定时器
            **/
            $rootScope.timer = $interval(function () { }, 25*1000*60);
             $rootScope.timer.then(success, error, notify);
               function success() {

                             }
                             function error() {

                             }
                             function notify() {
                                getBusinessLicQRCode();
                             }
            $scope.checkCipher = function (password) {
                if (password == "") {
                    control.showPopup('请输入电子营业执照密码！', 2000);
                    return;
                }

                getBusinessLicQRCode();
            }
              $scope.pushQRCode=function(){
               getBusinessLicQRCode();
              }
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
