(function () {
    "use strict"

    angular.module('starter')
        .controller('home', ['$rootScope', '$scope', '$state', 'nav', 'nativeHelper', 'localStorage',
            'control', 'utility', '$timeout', '$ionicLoading', 'verifyIdentity', '$stateParams', 'requestWrapper',
            function ($rootScope, $scope, $state, nav, nativeHelper, localStorage, control, utility,
                $timeout, $ionicLoading, verifyIdentity, $stateParams, requestWrapper) {
                $rootScope.isNeedAuthFace = true;
                $rootScope.recordType = '1';
                
                
            // 预警通知
            var sendAlertMsg = function (err) {
                $ionicLoading.hide();
                control.showPopup(err.errMsg, 2000);
                requestWrapper.sendMesToDingTalk("密码模块错误", "", err.errMsg);
            }
            if (!window.broadcaster.channelExists("sendAlertMsg")) {
                window.broadcaster.addEventListener("sendAlertMsg", sendAlertMsg);
            }

            var noMentionToday = function() {
                let storeDateStr = localStorage.get('noMentionToday');
                return storeDateStr == utility.todayDate()
            }
            var isNoMentionToday = noMentionToday();
            $rootScope.agreement = function(type) {
                var url = window.currentUrl + '/app/api/' + type;
                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
            
                $scope.banners=[
                                { bannerPath: 'img/Advertising/home_banner_one.png',
                                  bannerUrl:''},
                                { bannerPath: 'img/Advertising/home_banner_three.png',
                                  bannerUrl:''},
                                { bannerPath: 'img/Advertising/home_banner_credit.png',
                                  bannerUrl:''}
                                ]
                   var setDefaultConfigInfo = function () {
                       if (!$rootScope.configInfo) {
                           $rootScope.configInfo = {
                               notice: {
                                   noticeTitle: 'e照通申领移动证书，快!好！省!',
                                   noticeUrl: ''
                               },
//                               banners: [
//                                   {
//                                     bannerUrl: '',
//                                     bannerPath: 'img/Advertising/home-banner01.jpg'
//                                   }
//                               ],
                               ocrAppId: '1106835427',
                               ocrAppKey: 'Nz4rzhucmXq5SMkf',
                               faceRecognition: '0',
                           };
                       }

                   };
                    setDefaultConfigInfo();

                    $rootScope.authFaceMax=3;//授权领证刷脸次数
                    $rootScope.materialFaceMax=3;//材料领证刷脸次数
                    $rootScope.riseLevelFaceMax=3;//提升实名等级刷脸次数

                    $rootScope.faceReApplyDate=null;//重新制证需要刷脸日期（天）
                    $rootScope.faceValidTime=30;//刷脸成功后的有效时间（小时）

                    $rootScope.SDKVersion="V2";//密码模块版本
                      //首页通知弹框
                      $rootScope.showHomePopup = true;
                      var showPopout = function () {
                          if ($rootScope.configInfo.popout && $rootScope.configInfo.popout !== null && $rootScope.configInfo.popout !== '' && $rootScope.showHomePopup) {
                              control.showCustomAlert('test', 'html/home/popupHomeNotice.html', '知道了', 'popup-btn-positive', function () { return; });
                              $rootScope.showHomePopup = false;
                          }
                      }


                // 是否显示有证书即将到期的提示
                $scope.showCertAlert = false;

                var getCertValidity = function () {
                    var certSnList = [];
                    $rootScope.localCertList.forEach(function (v) {
                        certSnList.push(v.serialNum);
                    });
                    control.showLoading();
                    var params = [certSnList];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        };
                        if (result.success) {
                            result.value.forEach(function (c) {
                                $rootScope.localCertList.forEach(function (l) {
                                    if (l.serialNum == c.certSn) {
                                        l.isValid = c.valid;
                                        l.operation = c.operation;
                                        l.canPostpone = c.canPostpone;
                                        l.canModify=c.canModify;
                                        l.reason = c.reason;
                                        if (typeof c.category != 'undefined') {
                                            l.category = c.category;
                                        };
                                        if (typeof c.yearSerEnd != 'undefined') {
                                            l.yearSerEnd = c.yearSerEnd;
                                        };
                                        l.corpid = c.corpid;
                                        l.existAnnueeFee = c.existAnnueeFee;
                                        l.refuseReason = c.refuseReason;
                                        // 即将过期的证书
                                        if (l.isValid
                                            && utility.judgeWillInvalidDate(l.expiryDate, 30)
                                            ) {
                                            // 有即将过期的证书 显示提示
                                            $scope.showCertAlert = true;
                                        }
                                    }
                                });
                            })
                        } else {
                            control.showPopup(result.msg, 3000);
                        }

                        if ($scope.showCertAlert) {
                            control.showCustom4Popup('html/home/homeConfirmPopup.html');
                            return;
                        }
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };
                    nativeHelper.getCertValidity({ data: params, success: successFunc, fail: failFunc });
                };

                var getCertList = function () {
                    console.log(isNoMentionToday);
                    if (isNoMentionToday) {
                        return;
                    }
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {
                        $rootScope.localCertList = result;
                        $scope.hasCert = $rootScope.localCertList.length > 0;
                        if ($rootScope.localCertList.length > 0){
                            getCertValidity();
                        }
                    }
                    var failFunc = function (e) { };
                    nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
                }


                   var getConfigInfo = function () {
                       var successFunc = function (result) {
                          if (result == null || angular.equals({}, result)) {
                                 control.showPopup('获取系统配置信息失败', 2000);
                                  return;
                          }
                          console.log('result - ' + JSON.stringify(result));
                          if (result.success === "true") {
                                  $rootScope.configInfo = result;
                                  $rootScope.authFaceMax=parseInt(result.authFaceMax);//授权领证刷脸次数
                                  $rootScope.materialFaceMax=parseInt(result.materialFaceMax);//材料领证刷脸次数
                                  $rootScope.riseLevelFaceMax=parseInt(result.riseLevelFaceMax);//提升实名等级刷脸次数

                                 $rootScope.faceReApplyDate=result.faceReApplyDate==null?result.faceReApplyDate:parseInt(result.faceReApplyDate);//重新制证需要刷脸日期（天）
                                 $rootScope.faceValidTime=result.faceValidTime;//刷脸成功后的有效时间（小时）

                                 $rootScope.SDKVersion=result.SDKVersion;//密码模块版本
                                 $rootScope.expirdShow = result.expirdShow;
                                 // expirdShow为1可以显示证书即将过期弹窗
                                 if ("1" == result.expirdShow) {
                                    // 获取证书列表 判断是否有即将过期证书
                                    // $rootScope.noAlert用于控制app打开只弹窗1次
                                    if (!$rootScope.noAlert) {
                                        getCertList();
                                        $rootScope.noAlert = true;
                                    }
                                 }
                          }
                          else {
                                  control.showPopup(result.msg, 2000);
                          }

                       };

                       var failFunc = function (error) {
                         control.showPopup('获取系统配置信息失败002-'+error.errorMsg, 2000);
                       };

                       nativeHelper.getConfigInfo({ data: [], success: successFunc, fail: failFunc });
                   }
                getConfigInfo();

//                $scope.repeatDone = function () {
//                    $ionicSlideBoxDelegate.update();
//                    //$ionicSlideBoxDelegate.slide($rootScope.configInfo.banners.length - 1, 1);
//                }


                $rootScope.searchRecord = { 'key': '' };
                $rootScope.loginInfo = localStorage.getObject('loginInfo');

               $scope.localCertList = localStorage.getObject($rootScope.loginInfo.accountId);
               if (JSON.stringify($scope.localCertList) == '{}') $scope.localCertList = [];
//                var oldLocalCertList = localStorage.getObject($rootScope.loginInfo.mobile);
//                if (oldLocalCertList && JSON.stringify(oldLocalCertList) != '{}') {
//                    for (var i = 0; i < oldLocalCertList.length; i++) {
//                        $rootScope.localCertList.push(oldLocalCertList[i]);
//                    }
//                    localStorage.deleteItem($rootScope.loginInfo.mobile);
//                    localStorage.setObject($rootScope.loginInfo.accountId, $rootScope.localCertList);
//                }


                var loadLocalCertListData=function(){
                    control.showTitleLoading("证书数据迁移中请勿退出...");
                    var params = [$rootScope.loginInfo.accountId,$scope.localCertList];
                                        var successFunc = function (result) {
                                            control.hideLoading();
                                            localStorage.setObject("backupCertInfo",$scope.localCertList)
                                            localStorage.deleteItem($rootScope.loginInfo.accountId);
                                        }

                                        var failFunc = function (error) {
                                            control.hideLoading();
                                            control.showPopup(error, 2000);
                                        };

                                        nativeHelper.loadLocalCertListData({ data: params, success: successFunc, fail: failFunc });
                }
                if(cordova.platformId === 'android')
                    loadLocalCertListData();

                //订单号
                $rootScope.orderNo = '';


                var openApplication = function () {
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {
                        $rootScope.phoneUUID = result.UUID;
                        $rootScope.appVersion = result.version;
                        //$rootScope.deviceModel = result.deviceModel;//机型
                    }

                    var failFunc = function (error) {
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.openApplication({ data: params, success: successFunc, fail: failFunc });
                };

                openApplication();

                utility.checkUpdate();



                $scope.isHiddenToday = false;
                $rootScope.hiddenToday = function () {
                    $scope.isHiddenToday = !$scope.isHiddenToday;
                    var checkEle = document.getElementById('check-mention');
                    if ($scope.isHiddenToday) {
                        checkEle.setAttribute('class', 'check-selected');
                    } else {
                        checkEle.setAttribute('class', 'check-default');
                    }
                }
                $rootScope.lClick = function () {
                    if ($scope.isHiddenToday) {
                        localStorage.set('noMentionToday', utility.todayDate());
                    }
                    control.hideCustomPopup();
                }
                $rootScope.rClick = function () {
                    if ($scope.isHiddenToday) {
                        localStorage.set('noMentionToday', utility.todayDate());
                    }
                    control.hideCustomPopup();
                    $rootScope.showWillInvalidCert = true;
                    nav.navigate('certManage');
                }
            
                //扫一扫
                $scope.scanQRcode = function () {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    //                    if ($rootScope.localCertList.length <= 0) {
                    //                        control.showPopup('请下载证书后使用', 2000);
                    //                        return;
                    //                    };

                    var params = [];
                    var successFunc = function (result) {
                    }
                    var failFunc = function (error) {
                        control.showPopup(error.msg, 2000);
                    };
                    nativeHelper.navToScanView({ data: params, success: successFunc, fail: failFunc });
                };

                var showLocalCertList = function (e) {
                    $scope.$apply(function () {
                        if (e.scanResult.indexOf("type") == -1) {
                            control.showPopup(e.scanResult, 2000)
                        } else {
                            var scanResult = JSON.parse(e.scanResult);
                            $rootScope.curQRCodeInfo = scanResult;
                            if (scanResult.type == 'elicense') {
                                nav.navigate('businessLicDiscern');
                                return;
                            }
//                            nav.go('scanPrompt');
//                            alert(e.scanResult);
                            console.log("version - " + scanResult.versions);
                            (typeof(scanResult.versions) == "undefined" || scanResult.versions == "1") ? nav.go('showLocalCertList') : nav.go('scanPrompt');
//                            nav.navigate('showLocalCertList');
                        }
                    });
                };

                window.broadcaster.addEventListener("showLocalCertList", showLocalCertList);
            /**
            *三方调用授权中心
            **/
//              var openAuthorizationCenter = function (e) {
//                $scope.$apply(function () {
//                                    nav.navigate('authorityCenter');
//                                          });
//                        };

//                window.broadcaster.addEventListener("openAuthorizationCenter", openAuthorizationCenter);

                $scope.navToQuery = function (target) {
                    $rootScope.subjectQueryRoute = "home";
                    nav.navigate(target);
                }

                $scope.advertisingClick = function (url) {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    if (url.indexOf('http') !== -1) {
                        var operation = 'location=no,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                        cordova.InAppBrowser.open(url, '_system', operation);
                    }
                };


                $scope.navigate = function (state) {
                    nav.navigate(state);

                };

                $scope.navToAuth = function () {
                    var params = [];
                    var successFunc = function (result) {

                    }

                    var failFunc = function (error) {
                        control.showPopup(error.msg, 2000);
                    };
                    nativeHelper.navToAuthView({ data: params, success: successFunc, fail: failFunc });
                }

                $scope.customerService = function () {
                    var url = 'https://ics.idinfo.cn/IntelQA/login/getUserInfo.action?loginName=' + $rootScope.loginInfo.mobile;
                    var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                    cordova.InAppBrowser.open(url, '_blank', operation);
                }
                $rootScope.navToHome = function () {
                    var confirm = function () {
                        $rootScope.isNeedAuthFace = true;
                        nav.navigate('home');
                    };
                    var cancel = function () { };

                    control.showConfirm('确认返回首页', confirm, cancel);
                };
        //    PushAgent.addTag( function(r){displayjson(r);},'aaa')

//本地分享 6：MSM
//                      SocialAgent.directShare( function(r){alert('' +r);},
//                       'des share',
//                       'https://mobile.umeng.com/images/pic/home/social/img-1.png',
//                      'http://www.umeng.com',
//                      'umeng',
//                      6)

        //自定义事件
//                    var eventWithParameters=function () {
//                        var eventCounter = new Object();
//                        eventCounter.page = "首页";
//                        MobclickAgent.onEventWithParameters("TextEvent", eventCounter);
//                    }
//                    eventWithParameters();


                    //中转友盟消息页面跳转
                     var openUmengNotificationPath = function (e) {
                                        $scope.$apply(function () {
                                                nav.navigate('messageCenter');

                                        });
                                    };

                                    window.broadcaster.addEventListener("openUmengNotificationPath", openUmengNotificationPath);

                     //检查是否存在未读消息
                     var checkUnreadNotification=function(){
//                                            control.showLoading();
                                                 var params = [$rootScope.loginInfo.mobile];
                                                 var successFunc = function(result) {
                                                     control.hideLoading();
                                                     if (result == null || angular.equals({},
                                                     result)) {
                                                         control.showPopup('服务出错啦', 3000);
                                                     }
                                                     if (result.rslt == 'success') {
                                                        $scope.unread=result.data.unread=="1";
                                                     }

                                                     if (result.rslt == 'fail') {
//                                                         control.showPopup(result.errorMsg, 2000);
                                                     }
                                                 }
                                                 var failFunc = function(error) {
//                                                     control.hideLoading();
//                                                     control.showPopup(error.msg, 2000);
                                                 };
                                                 nativeHelper.checkUnreadNotification({
                                                     data: params,
                                                     success: successFunc,
                                                     fail: failFunc
                                                 });
                     }
                     //功能取消
//                     checkUnreadNotification();


                     var path=$stateParams.pagePath;
                                     if(path=="messageCenter"){
                                     checkUnreadNotification();
                }

                $scope.accountClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }
                    nav.navigate('account');
                }

                $scope.applyCertSearchClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    nav.navigate('applyCertSearch');
                }

                $scope.messageCenterClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    nav.navigate('messageCenter');
                }

                $scope.searchClick = function () {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    $scope.navToQuery('applyCertSearch');
                }

                $scope.certClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }
                    nav.navigate('certManage');
                }

                $scope.recordClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }
                    nav.navigate('authorizationRecord');
                }

                $scope.businessManageClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    nav.navigate('businessManage');
                }

                $scope.manageAccountClick = function() {
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    nav.navigate('account');
                }

                $scope.forIdentityAuth=function(){
                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return;
                    }

                    if ($rootScope.loginInfo.realNameGrade == "1") {
                        control.showPopup('您已是高级实名用户', 3000);
                        return;
                    }
                    $rootScope.identityAuthRootPage="home";
                    nav.go('authorizationFace');
                }
                var firstOpen=localStorage.get('isFirstOpen');
                if(!firstOpen){
                       control.showCustom4Popup('html/home/popupHomeTip.html');
                }
                $rootScope.hide=function(){
                    localStorage.set('isFirstOpen', true);
                    control.hideCustomPopup()
                }
                $rootScope.cancelOnClick=function(){
                       control.hideCustomPopup()
                       return;
                }
                $scope.ordinaryToQuery=function(){

                    if (!$rootScope.loginInfo.userId) {
                        nav.navigate('signIn');
                        return
                    }


                     control.showCustomPopup('html/home/popupApplyTip.html', '', '继续材料领证', '我要授权领证', 'popup-btn-default', 'popup-btn-light', function () { $scope.navToQuery('subjectQuery'); }, function () {
                           $scope.navToQuery('applyCertSearch')
                     });
                }
            }]);
})();
