﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('payCertApplyInvoice', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state', function ($rootScope, $scope, nav, control,
                nativeHelper, $state) {

                $scope.invoice = { header: $rootScope.certUnderwayInfo.entName.replace(/\(副本.*?\)/g,''), taxNo: $rootScope.certUnderwayInfo.uniscid }
                //生成业务单
                $scope.confirmInvoice = function (header, taxNo) {

                    if (header == '') {
                        control.showPopup("发票抬头不能为空", 2000);
                        return;
                    }
                    if (taxNo == '') {
                        control.showPopup("统一信用代码不能为空", 2000);
                        return;
                    }
                    control.showLoading();
                    var params = [$rootScope.certUnderwayInfo.operator,
                    $rootScope.certUnderwayInfo.operatorid,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.accountId,
                    $rootScope.certUnderwayInfo.corpid,
                    $rootScope.certUnderwayInfo.categoryBh,
                    $rootScope.certUnderwayInfo.netType,
                    {
                        'idCardFace': $rootScope.certExamineMaterial.idFace,
                        'idCardBack': $rootScope.certExamineMaterial.idOpposite,
                        'businessLicense': $rootScope.certExamineMaterial.businessLicense,
                        'letter': $rootScope.certExamineMaterial.authorization
                    },
                        header,
                        taxNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.success) {
                            var item = {
                                orderNo: result.value.orderNo, payType: result.value.payType, allFee: result.value.allFee,
                                entName: $scope.header, lastPage: 'payCertApplyInvoice'
                            };
                            $state.go('orderDetails', { orderInfo: item });
                        }
                        if (!result.success) {
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.doSaveNetOrderInfoWithInvoice({ data: params, success: successFunc, fail: failFunc });

                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();