(function() {
    "use strict"
    angular.module('starter')
    .controller('signConversation', ['$rootScope', '$scope', 'nav', 'control','$stateParams','nativeHelper','validate','$interval','$ionicPopup','$timeout',
    function($rootScope, $scope, nav, control,$stateParams,nativeHelper,validate,$interval,$ionicPopup,$timeout) {

        $scope.certInfo = $stateParams.cert;
        $rootScope.stop;
        $scope.isSign=false;
        $scope.isStopConversation=false;
        $scope.passAlert = false;  //密码输入框
        $scope.msgAlert = false;  //消息弹框

        var showPasswordPopup = function(){
//            $rootScope.localCert = {
//                useCertPwd: ''
//            };
//            control.showCustomPopup('html/home/popupUseCert.html', '', '中止签章', '确认', 'popup-btn-default', 'popup-btn-light',
//            function() {
//                $scope.stopConversation();
//                return;
//            },
//            function() {
//                $scope.confirmPwd($scope.certInfo);
//            })
            $scope.$apply(function () {
                $rootScope.localCert = { useCertPwd: ''};
                $scope.passAlert = true;
            });
        }

        var showSuccessPopup = function () {
            $scope.$apply(function () {
                $scope.msgAlert = true;
                $timeout(function () {
                    $scope.msgAlert = false;
                }, 2000);
            });
        };

        var getDate=function() {
            var date = new Date();
            date.setDate(date.getDate() + 0);
            var y = date.getFullYear();
            var m = date.getMonth() + 1;
            var d = date.getDate();

            var h = date.getHours();
            var ms = date.getMinutes();
            var s = date.getSeconds();

              m=checkTime(m);
              d=checkTime(d);
              ms = checkTime(ms);
              s = checkTime(s);
            return y + "-" + m + "-" + d+ " " + h+ "-" + ms+ "-" + s;
        }

        var checkTime=function (i) {
            if (i < 10) {
                i = "0" + i;
            }
            return i;
        }

       $scope.conversationTipInfo=[{"time":getDate(),"operation":"开始会话","conversationContent":"政采云招投标客户端发起会话请求"}];

       var getSignList = function(isFirst) {
           var params = [$rootScope.curQRCodeInfo.businessAppId, $scope.certInfo.serialNum,isFirst];
           var successFunc = function(result) {
               if (result == null || angular.equals({},result)) {
                   startPolling();
                   return;
               }

               if (result.rslt == "success") {
                   if (result.signList.length > 0) {
                       $rootScope.curQRCodeInfo.type = result.signList[0].type;
                       $rootScope.curQRCodeInfo.uuid = result.signList[0].uuid;
                       $rootScope.curQRCodeInfo.reqData = result.signList[0].reqData;

                       //密码弹窗
                       showPasswordPopup();
                   }else{
                       startPolling();
                   }
               } else {
                  startInterval();
               }
           }

           var failFunc = function(e) {
             startPolling();
           };

           nativeHelper.getSignList({
               data: params,
               success: successFunc,
               fail: failFunc
           });
       }

        getSignList("1");

        var startPolling=function(){
            $rootScope.stop = $interval(function() {
                getSignList("0");
                $interval.cancel($rootScope.stop);
            },
            4000);
        }

        $scope.confirmPwd = function(curCert) {
            $scope.passAlert = false;

            if (!validate.certPassword($rootScope.localCert.useCertPwd)) {
                control.showPopup("请输入6位数字密码！", 2000, showPasswordPopup);
            }else if ($rootScope.localCert.useCertPwd !== curCert.password) {
                control.showPopup("证书密码不正确！", 2000, showPasswordPopup);
            }else{
                $scope.isSign=true;
                startUploadinfo(curCert);
            }
        }
        
        var signEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "扫码签名";
            MobclickAgent.onEventWithParameters("signEvent", eventCounter);
        }
    
        var signUploadEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "签名上传";
            MobclickAgent.onEventWithParameters("signUploadEvent", eventCounter);
        }

        var startUploadinfo=function(curCert){
            control.showLoading();
            signEvent();//监听扫码签名

            //param1:二维码扫描结果
            //param2:选中证书对应的容器
            //param3:证书base64,与对应容器里到处的校验下是否一致
            //param4:用户输入的证书使用密码（容器PIN码）
            var params = [$rootScope.curQRCodeInfo, curCert.containerName, curCert.certContent, $rootScope.localCert.useCertPwd,curCert.SDKVersion, $rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, curCert.serialNum, curCert.encSerialNum,$rootScope.loginInfo.accountId,$rootScope.loginInfo.mobile, curCert.uniscid];
            console.log(params);
             var successFunc = function(result) {
                $rootScope.localCert = {
                    useCertPwd: ''
                };
                startPolling();
                control.hideLoading();
                 
                if (result == null || angular.equals({}, result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                 
                signUploadEvent();//上传监听

                if (result.rslt == 'success') {
                    var newSignData={"time":getDate(),"operation":"继续会话","conversationContent":"汇信签章完成政采云标书签章"};
                    $scope.conversationTipInfo.push(newSignData);
                    showSuccessPopup();
                    $scope.isSign=false;
                } else {
                    control.showPopup(result.errorMsg, 2000, showPasswordPopup);
                }

            };
            var failFunc = function(result) {
                control.hideLoading();
//                            startPolling();
                control.showPopup(result.errorMsg, 2000,showPasswordPopup);
            };

            setTimeout(function () {
                nativeHelper.uploadinfo({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }, 1000);
        }

        $scope.stopConversation=function(){
            $scope.passAlert = false;
            control.showLoading();
            //param1:二维码扫描结果
            //param2:选中证书对应的容器
            //param3:证书base64,与对应容器里到处的校验下是否一致
            //param4:用户输入的证书使用密码（容器PIN码）
            var params = [$rootScope.curQRCodeInfo.uuid];
            console.log(params);
             var successFunc = function(result) {
                $rootScope.localCert = {
                    useCertPwd: ''
                };
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }

            if (result.rslt == 'success') {
                control.showPopup('签章中止', 2000);
                $scope.isStopConversation=true;
            } else {
                startPolling();
                control.showPopup(result.errorMsg, 2000);
            }

            };
            var failFunc = function(result) {
                control.hideLoading();
                startPolling();
                control.showPopup(result.msg, 2000);
            };

            nativeHelper.invalidationQrCode({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        $scope.navigate = function(state) {
            if (angular.isDefined($rootScope.stop)) {
                $interval.cancel($rootScope.stop);
                $rootScope.stop = undefined;
            }
            nav.go(state);
        };
    }]);
})();
