(function () {
    "use strict"
    angular.module('starter')
        .controller('updateCertificatePic', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', '$ionicActionSheet', 'nativeHelper','$state', function ($rootScope, $scope, nav, localStorage, control, $ionicActionSheet, nativeHelper,$state) {
//            $scope.updateCertificatePicInfo = { idFace: '', idOpposite: '', businessLicense: '', authorization: '' };


            // 是否显示授权书图片
            $scope.showAuthPic = !($rootScope.hideAuthUpload);
            console.log('$rootScope.hideAuthUpload - ' + $rootScope.hideAuthUpload);

            //获取图片信息
            var getUpdateMaterialPic = function () {

                control.showLoading();
                var params = [$rootScope.curBusinessInfo.orderNo];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        $scope.$apply(function () {
                            $scope.updateCertificatePicInfo = {
                                idFace: result.value.idCardFace,
                                idOpposite: result.value.idCardBack,
                                businessLicense: result.value.businessLicense,
                                authorization: result.value.letter
                            };
                        });
                    }
                    if (!result.success) {
                        control.showPopup(result.msg, 2000);
                    }
                }

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };

                nativeHelper.getUpdateMaterialPic({ data: params, success: successFunc, fail: failFunc });
            };
//            getUpdateMaterialPic();
            //经办材料导航状态和成功后弹框
//            $scope.isSuccess = false

            $scope.uploadAvatar = function (e) {
                var successFunc = function (pic) {
                    $scope.$apply(function () {
                        control.hideLoading();
                        switch (e) {
                            case "idFace":
                                $rootScope.updateCertificatePicInfo.idFace = pic;
                                break;
                            case 'idOpposite':
                                $rootScope.updateCertificatePicInfo.idOpposite = pic;
                                break;
                            case 'businessLicense':
                                $rootScope.updateCertificatePicInfo.businessLicense = pic;
                                break;
                            case 'authorization':
                                $rootScope.updateCertificatePicInfo.authorization = pic;
                                break;

                        }
                    });

                };
                var failFunc = function () {
                    control.hideLoading();
                }
                control.camera(successFunc,failFunc, true);
            };

            //材料提交
            $scope.submitMaterial = function (isAgree) {
                
                if ($rootScope.hideAuthUpload) {
                    // 变更/延期的业务单不判断授权书 
                    if (undefined == $scope.updateCertificatePicInfo.authorization) {
                        $scope.updateCertificatePicInfo.authorization = '';
                    }
                    if ($scope.updateCertificatePicInfo.idFace == '' 
                    || $scope.updateCertificatePicInfo.idOpposite == ''
                    || $scope.updateCertificatePicInfo.businessLicense == ''
                    || undefined == $scope.updateCertificatePicInfo.idFace
                    || undefined == $scope.updateCertificatePicInfo.idOpposite
                    || undefined == $scope.updateCertificatePicInfo.businessLicense
                    ) {
                        control.showPopup("请完善证件资料", 2000);
                        return;
                    }
                } else {
                    if ($scope.updateCertificatePicInfo.idFace == '' 
                    || $scope.updateCertificatePicInfo.idOpposite == ''
                    || $scope.updateCertificatePicInfo.businessLicense == '' 
                    || $scope.updateCertificatePicInfo.authorization == ''
                    || undefined == $scope.updateCertificatePicInfo.idFace
                    || undefined == $scope.updateCertificatePicInfo.idOpposite
                    || undefined == $scope.updateCertificatePicInfo.businessLicense 
                    || undefined == $scope.updateCertificatePicInfo.authorization
                    ) {
                        control.showPopup("请完善证件资料", 2000);
                        return;
                    }
                }


                if ($rootScope.isSelect) {
                    isAgree = true;
                }
                if (!isAgree) {
                    control.showPopup("请同意协议", 2000);
                    return;
                }
                control.showLoading();
                var params = [$scope.updateCertificatePicInfo.idFace, $scope.updateCertificatePicInfo.idOpposite,
                    $scope.updateCertificatePicInfo.businessLicense, $scope.updateCertificatePicInfo.authorization, $rootScope.curBusinessInfo.orderNo,$rootScope.updateCertificatePicInfo.faceBase64,$rootScope.curBusinessInfo.facePassState];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
//                    console.log("$rootScope.certUnderwayInfo.facePassState"+$rootScope.certUnderwayInfo.facePassState)
                        $scope.$apply(function () {
                         if ($rootScope.curBusinessInfo.facePassState === '0'||$rootScope.curBusinessInfo.facePassState==null) {
                              $state.go('businessCompleted',{orderNo:$rootScope.curBusinessInfo.orderNo});
                         } else
                            $state.go('postIntroduction',{orderNo:$rootScope.curBusinessInfo.orderNo});
                        });
                    }
                    if (!result.success) {
                        control.showPopup(result.msg, 2000);
                    }
                }

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };

                nativeHelper.submitMaterialPic({ data: params, success: successFunc, fail: failFunc });
            };

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
