﻿(function () {
    angular.module('starter')
.directive('verficationcode', ['$rootScope', '$timeout', '$interval', '$ionicPopup', 'validate', 'control', 'nativeHelper', '$filter', function ($rootScope, $timeout, $interval, $ionicPopup, validate, control, nativeHelper, $filter) {
    return {
        restrict: 'AE',
        templateUrl: 'html/directives/verficationcode.html',
        scope: {
            showTimer: '=',
            timeout: '=',
            tel: '@tel',
            actionType: '@actionType'
        },
        link: function (scope, element, attrs) {
            scope.timer = false;
            scope.timeout = 60000;

            scope.timerCount = scope.timeout / 1000;
            scope.text = "发送验证码";

            scope.onClick = function () {
                if (validate.mobile(scope.tel)) {
                    scope.timer = true;
                    var params = [scope.tel, scope.actionType];
                    var failFunc = function (result) {
                        scope.timer = false;
                        control.showPopup(result.msg, 3000);
                    };

                    var success = function (result) {
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('获取验证码失败', 3000);
                            return;
                        }

                        if (!result.success) {
                            scope.timer = false;
                            control.showPopup(result.msg, 3000);
                            return;
                        } else {
                            scope.showTimer = true;
                            control.showPopup('验证码已发送', 3000);
                            scope.text = "";
                            var counter = $interval(function () {
                                scope.timerCount = scope.timerCount - 1;
                            }, 1000);

                            $timeout(function () {
                                scope.text = "发送验证码";
                                scope.timer = false;
                                $interval.cancel(counter);
                                scope.showTimer = false;
                                scope.timerCount = scope.timeout / 1000;
                            }, scope.timeout);
                            return;
                        }
                    };

                    nativeHelper.getMesAuthCode({ data: params, success: success, fail: failFunc });
                }
                else {
                    control.showPopup("请输入正确的手机号码！", 3000);
                    return;
                };
            }
        }

    };


}]);

})();