(function () {
    "use strict"

    angular.module('starter')
        .factory('control', ['$rootScope',  '$ionicPopup', '$ionicLoading', '$timeout', 'nav', 'nativeHelper', '$ionicActionSheet', function ($rootScope, $ionicPopup, $ionicLoading, $timeout, nav, nativeHelper, $ionicActionSheet) {
            var showConfirm = function (msg, okFunc, cancelFunc, cancelBtn, okBtn, customClass) {
                var confirmPopup = $ionicPopup.confirm({
                    title: msg,
                    cssClass: customClass || 'private-popup-confirm',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '确定'
                    //    cssClass: '', // String, The custom CSS class name
                    //    subTitle: '', // String (optional). The sub-title of the popup.
                    //    template: '', // String (optional). The html template to place in the popup body.
                    //    templateUrl: '', // String (optional). The URL of an html template to place in the popup   body.
                    //    cancelText: '', // String (default: 'Cancel'). The text of the Cancel button.
                    //    cancelType: '', // String (default: 'button-default'). The type of the Cancel button.
                    //    okText: '', // String (default: 'OK'). The text of the OK button.
                    //    okType: '', // String (default: 'button-positive'). The type of the OK button.
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
                        cancelFunc();
                    }
                });
            };

            var showConfirm2 = function (okFunc, cancelBtn, okBtn, customClass) {
                var confirmPopup = $ionicPopup.confirm({
                    template: "<div><i class='icon-tips2'></i><h3>人脸验证失败</h3><p>重新验证或<br/>联系客服<span class='color-333'>400-888-4636</span></p></div>",
                    cssClass: customClass || 'check-information',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '确定'

                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
//                        cancelFunc();
                    }
                });
            };
            var showConfirm3 = function ( okFunc,cancelFunc,cancelBtn, okBtn, customClass,template) {
                var confirmPopup = $ionicPopup.confirm({
                    template:template ,
                    cssClass: customClass || 'check-information',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '确定'

                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
                        cancelFunc();
                    }
                });
            };
            var showConfirm4 = function (url, msg, okFunc, cancelFunc, cancelBtn, okBtn, customClass) {
                var confirmPopup = $ionicPopup.confirm({
                    title: msg,
                    templateUrl: url,
                    cssClass: customClass || 'private-popup-confirm',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '确定'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
                        cancelFunc();
                    }
                });
            };
            var showConfirm5 = function (url, msg, okFunc, cancelFunc, cancelBtn, okBtn, customClass) {
                var confirmPopup = $ionicPopup.confirm({
                    title: msg,
                    template: url,
                    cssClass: customClass || 'private-popup-confirm',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '确定'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
                        cancelFunc();
                    }
                });
            };

            var showConfirm6 = function (okFunc, cancelBtn, okBtn, customClass) {
                var confirmPopup = $ionicPopup.confirm({
                    template: "<div class='area'><i class='icon-tips2'></i><h3>证书即将过期提醒</h3><p>重要通知：<br/>尊敬的用户，您名下有证书即将过期，请尽快前往【我的证书】进行证书延期，避免影响后续业务的正常办理！</p></div>",
                    cssClass: customClass || 'attention-information',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '前往我的证书'

                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
//                        cancelFunc();
                    }
                });
            };
            var showConfirm7 = function ( okFunc,cancelFunc, okBtn, cancelBtn, customClass, tmpUrl) {
                var confirmPopup = $ionicPopup.confirm({
                    templateUrl:tmpUrl ,
                    cssClass: customClass || 'usage-information',
                    cancelText: cancelBtn || '取消',
                    okText: okBtn || '确定'

                });
                confirmPopup.then(function (res) {
                    if (res) {
                        okFunc();
                    } else {
                        cancelFunc();
                    }
                });
            };

            var showAlert1 = function (msg, okFunc, okBtn, customClass) {
                var alertPopup = $ionicPopup.alert({
                    title: msg,
                    cssClass: customClass || 'private-popup-confirm',
                    okText: okBtn || '确定'
                });
                alertPopup.then(function () {
                    okFunc();
                });
            };

            var showPopup
            var hideCustomPopup = function(){
                 showPopup.close();
            };
            var showCustomPopup = function (url, tit, btnLeft, btnRight, btnLeftClass, btnRightClass, leftFunc, rightFunc, customClass) {
                 showPopup = $ionicPopup.show({
                    templateUrl: url,
                    title: tit,
                    cssClass: customClass || 'cert-operation',
                    buttons: [
                        {
                            text: btnLeft,
                            type: btnLeftClass,
                            onTap: function (e) {
                                leftFunc();
                            }
                        }, {
                            text: btnRight,
                            type: btnRightClass,
                            onTap: function (e) {
                                rightFunc();
                            }
                        }
                    ]
                });

            };

            var showCustom2Popup = function (htmlString, tit, btnLeft, btnRight, btnLeftClass, btnRightClass, leftFunc, rightFunc) {
                var showPopup = $ionicPopup.show({
                    template: htmlString,
                    title: tit,
                    cssClass: 'cert-operation',
                    buttons: [
                        {
                            text: btnLeft,
                            type: btnLeftClass,
                            onTap: function (e) {
                                leftFunc();
                            }
                        }, {
                            text: btnRight,
                            type: btnRightClass,
                            onTap: function (e) {
                                rightFunc();
                            }
                        }
                    ]
                });
            };
            var showCustom3Popup = function (okText, customClass,title,content) {
                            var alertPopup = $ionicPopup.alert({
                                cssClass: customClass || 'cert-operation',
                                template: "<div><i class='icon-tips'></i><h3>"+title+"</h3><p>"+content+"</p></div>",
                                okText: okText,
                            });
                            alertPopup.then(function(){
            //                    cancelFunc();
                            });
                        };
            var showCustom4Popup = function (url) {
                 showPopup = $ionicPopup.show({
                         templateUrl: url,
                         cssClass: 'popup-home-tips',
                 });
            };
            var showCustom5Popup = function (url) {
                showPopup = $ionicPopup.show({
                        templateUrl: url,
                        // cssClass: '',
                });
           };
            var showCustomAlert = function (msg, url, okText, okType, func) {
                var alertPopup = $ionicPopup.alert({
                    cssClass: 'cert-operation',
                    title: '', // String. 弹窗的标题。
                    subTitle: msg, // String (可选)。弹窗的子标题。
                    template: '', // String (可选)。放在弹窗body内的html模板。
                    templateUrl: url, // String (可选)。 放在弹窗body内的html模板的URL。
                    okText: okText, // String (默认: 'OK')。OK按钮的文字。
                    okType: okType, // String (默认: 'button-positive')。OK按钮的类型。
                });
                alertPopup.then(func());
            };

            var showCustomAlert2 = function (msg, okText, func, customClass) {
                var alertPopup = $ionicPopup.alert({
                    cssClass: customClass || 'cert-operation',
                    template: msg,
                    okText: okText,
                });
                alertPopup.then(func());
            };

            var showCustomAlert3 = function (okText, customClass) {
                var alertPopup = $ionicPopup.alert({
                    cssClass: customClass || 'cert-operation',
                    template: "<div><i class='icon-tips'></i><h3>信息有误</h3><p>请核对主体信息</p></div>",
                    okText: okText,
                });
                alertPopup.then(function(){
//                    cancelFunc();
                });
            };

            var showCustomAlert4 = function (okText, customClass) {
                var alertPopup = $ionicPopup.alert({
                    cssClass: customClass || 'cert-operation',
                    template: "<div><i class='icon-tips'></i><h3>数据无法匹配</h3><p>信息有误请核对或<br/>联系客服<span class='color-333'>400-888-4636</span></p></div>",
                    okText: okText,
                });
                alertPopup.then(function(){
//                              cancelFunc();
                               });
            };
            var showCustomAlert5 = function (msg, customClass,func) {
                 var alertPopup = $ionicPopup.alert({
                     cssClass: customClass || 'cert-operation',
                     template:"<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + msg + "</p></div>",
                     okText: '知道了'
                     });
                 alertPopup.then(func());
            };



            var showPopup = function (msg, milliSecond, func) {
                //$rootScope.msg = msg;

                var msgPopup = $ionicPopup.show({
                    //template: '<div class="state-tips-bg"><div class="text-center state-tips-box">{{msg}}</div></div>',
                    subTitle: msg,
                    cssClass: 'private-popup-show',
                    //cssClass: 'ex-popup',
                    //scope: $rootScope
                });

                $timeout(function () {
                    msgPopup.close();
                    if (func) {
                        func();
                    }
                }, milliSecond);
            };


            var showLoadingVar;

            //加载动画
            var showLoading = function () {
                switch (cordova.platformId) {
                    case 'android':
                        $ionicLoading.show({
                            // template: '加载中...',
                            template: '<ion-spinner icon="circles" class="spinner-light">加载中...</ion-spinner>',//动画模板
                        });
                        break;
                    case 'ios':
                        $ionicLoading.show({
                            template: '<ion-spinner icon="bubbles" class="spinner-stable">loading</ion-spinner>',//动画模板
                        });
                        break;
                }
            };
            //加载动画
            var showTitleLoading = function (msg) {
                switch (cordova.platformId) {
                    case 'android':
                        $ionicLoading.show({
                            // template: '加载中...',
                            template: msg,//动画模板
                        });
                        break;
                    case 'ios':
                        $ionicLoading.show({
                            template: '<ion-spinner icon="bubbles" class="spinner-stable">loading</ion-spinner>',//动画模板
                        });
                        break;
                }
            };

            //隐藏加载动画
            var hideLoading = function () {
                $ionicLoading.hide();
            };
            //清除拍照缓存
            var clearCameraCache = function (index) {
                if (index === 1) {
                    var cameraSuccess = function () {
                    }
                    var cameraError = function () {
                    }
                    navigator.camera.cleanup(cameraSuccess, cameraError);
                }
            }
            //拍照
            var camera = function (successFunc, failFunc, isheader, width, height, quality) {

                $ionicActionSheet.show({
                    buttons: [
                        { text: '相册' },
                        { text: '拍照' }
                    ],
                    cssClass: 'special-action-sheet',

                    cancel: function () {
                        failFunc();
                    },
                    buttonClicked: function (index) {
                        //if (cordova.platformId === 'ios' && $rootScope.deviceModel.indexOf('') != -1) {
                        //    quality = 80;
                        //    width = 500;
                        //    height = 500
                        //}
                        var options = {
                            quality: quality || 100,                                            //相片质量0-100
                            destinationType: 0,      //返回类型：DATA_URL= 0，返回作为 base64 字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，???)
                            sourceType: index,                                      //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
                            allowEdit: false,                                        //在选择之前允许修改截图
                            encodingType: 0,                                        //保存的图片格式： JPEG = 0, PNG = 1
                            targetWidth: width || 800,                                       //照片宽度
                            targetHeight: height || 800,                                      //照片高度
                            mediaType: index,                                           //可选媒体类型：?片=0，只允许选择图片?返回指定DestinationType的参数。 ??格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
                            cameraDirection: 0,                                     //前后摄像头类型：Back= 0,Front-facing =1
                            //popoverOptions: CameraPopoverOptions,
                            saveToPhotoAlbum: false                                 //保存进手机相册
                        };

                        function onSuccess(imageData) {
                            if (isheader) {
                                imageData = 'data:image/jpeg;base64,' + imageData;
                            }
                            clearCameraCache(index);
                            successFunc(imageData);
                        };

                        function onFail(ex) {
                            hideLoading();
                            clearCameraCache(index);
                            failFunc();
                            //showPopup(ex, 2000);
                        }
                        showLoading();
                        navigator.camera.getPicture(onSuccess, onFail, options);

                        return true;
                    }
                })
            }
            //android 平台双击返回判断
            var androidPlatFormExit = function (input) {
                if (input === "/home")
                    return true;
                else if (input === "/signIn")
                    return true;

            }
            //back
            var androidPicker=function(path){
                if(path=='/claimantInfo'){
                return true;
            }
            if(path=='/applyAuthorize'){
                return true;
             }
            }
           //backhome
           var androidPlatFormGoHome = function(input) {
               if (input === "/businessManage") return true;
               else if (input === "/orderDetails") return true;
               else if (input === "/paymentSuccess") return true;
               else if (input === "/reissueOrGetNewCert") return true;
               else if (input === "/eleBusinessLicense") return true;
               else if (input === "/certManage") return true;
               else if (input === "/applyCertComplete") return true;
               else if (input === "/downloadCertSuccess") return true;
               else if (input === "/authorizationFace") return true;
               else if (input === "/authorizationRecord") return true;
               else if (input === "/applyCertSearch") return true;
               else if (input === "/signCompleted") return true;
               else if (input === "/signConversation") return true;
           }

            return {
                showConfirm: showConfirm,
                showConfirm2: showConfirm2,
                showConfirm3: showConfirm3,
                showConfirm4: showConfirm4,
                showConfirm5: showConfirm5,
                showConfirm6: showConfirm6,
                showConfirm7: showConfirm7,
                showAlert1: showAlert1,
                showPopup: showPopup,
                showLoading: showLoading,
                hideLoading: hideLoading,
                androidPlatFormExit: androidPlatFormExit,
                showCustomPopup: showCustomPopup,
                showCustom3Popup:showCustom3Popup,
                showCustom4Popup:showCustom4Popup,
                showCustom5Popup:showCustom5Popup,
                showCustomAlert: showCustomAlert,
                camera: camera,
                showCustomAlert2: showCustomAlert2,
                showCustomAlert3: showCustomAlert3,
                showCustomAlert4: showCustomAlert4,
                showCustomAlert5: showCustomAlert5,
                androidPlatFormGoHome: androidPlatFormGoHome,
                androidPicker:androidPicker,
                showTitleLoading:showTitleLoading,
                hideCustomPopup:hideCustomPopup,
            };
        }]);
})();
