﻿(function () {
    "use strict"

    angular.module('starter')
        .factory('request', ['$http', '$location', '$rootScope', 'nav','utility', function ($http, $location, $rootScope, nav,utility) {
            var postFunc = function (req) {
                utility.log('入参：' + JSON.stringify(req.data) + '\n' + '地址：' + req.url);
                req.data = req.data || {};
                // req.transformFlag = Boolean(req.transformFlag || ((typeof req.transformFlag) === 'undefined'));
                $http({
                    method: 'POST',
                    params: req.params,
                    url: req.url,
                    data: angular.toJson(req.data),
                    // data: { 'encParamsStr': DES3.encrypt($rootScope.KEY, $rootScope.IV, angular.toJson(req.data)) },
                    headers: { 'Content-Type': 'application/json'},
                    // transformRequest: function (obj) {
                    //    obj = angular.toJson(obj);
                    //    return obj;
                    // }
                })
                .success(function (data, status, headers, config) {
                    utility.log("请求成功"+JSON.stringify(data));
                    //data = angular.fromJson(data);
                    // if (data.msg) {
                    //     control.hideLoading();
                    //     nav.navigate('signIn');
                    // } else {
                        req.success(data, status, headers, config);
                    // }
                })
                .error(function (data, status, headers, config) {
                    utility.log(headers);
                    utility.log(config);
                    req.error(data, status, headers, config);
                });
            };
           

            var getFunc = function (req) {
                utility.log('入参：' + req.data + '\n' + '地址：' + req.url);
                req.data = req.data || {};
                var aa =  angular.extend({}, req.params, { token: $rootScope.requestVerificationToken });
                $http({
                    method: 'GET',
                    params: angular.extend({}, req.params, { token: $rootScope.requestVerificationToken }),
                    //params: req.params,
                    url: req.url,
                    data: req.data
                })
                    .success(function (data, status, headers, config) {
                        if (data.msg && data.msg.indexOf('token') >= 0) {
                            nav.navigate('login');
                        } else {
                            req.success(data, status, headers, config);
                        }
                    })
                    .error(function (data, status, headers, config) {
                        req.error(data, status, headers, config);
                    });
            };

            var uploadFunc = function (req) {
                req.data = req.data || {};
                var fd = new FormData();
                angular.forEach(req.data, function (value, key) {
                    fd.append(key, value);
                });

                $http({
                    method: 'POST',
                    params: req.params,
                    url: req.url,
                    data: fd,
                    //headers: { 'Content-Type': undefined, 'X-Requested-With': 'XMLHttpRequest', 'RequestVerificationToken': requestVerificationToken },
                    headers: {'Content-Type': 'application/x-www-form-urlencoded'},
                    transformRequest: function (data) {
                        return data;
                    }
                })
                    .success(function (data, status, headers, config) {
                        req.success(data, status, headers, config);
                    })
                    .error(function (data, status, headers, config) {
                        req.error(data, status, headers, config);
                    });
            };

            return {
                post: postFunc,
                get: getFunc,
                upload: uploadFunc
            };
        }]);
})();
