﻿(function () {
    "use strict"

    angular.module('starter')
        .factory('requestWrapper', ['$rootScope','$q', 'request', 'url', 'utility','md5', function ($rootScope, $q, request,url,utility,md5) {

            return {

                // 检查是否要上传资料
                doCheckUploadPicture: function (options) {
                    var defer = new $q.defer();
                    request.post({
                        url: url.generate('app/api/doCheckUploadPicture', 'serverUrl'),
                        params: {},
                        data: options.data,
                        success: function (data) {
                            defer.resolve(data);
                        },
                        error: function (data, status) {
                            defer.reject({ data: data, status: status });
                        }
                    });
                    return defer.promise;
                },


                // 校验二维码是否可用
                checkAppCanScanQrcode: function (options) {
                    var defer = new $q.defer();
                    request.post({
                        url: url.generate('api/newQrCode/checkAppCanScanQrcode', 'scanUrl'),
                        params: {},
                        data: options.data,
                        success: function (data) {
                            defer.resolve(data);
                        },
                        error: function (data, status) {
                            defer.reject({ data: data, status: status });
                        }
                    });
                    return defer.promise;
                },

                // 图片上传 补齐资料
                doUploadEntPic: function (options) {
                    var defer = new $q.defer();
                    request.post({
                        url: url.generate('app/api/doUploadEntPic', 'serverUrl'),
                        params: {},
                        data: options.data,
                        success: function (data) {
                            defer.resolve(data);
                        },
                        error: function (data, status) {
                            defer.reject({ data: data, status: status });
                        }
                    });
                    return defer.promise;
                },

                // 移动证书相关服务预警
                sendMesToDingTalk: function (tips,source,alarmMsg) {
                    console.log("sendMesToDingTalk参数alarmMsg: " + alarmMsg);
                    if(typeof(alarmMsg) != 'undefined'&& alarmMsg != ''){
                        var time = utility.getCurrentTime();
                        var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                        var params = {
                            'appid': $rootScope.appid,
                            'time': time,
                            'hashdata': hashdata,
                            'content': "【"+tips+"】：（"+cordova.platformId+"端 -用户:"+$rootScope.loginInfo.mobile+" -版本:V"+$rootScope.appVersion +" -来源:"+source+"）"+alarmMsg,
                        }
                        console.log("sendMesToDingTalk参数: " + JSON.stringify(params));

                        request.post({
                             url: url.generate('app/api/sendMesToDingTalk', 'serverUrl'),
                             params: {},
                             data: params,
                             success: function (data) {
                                  console.log("sendMesToDingTalk success: " + data);
                             },
                             error: function (data, status) {
                                  console.log("sendMesToDingTalk error: " + data);
                             }
                        });
                    }

                }
            };
        }]);
})();