(function () {
    "use strict"

    angular.module('starter')
    .factory('utility', ['$q', '$rootScope', '$ionicLoading', '$ionicPopup', '$timeout', 'validate', 'localStorage', 'control', 'nativeHelper', 'nav', 'md5', function ($q, $rootScope, $ionicLoading, $ionicPopup, $timeout, validate, localStorage, control, nativeHelper, nav, md5) {
        var calculateTotalPages = function (pages, pageSize) {
            return Math.ceil(pages / pageSize);
        };

        // sort params and stringify them
        var stringifyParams = function (params) {
            if (!params) {
                return '';
            }

            var ret = [], keys = [];
            for (var key in params) {
                keys.push(key);
                keys.sort();
            }

            for (var i = 0; i < keys.length; ++i) {
                ret.push(keys[i] + '=' + params[keys[i]]);
            }

            return ret.join('&');
        };

        var findFirst = function (arr, fn, def) {
            var l = arr.length;
            for (var i = 0; i < l; ++i) {
                if (fn(arr[i], i))
                    return arr[i];
            };
            return def;
        };

        var generateStringComparer = function (prop, desc) {
            desc = desc ? -1 : 1;
            return function (v1, v2) {
                var prop1 = v1[prop], prop2 = v2[prop];
                if (validate.isString(prop1) && validate.isString(prop2)) {
                    prop1 = prop1.trim().toLowerCase();
                    prop2 = prop2.trim().toLowerCase();
                }
                if (prop1 < prop2)
                    return -1 * desc;
                if (prop1 > prop2)
                    return 1 * desc;
                return 0;
            };
        };

        var HTMLElemClearChild = function (elem) {
            while (elem.hasChildNodes()) {
                elem.removeChild(elem.lastChild);
            }
        };

        var HTMLElemAddClass = function (elem, className) {
            var cc = elem.className.split(' ').filter(function (c) { return c != className; });
            cc.push(className);
            elem.className = cc.join(' ');
        };

        var HTMLElemRemoveClass = function (elem, className) {
            elem.className = elem.className.split(' ').filter(function (c) { return c != className; }).join(' ');
        };

        var HTMLElemHasClass = function (elem, classname) {
            var elemClasses = elem.className.split(' ');
            return elemClasses.some(function (c) { return c == classname; });
        };

        var callService = function () {
            //调用插件  
            window.plugins.CallNumber.callNumber(
                function onSuccess(result) {
                    //alert("Success:call number" + result);
                },
                function onError(result) {
                    //alert("Error:call number" + result);
                },
                "400-888-4636", true);
        };

        var checkUpdate = function () {
            $timeout(function () {
                var params = [{ 'type': 'ios' }];
                var successFunc = function (result) {
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 3000);
                        return;
                    }
               
                    if (!result.success) {
                        control.showPopup(result.msg, 3000);
                    }
                };

                var failFunc = function (result) {
                    control.showPopup(result.msg, 3000);
                };

                nativeHelper.checkUpdate({
                    data: params, success: successFunc, fail: failFunc
                });
            }, 1000*7);
        };

        var setUserInfo = function () {
            var successFunc = function (result) {
                localStorage.setObject('loginInfo', result);
            }

            var failFunc = function (error) {
                control.showPopup(error, 3000);
            };

            var loginInfo = $rootScope.user.name + ',' + $rootScope.user.password

            nativeHelper.getEncryptAndDecryptStr({ data: ['1', loginInfo], success: successFunc, fail: failFunc });
        }

        //randomFlag-是否任意长度 min-任意长度最小位[固定位数] max-任意长度最大位
        var randomStr = function (randomFlag, min, max) {
            //Math.random().toString(36).substr(2);

            var str = "",
            range = min,
            arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

            // 随机产生
            if (randomFlag) {
                range = Math.round(Math.random() * (max - min)) + min;
            }

            var pos;
            for (var i = 0; i < range; i++) {
                pos = Math.round(Math.random() * (arr.length - 1));
                str += arr[pos];
            }
            return str;
        }

        //php函数urlencode的js实现方法
        var  URLEncode = function(clearString) {
            var output = '';
            var x = 0;
            clearString = clearString.toString();
            var regex = /(^[a-zA-Z0-9-_.]*)/;
            while (x < clearString.length) {
                var match = regex.exec(clearString.substr(x));
                if (match != null && match.length > 1 && match[1] != '') {
                    output += match[1];
                    x += match[1].length;
                } else {
                    if (clearString.substr(x, 1) == ' ') {
                        //原文在此用 clearString[x] == ' ' 做判断, 但ie不支持把字符串当作数组来访问, 
                        //修改后两种浏览器都可兼容 
                        output += '+';
                    }
                    else {
                        var charCode = clearString.charCodeAt(x);
                        var hexVal = charCode.toString(16);
                        output += '%' + ( hexVal.length < 2 ? '0' : '' ) + hexVal.toUpperCase();
                    }
                    x++;
                }
            }
            return output;
        }

        /** 
         * param 将要转为URL参数字符串的对象 
         * key URL参数字符串的前缀 
         * encode true/false 是否进行URL编码,默认为true 
         *  
         * return URL参数字符串 
         */  
        var jsonToURL = function (param, key, encode) {  
            if(param==null) return ''; 
            
            var paramStr = '';  
            var t = typeof (param);  
            if (t == 'string' || t == 'number' || t == 'boolean') {  
                paramStr += '&' + key + '=' + ((encode == null || encode) ? URLEncode(param) : param);
            } else {  
                for (var i in param) {  
                    var k = key == null ? i : key + (param instanceof Array ? '[' + i + ']' : '.' + i);  
                    paramStr += jsonToURL(param[i], k, encode);
                }  
            }

            return paramStr;  
        };

        var objKeySort = function(arys) {
            //先用Object内置类的keys方法获取要排序对象的属性名，再利用Array原型上的sort方法对获取的属性名进行排序，newkey是一个数组
            var newkey = Object.keys(arys).sort();
            //console.log('newkey='+newkey);
            var newObj = {}; //创建一个新的对象，用于存放排好序的键值对
            for (var i = 0; i < newkey.length; i++) {
                //遍历newkey数组
                newObj[newkey[i]] = arys[newkey[i]];
                //向新创建的对象中按照排好的顺序依次增加键值对

            }
            return newObj; //返回排好序的新对象
        }

        var getReqSign = function (param) {
            var appKey = $rootScope.configInfo.ocrAppKey || 'Nz4rzhucmXq5SMkf';

            //var json = angular.toJson(params);
            var json = objKeySort(param);
            var str = jsonToURL(json);
            str = str.substr(1,str.length);

            str += '&' + 'app_key' + '=' + appKey;
            //str = str.replace(/[\n]/ig, '');.replace(/\ +/g,'')
            var md5Str = md5.createHash(str || '');

            return angular.uppercase(md5Str);
        }

        var log = function(msg){
            if($rootScope.isDebug){
                console.log(msg);
            } 
        }

        var setCertList = function (data, successFunc, failFunc) {
            nativeHelper.setLocalCertList({ data:data, success: successFunc, fail: failFunc });
        }

        var getCertList = function (successFunc) {
            var params = [$rootScope.loginInfo.accountId];

            var failFunc = function (e) {

            };

            nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
        }

        var resetDate = function(n) { return n < 10 ? '0' + n : n }
        var getCurrentTime = function() {
            console.log('getCurrentTime');
            var date = new Date();
            return date.getFullYear().toString() + resetDate(date.getMonth() + 1) + resetDate(date.getDate()) + resetDate(date.getHours()) + resetDate(date.getMinutes()) + resetDate(date.getSeconds());
        }


         /**
          * 字符串转化数组
          * @param {*} str 
          * @returns 
          */
          var stringToByte = function(str) {
            var bytes = new Array();
            var len, c;
            len = str.length;
            for(var i = 0; i < len; i++) {
                c = str.charCodeAt(i);
                if(c >= 0x010000 && c <= 0x10FFFF) {
                    bytes.push(((c >> 18) & 0x07) | 0xF0);
                    bytes.push(((c >> 12) & 0x3F) | 0x80);
                    bytes.push(((c >> 6) & 0x3F) | 0x80);
                    bytes.push((c & 0x3F) | 0x80);
                } else if(c >= 0x000800 && c <= 0x00FFFF) {
                    bytes.push(((c >> 12) & 0x0F) | 0xE0);
                    bytes.push(((c >> 6) & 0x3F) | 0x80);
                    bytes.push((c & 0x3F) | 0x80);
                } else if(c >= 0x000080 && c <= 0x0007FF) {
                    bytes.push(((c >> 6) & 0x1F) | 0xC0);
                    bytes.push((c & 0x3F) | 0x80);
                } else {
                    bytes.push(c & 0xFF);
                }
            }
            return bytes;
        }

        /**
         * 数组转base64
         * @param {*} buffer 
         * @returns 
         */
         var  arrayBufferToBase64 = function(buffer) {
            var binary = '';    
            var bytes = new Uint8Array( buffer );
            var len = bytes.byteLength;    
            for (var i = 0; i < len; i++) {
                binary += String.fromCharCode( bytes[ i ] );  
            }     
            return window.btoa( binary );    
        }
        
        /**
         * 字符串转化sm3后转base64
         * @param {} str 
         * @returns 
         */
        var sm3HashBase64 = function(str) {
            var sm3keycur = new SM3Digest();
            var msgByte = stringToByte(str);
            sm3keycur.BlockUpdate(msgByte, 0, msgByte.length);
            var md= new Array(32);
            sm3keycur.DoFinal(md, 0);
            return arrayBufferToBase64(md)
        }

        // 判断当前时间距离截止日期是否小于x天
        // 参数1-dateFormatter ：截止日期格式'yyyy-MM-dd'
        // 参数2-limited ：x
        // 返回小于为true 否则false
        var judgeWillInvalidDate = function (dateFormatter , limited) {
            const limitedTimeArr = dateFormatter.split('-');
            const nowTime = new Date();
            const nowYMD = new Date(nowTime.getFullYear(), nowTime.getMonth(), nowTime.getDate());
            const limitedTimeYMD = new Date(limitedTimeArr[0], limitedTimeArr[1] - 1, limitedTimeArr[2]);
            const over = (limitedTimeYMD > nowYMD) && ((limitedTimeYMD - nowYMD) / (1000 * 60 * 60 * 24) < limited);
            return over;
        }

        var todayDate = function() {
            //获取当前日期函数
            let date = new Date(),
            seperator1 = '-',
            year = date.getFullYear(),
            month = date.getMonth() + 1, 
            strDate = date.getDate()
            if (month >= 1 && month <= 9) month = '0' + month
            if (strDate >= 0 && strDate <= 9) strDate = '0' + strDate
            let currentdate = year + seperator1 + month + seperator1 + strDate 
            return currentdate
        }


        return {
            htmlElem: {
                clearChild: HTMLElemClearChild,
                addClass: HTMLElemAddClass,
                removeClass: HTMLElemRemoveClass,
                hasClass: HTMLElemHasClass
            },
            calculateTotalPages: calculateTotalPages,
            stringifyParams: stringifyParams,
            findFirst: findFirst,
            generateStringComparer: generateStringComparer,
            setUserInfo: setUserInfo,
            callService: callService,
            checkUpdate: checkUpdate,
            randomStr: randomStr,
            sm3HashBase64: sm3HashBase64,
            getReqSign: getReqSign,
            setCertList:setCertList,
            getCertList: getCertList,
            getCurrentTime: getCurrentTime,
            log: log,
            judgeWillInvalidDate: judgeWillInvalidDate,
            todayDate: todayDate,
            URLEncode: URLEncode
        };
    }]);
})();
