﻿(function () {
    angular.module('starter')
    .factory('validate', [function () {
        var emailRegex = /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
        //var mobileRegex = /^1[3|4|5|7|8]\d{9}$/;//手机号码
        var mobileRegex = /^(13[0-9]|14[56789]|15[0-3,5-9]|16[6]|17[012345678]|18[0-9]|19[135689])\d{8}$/;//手机号码
        var digitsRegex = /^[0-9]{1,15}$/;//数字
        //身份证
        var isIDCard = /^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$|^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|[xX])$/;

        var isString = function (str) {
            return (typeof str) === 'string' || (str instanceof String);
        };
        var isNullOrEmpty = function (input) {
            return input == null || (isString(input) && input.trim() == '');
        };
           //身份证校验
         var idNo = function (idcard) {
            var area = {
                11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古", 21: "辽宁", 22: "吉林", 23: "黑龙江", 31: "上海", 32: "江苏", 33: "浙江",
                34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南", 42: "湖北", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆", 51: "四川",
                52: "贵州", 53: "云南", 54: "西藏", 61: "陕西", 62: "甘肃", 63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门", 91: "国外"
            };
            var Y, JYM, S, M, ereg,idcard_array =  idcard.split("");
            if (area[parseInt(idcard.substr(0, 2))] == null) {
                return { result: false, e: "身份证号码不正确!"};
            }
            switch (idcard.length) {
                case 15:
                    if ((parseInt(idcard.substr(6, 2)) + 1900) % 4 == 0 || ((parseInt(idcard.substr(6, 2)) + 1900) % 100 == 0 && (parseInt(idcard.substr(6, 2)) + 1900) % 4 == 0)) {
                        ereg = /^[1-9][0-9]{5}[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}$/;
                    } else {
                        ereg = /^[1-9][0-9]{5}[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}$/;
                    }
                    if (ereg.test(idcard)) {
                        return { result: true};
                    } else {
                        return { result: false, e: "身份证号码出生日期超出范围或含有非法字符!"};
                    }
                    break;
                case 18:
                    if (parseInt(idcard.substr(6, 4)) % 4 == 0 || (parseInt(idcard.substr(6, 4)) % 100 == 0 && parseInt(idcard.substr(6, 4)) % 4 == 0)) {
                        ereg = /^[1-9][0-9]{5}19[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}[0-9Xx]$/;
                    } else {
                        ereg = /^[1-9][0-9]{5}19[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}[0-9Xx]$/;
                    }
                    if (ereg.test(idcard)) {
                        S = (parseInt(idcard_array[0]) + parseInt(idcard_array[10])) * 7
                            + (parseInt(idcard_array[1]) + parseInt(idcard_array[11])) * 9
                            + (parseInt(idcard_array[2]) + parseInt(idcard_array[12])) * 10
                            + (parseInt(idcard_array[3]) + parseInt(idcard_array[13])) * 5
                            + (parseInt(idcard_array[4]) + parseInt(idcard_array[14])) * 8
                            + (parseInt(idcard_array[5]) + parseInt(idcard_array[15])) * 4
                            + (parseInt(idcard_array[6]) + parseInt(idcard_array[16])) * 2
                            + parseInt(idcard_array[7]) * 1
                            + parseInt(idcard_array[8]) * 6
                            + parseInt(idcard_array[9]) * 3;
                        Y = S % 11;
                        M = "F";
                        JYM = "10X98765432";
                        M = JYM.substr(Y, 1);
                        if (M == idcard_array[17]) {
                            return { result: true}
                        } else {
                            return { result: false, e: "身份证号码出生日期超出范围或含有非法字符!"};
                        }
                    } else {
                        return { result: false, e: "身份证号码出生日期超出范围或含有非法字符!"};
                    }
                    break;
                default:
                    return { result: false, e: "身份证号码位数不对!"};
            }
        };
         return {
            idNo: idNo,
            isString: isString,
            nullOrEmpty: isNullOrEmpty,
            email: function (input, optional) {
                return Boolean((isString(input) && emailRegex.test(input.toLowerCase())) || (optional && isNullOrEmpty(input)));
            },
            isIDCard: function (input, optional) {
                return Boolean((isString(input) && isIDCard.test(input.toLowerCase())) || (optional && isNullOrEmpty(input)));
            },
            mobile: function (input, optional) {
                return Boolean((isString(input) && mobileRegex.test(input)) || (optional && isNullOrEmpty(input)));
            },
            userName:function (input, optional) {
                var pwdValidator = this.stringLimitGenerator({ max: 16, min: 4 });
                return Boolean(pwdValidator(input) || (optional && isNullOrEmpty(input)));
            },
            loginPassword: function (input, optional) {
                var pwdValidator = this.stringLimitGenerator({ max: 100, min: 6 });
                return Boolean(pwdValidator(input) || (optional && isNullOrEmpty(input)));
            },
            loginPasswordReg: function (input) {
                var regStr = /^(?![A-Za-z]+$)(?![A-Z\d]+$)(?![A-Z\W]+$)(?![a-z\d]+$)(?![a-z\W]+$)(?![\d\W]+$)\S{8,32}$/;
                return regStr.test(input);
            },
            certPassword: function (input, optional) {
                if (input === "" || input == null) {
                    return false;
                }
                if (!isNaN(input)) {
                    var pwdValidator = this.stringLimitGenerator({ max: 6, min: 6 });
                    return Boolean(pwdValidator(input) || (optional && isNullOrEmpty(input)));
                } else {
                    return false;
                }
            },
            nickName: function (input, optional) {
                var nameValidator = this.stringLimitGenerator({ max: 15, min: 1 });
                return Boolean(nameValidator(input) || (optional && isNullOrEmpty(input)));
            },
            valuedString: function (input, optional) {
                return Boolean((isString(input) && input.trim().length > 0) || (optional && isNullOrEmpty(input)));
            },
            number: function (input, optional) {
                if (!input && optional)
                    return true;
                else {
                    var n = Number(input);
                    return !isNaN(n);
                }
            },
            title:function(title){
                return title.substr(0,8)+new String('.').repeat(3);
            },
            bigInt: function (input, optional) {
                var pwdValidator = this.stringLimitGenerator({ max: 6, min: 6 });
                var n = Number(input);
                return !isNaN(n) && Boolean((pwdValidator(input) && digitsRegex.test(input.toLowerCase())) || (optional && isNullOrEmpty(input)));
            },
            alwaysTrue: function () { return true; },
            nonEmptyArray: function (input) {
                return Array.isArray(input) && input.length > 0;
            },
            stringLimitGenerator: function (opt) {
                //internal func, no input check
                var max = opt.max, min = opt.min, noTrim = opt.noTrim;
                return function (str) {
                    if (!isString(str))
                        return false;
                    else {
                        var s = noTrim ? str : str.trim();
                        var l = s.length;
                        return (max == null || max >= l) && (min == null || min <= l);
                    }
                };
            }
        };
    }]);
})();