/**
*授权中心需要多次调用的接口抽离实现复用
**/
(function () {
    "use strict"

    angular.module('starter')
        .factory('verifyIdentity', ['$rootScope','control','nativeHelper','$filter',
        function ($rootScope,control,nativeHelper,$filter) {

            //检查身份类型 返回身份类型：: "0法定代表人1管理员2经办人
            var checkIdentity = function (uniscid,cert,checkIdentityType,resultFunc) {

            control.showLoading();
            //$rootScope.loginInfo.cert
            var params = [uniscid, cert,checkIdentityType];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                }
                //"identityType":"0法定代表人1管理员2经办人",
                    resultFunc(result);

            }
            var failFunc = function(error) {
                control.hideLoading();
                // control.showPopup(error.msg, 2000);
                return '';
            };
            nativeHelper.checkIdentity({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        };

            //三十四.查询有效授权领证信息和有效网点领证信息接口/0 未授权，1 已授权,2 记录
            var checkAuthorization = function (cert,type,uniscid,resultFunc) {

            control.showLoading();
            //$rootScope.loginInfo.cert
            var params = [cert,type, uniscid];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                }
                if (result.success) {
                    resultFunc(result);
                }

                if (!result.success) {
                    control.showPopup(result.msg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.doGetPermitInfo({
                data: params,
                success: successFunc,
                fail: failFunc
            });
            };

            //判断人脸是否和身份信息匹配
            //是否需要更新联连信息：updateLLInfo（String类型，0->不更新，1->更新，不传或者为空时，默认为1)
             var startIdentityAuthenticationAction = function(userName,idCard,photoData,userId,realNameGrade,resultFunc,updateLLInfo) {
                        control.showLoading();
                        var params = ['0x42', userName, idCard, photoData, userId, realNameGrade,updateLLInfo?updateLLInfo:"1"];
                        var successFunc = function(result) {
                            control.hideLoading();
                            if (result == null || angular.equals({},
                            result)) {
                                control.showPopup('服务出错啦', 2000);
                            }

                            if (result.rslt == 'success') {
//                                $rootScope.claimant.base64PhotoData = photoData;
                                resultFunc(result.data);

                            }
                            if (result.rslt == 'fail') {
                                var eventCounter = new Object();
                                eventCounter.page = "活体接口认证";
                                MobclickAgent.onEventWithParameters("authLivingInterfaceFailEvent", eventCounter);
                                control.showPopup(result.errorMsg, 2000);


                            }
                        }
                        var failFunc = function(error) {
                            var eventCounter = new Object();
                            eventCounter.page = "活体接口认证";
                            MobclickAgent.onEventWithParameters("authLivingInterfaceFailEvent", eventCounter);
                            control.hideLoading();
                            control.showPopup(error.msg, 2000);
                        };

                        nativeHelper.identityAuthentication({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
                    }



        var liveDetectionNum=0;
       //开启活体静默检测
        var startLiveDetection = function(listenerLiveDetectionRes) {
            //监听活体次数
            var eventCounter = new Object();
            eventCounter.page = "活体认证";
            MobclickAgent.onEventWithParameters("authLivingEvent", eventCounter);
                
            liveDetectionNum = liveDetectionNum + 1;
            var params = [];
            var successFunc = function(result) {};
            var failFunc = function(error) {};
            nativeHelper.liveDetection({
                data: params,
                success: successFunc,
                fail: failFunc
            });

            var listenerLiveDetection=function(res){
                window.broadcaster.removeEventListener("liveDetectionResult",listenerLiveDetection);
                listenerLiveDetectionRes(res);
            }
            window.broadcaster.addEventListener("liveDetectionResult", listenerLiveDetection);
        };


        var getDate=function(time,day) {
                time.setDate(time.getDate() + day);
                var y = time.getFullYear();
                var m = time.getMonth() + 1;
                var d = time.getDate();
                return y + "-" + (m<10?"0"+m:m) + "-" + (d<10?"0"+d:d);
            }
        //申请授权
        /**
        *系统时间、经办人身份号码、经办人姓名、结果回调
        **/
          var applyAuthorize = function(systemTime,idCard,userName,applyAuthorizeRes) {

                var time=new Date(systemTime);
                var endDate =getDate(time,14);
                    control.showLoading();

            var extendData={'certName':$rootScope.certUnderwayInfo.netType=="8"?$rootScope.certUnderwayInfo.certName:$rootScope.certUnderwayInfo.entName,
                             'categoryBh':$rootScope.certUnderwayInfo.categoryBh,
                             'netType':$rootScope.certUnderwayInfo.netType,
                             'corpid':$rootScope.certUnderwayInfo.corpid,
                             'businessType':$filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType),};


                    var params = [$rootScope.certUnderwayInfo.uniscid,idCard,userName,
                    '20191016172831442090',
                     $rootScope.loginInfo.mobile,systemTime+' 00:00:00',
                     endDate+' 23:59:59','EPASSAPP',extendData];
                    var successFunc = function(result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                        result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        if (result.rslt=='success') {
                            applyAuthorizeRes(result.shareContent);
                        }
                        if (result.rslt=='fail') {
                            control.showPopup(result.errorMsg, 3000);
                        }
                    }

                    var failFunc = function(error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 3000);
                    };

                    nativeHelper.applyAuthorize({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                }
            /**
                            *鉴权接口
                            *参数一："type":"鉴权类型：1：根据事项编码身份信息鉴权；2：根据事项编码授权码鉴权；3：根据
                                                          *        事项编码，身份信息，授权码鉴权；4：根据单位信息鉴权"。
                                                          *参数二："itemCode":"事项编码"。
                                                          *参数三："certKey":"身份证件号码的SM3hash值",js端将身份证信息传给native进行摘要。

                            **/
            var getAuthorizationComfirmInfo = function(cardId, entName, uniscid, checkRsFunc) {
                control.showLoading();
                var params = ["1", "20191016172831442090", cardId, $rootScope.searchResult.entName, $rootScope.searchResult.uniscid];
                //             var params = ["1","20190325092052817016",cardId,"玉环金源进出口有限公司","913310217719107159" ];
                var successFunc = function(result) {
                    control.hideLoading();
                    if (result.rslt == 'success') {
                        checkRsFunc(result);
                    } else {
                        control.showPopup(result.errorMsg, 2000);
                    }
                }
                var failFunc = function(result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.getAuthorizationComfirmInfo({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }
            return {
                checkIdentity:checkIdentity,
                checkAuthorization:checkAuthorization,
                startIdentityAuthenticationAction:startIdentityAuthenticationAction,
                startLiveDetection:startLiveDetection,
                applyAuthorize:applyAuthorize,
                getAuthorizationComfirmInfo:getAuthorizationComfirmInfo,
            };
        }]);
})();
